#Include "tlist.bi"

#Include "init.bi"

#Include "images.bi"

#Include "filedlg.bi"

#Include "file.bi"

#Include "autocomplect.bi"

#Include "callbacks.bi"

#Include "menu.bi"

#Include "toolbar.bi"

#Include "statusbar.bi"

#Include "winoutput.bi"

#Include "multitext.bi"

#Include "tabs.bi"

#Include "encoding.bi"

#Include "goto.bi"

#Include "tabs_spaces.bi"

#Include "convert_case.bi"

#Include "comments.bi"

#Include "indent.bi"

#Include "marker.bi"

#Include "timer.bi"

#Include "find_replace.bi"

#Include "options_dialog.bi"

#Include "fontdialog.bi"

#include "messagedialog.bi"

#include "widgetvisibility.bi"

#Include "config.bi"

#Include "compile.bi"

#Include "hotkeys.bi"

#Include "help.bi"

#Include "misc.bi"


Sub main()

	ChDir(ExePath)
	
	init_IUP_proc()

	Load_Imades_Proc()
	
	load_keywords_proc()

	create_main_menu_proc()

	TGlobalVariables->toolbar = create_toolbar_proc()

	TGlobalVariables->statusbar = Create_statusBar_proc()

	TGlobalVariables->buildbox = Create_build_info_BuildBox_proc()

	TGlobalVariables->tabs = Create_Tabs_proc()

	TGlobalVariables->split = IupSplit(TGlobalVariables->tabs , TGlobalVariables->buildbox)

	IupSetAttribute(TGlobalVariables->split, "ORIENTATION", "HORIZONTAL")

	IupSetAttribute(TGlobalVariables->split, "VALUE", IupConfigGetVariableStr(TGlobalVariables->hConfig,"DialogSize","splitsize"))

	TGlobalVariables->dlg = IupDialog(IupVBox(TGlobalVariables->toolbar , TGlobalVariables->split, TGlobalVariables->statusbar ,NULL))

	IupSetAttribute(TGlobalVariables->dlg, "TITLE", "IUP_FB_Editor")

	IupSetAttribute(TGlobalVariables->dlg, "MENU", "MainMenu")

	IupSetAttribute(TGlobalVariables->dlg, "RASTERSIZE", IupConfigGetVariableStr(TGlobalVariables->hConfig,"DialogSize","dlgsize"))
	
	If IupGetInt(TGlobalVariables->dlg, "RASTERSIZE") >= IupGetInt(NULL, "FULLSIZE") Then
	   
      IupSetAttribute(TGlobalVariables->dlg, "PLACEMENT", "MAXIMIZED")
      
   EndIf
	
	IupSetAttribute(TGlobalVariables->dlg, "SHRINK", "YES")
	
	IupSetCallback(TGlobalVariables->dlg, "DROPFILES_CB", Cast(Any Ptr, @dropfiles_callback))
	
	IupSetCallback(TGlobalVariables->dlg, "CLOSE_CB", Cast(Any Ptr, @close_dialog_callback))
	
	IupSetCallback(TGlobalVariables->dlg, "K_ANY", Cast(Any Ptr, @k_any_dialog_callback))
	
	set_visual_params_statusbar_proc(0)
	
	set_visual_params_build_info_proc(0)
	
	init_timer_proc()
	
	IupShow(TGlobalVariables->dlg)
	
	#Ifdef __FB_WIN32__
	
	Var icon=LoadIcon(GetModuleHandle(0),MAKEINTRESOURCE(100))
	
	SendMessage(Cast(HWND,IupGetAttribute(TGlobalVariables->dlg,"HWND")),WM_SETICON,ICON_BIG,Cast(Lparam,icon))
	
	SendMessage(Cast(HWND,IupGetAttribute(TGlobalVariables->dlg,"HWND")),WM_SETICON,ICON_SMALL,Cast(Lparam,icon))
	
	#EndIf

	For i As Long  = 1 To 100
		
		Dim As ZString*2256 szFileName = Command(i)
		
		If Len(szFileName)>0 Then
			
			open_file_proc(szFileName)
			
		Else
			
			Exit For
			
		EndIf
		
	Next
	
	gtk_window_set_icon_from_file(GTK_WINDOW(IupGetAttribute(TGlobalVariables->dlg, "WID")), (exepath & "/media/res.png"), NULL)
	
	#Ifdef __FB_WIN32__
	#else
	InitHotKeyAccel()
	#endif

	IupMainLoop()

	IupClose()

End Sub

main()

