' Retrieve the path for a single file
Function dlg_open_proc (pszTitle As ZString Ptr , pszFilter As ZString Ptr ) As String
	
	Dim As Ihandle Ptr dlg = IupFileDlg()
	
	IupSetAttribute(dlg, "DIALOGTYPE", "OPEN")
	
	IupSetAttribute(dlg, "TITLE", pszTitle)
	
	IupSetAttributes(dlg, pszFilter)

	IupPopup(dlg, IUP_CURRENT, IUP_CURRENT)	
	
	if (IupGetInt(dlg, "STATUS")) <> CInt(-1) Then
		
		Function = *IupGetAttribute(dlg, "VALUE")
		
	EndIf
	
	IupDestroy(dlg)
	
End Function

' Retrieve the path for a dir
Function dlg_opendir_proc () As String
	
	Dim As Ihandle Ptr dlg = IupFileDlg()
	
	IupSetAttribute(dlg, "DIALOGTYPE", "DIR")

	IupPopup(dlg, IUP_CURRENT, IUP_CURRENT)	
	
	if (IupGetInt(dlg, "STATUS")) <> CInt(-1) Then
		
		Function = *IupGetAttribute(dlg, "VALUE")
		
	EndIf
	
	IupDestroy(dlg)
	
End Function

' get paths for single and multiple file selection
Function open_dialog_files_proc() As ZString Ptr

	Static As ZString*1000 szPath

	For i As Long  = 0 To 999

		szPath[i] = 0

	Next

	Dim As Ihandle Ptr dlg = IupFileDlg()

	IupSetAttribute(dlg, "DIALOGTYPE", "OPEN")

	IupSetAttribute(dlg, "TITLE", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgopenfile"))

	IupSetAttribute(dlg, "EXTFILTER" , "Freebasic files (bas)|*.bas|FreeBasic headers files (bi)|*.bi|All files|*.*|")

	IupSetAttribute(dlg, "MULTIPLEFILES", "YES")

	IupPopup(dlg, IUP_CURRENT, IUP_CURRENT)

	If IupGetInt(dlg, "STATUS") = 0 Then

		szPath = *IupGetAttribute(dlg, "VALUE")

		Function = @szPath

	End If

	IupDestroy(dlg)

End Function

' getting the path to save the file
Function save_dialog_proc() As ZString Ptr

	Static As ZString*1000 szPath

	For i As Long  = 0 To 999

		szPath[i] = 0

	Next

	Dim As Ihandle Ptr dlg = IupFileDlg()

	IupSetAttribute(dlg, "DIALOGTYPE", "SAVE")

	IupSetAttribute(dlg, "TITLE", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgsaveas"))

	IupSetAttribute(dlg, "EXTFILTER" , "Freebasic files (bas)|*.bas|FreeBasic headers files (bi)|*.bi|All files|*.*|")

	IupPopup(dlg, IUP_CURRENT, IUP_CURRENT)

	If IupGetInt(dlg, "STATUS") <> -1 Then

		szPath = *IupGetAttribute(dlg, "VALUE")
		
		If lcase(Right(szPath,3)) = "bas" OrElse lcase(Right(szPath,2)) = "bi" Then						
			
		Else
			
			If IupGetInt(dlg, "FILTERUSED") = 1 Then
				
				szPath &= ".bas"
				
			ElseIf IupGetInt(dlg, "FILTERUSED") = 2 Then
				
				szPath &= ".bi"
				
			EndIf		 
			
		EndIf	
		
		Function = @szPath

	End If

	IupDestroy(dlg)

End Function