Sub hotkeys_proc(iKey As Integer)
	
	
	Select Case iKey
		
		Case  K_F4
		
			item_close_callback(0)
		
		Case  K_cF4
		
			item_close_all_callback(0)
		
		Case  K_F3
		
			item_find_next_callback(0)
		
		Case  K_cF3 
		
			item_find_prev_callback(0)
			#Ifdef __FB_WIN32__		
		Case  K_cN, &h200006D4, &h200006F4
		
			item_new_callback(0)
		
		Case  K_cO, &h200006DD, &h200006FD
		
			item_open_callback(0)
		
		Case  K_cS, &h200006D9, &h200006F9
		
			item_save_callback(0)
		
		Case  (K_cS Or &h40000000) , (&h200006D9 Or &h40000000) , (&h200006F9 Or &h40000000) 
		
			item_save_as_callback(0)
		
		Case  (K_cS Or &h10000000), (&h200006D9 Or &h10000000) , (&h200006F9 Or &h10000000)
		
			item_save_all_callback(0)
		
		Case  K_cF, &h200006C1, &h200006E1
		
			item_find_callback(0)
		
		Case  K_cR_, &h200006CB, &h200006EB
		
			item_replace_callback(0)
		
		Case  K_cG, &h200006D0, &h200006F0
		
			item_goto_callback(0)
		
		Case  K_cL, &h200006C4, &h200006E4
		
			item_convert_lower_case_callback(0)
		
		Case  K_cU, &h200006C7, &h200006E7
		
			item_convert_upper_case_callback(0)			
			#endif		
		Case  K_sF8
		
			item_bookmarks_toggle_callback(0)
		
		Case  K_F8
		
			item_bookmarks_next_callback(0)
		
		Case  K_cF8
		
			item_bookmarks_prev_callback(0)
		
		Case  (K_cF8 Or &h10000000)
		
			item_bookmarks_clear_all_callback(0)
		
		Case  (K_cF5 Or &h10000000)
		
			item_compile_callback(0)
		
		Case  K_sF5
		
			item_run_callback(0)
		
		Case  K_cF5
		
			item_compile_and_run_callback(0)
		
		Case  K_F5
		
			item_quick_run_callback(0)
		
		Case  K_F9
		
			item_comment_callback(0)
		
		Case  K_cF9  
		
			item_uncomment_callback(0)
		
		Case  K_cTAB  
		
			next_tab_proc()
		
			#Ifdef __FB_WIN32__
		Case K_cTAB or &h10000000 'ctrl+shift+tab
			#else
		Case 805371424 'ctrl+shift+tab . in the Linux bug????
			#endif 
			prev_tab_proc()
		
		Case K_F1
		
			processing_f1_proc()
		
		Case (K_cF12 Or &h10000000)
		
			autoindent_proc()
		
			'Case  &h200006D1 'CTRL+Z in Russian  
		'
			'item_undo_callback(0)
		'
			'Case  &h20000059 'CTRL+Y in Russian
		'
			'item_redo_callback(0)
		'
			'Case  &h200006DE 'CTRL+X in Russian  
		'
			'item_cut_callback(0)
		'
			'Case  &h200006D3 'CTRL+C in Russian  
		'
			'item_copy_callback(0)	
		'
			'Case  &h200006CD 'CTRL+V in Russian  
		'
			'item_paste_callback(0)						
		
	End Select
	
End Sub

#Ifdef __FB_WIN32__
#else
sub InitHotKeyAccel()
	
	dim as any ptr win  = IupGetAttribute(TGlobalVariables->dlg, "WID")
	
	dim as any ptr accel_group = gtk_accel_group_new()
	
	gtk_window_add_accel_group(GTK_WINDOW(win), accel_group)
	
	' add keys
	
	dim as GClosure ptr closure = g_cclosure_new(cast(any ptr,@item_new_callback), 0 , 0)
	
	gtk_accel_group_connect(accel_group, &h04e , GDK_CONTROL_MASK, 0, closure)		'CTRL+N	
	
	closure = g_cclosure_new(cast(any ptr,@item_open_callback), 0 , 0)
	
	gtk_accel_group_connect(accel_group, &h04f , GDK_CONTROL_MASK, 0, closure)		'CTRL+O	
	
	closure = g_cclosure_new(cast(any ptr,@item_save_callback), 0 , 0)
	
	gtk_accel_group_connect(accel_group, &h053 , GDK_CONTROL_MASK, 0, closure)		'CTRL+S	
	
	closure = g_cclosure_new(cast(any ptr,@item_save_as_callback), 0 , 0)			
	
	gtk_accel_group_connect(accel_group, &h053 , GDK_CONTROL_MASK+GDK_MOD1_MASK, 0, closure)		'CTRL+ALT+S	
	
	closure = g_cclosure_new(cast(any ptr,@item_save_all_callback), 0 , 0)			
	
	gtk_accel_group_connect(accel_group, &h053 , GDK_CONTROL_MASK+GDK_SHIFT_MASK, 0, closure)		'CTRL+SHIFT+S	
	
	closure = g_cclosure_new(cast(any ptr,@item_find_callback), 0 , 0)			
	
	gtk_accel_group_connect(accel_group, &h046 , GDK_CONTROL_MASK, 0, closure)		'CTRL+F		
	
	closure = g_cclosure_new(cast(any ptr,@item_replace_callback), 0 , 0)			
	
	gtk_accel_group_connect(accel_group, &h052 , GDK_CONTROL_MASK, 0, closure)		'CTRL+R	
	
	closure = g_cclosure_new(cast(any ptr,@item_goto_callback), 0 , 0)			
	
	gtk_accel_group_connect(accel_group, &h047 , GDK_CONTROL_MASK, 0, closure)		'CTRL+G	
	
	closure = g_cclosure_new(cast(any ptr,@item_convert_lower_case_callback), 0 , 0)			
	
	gtk_accel_group_connect(accel_group, &h04c , GDK_CONTROL_MASK, 0, closure)		'CTRL+L	
	
	closure = g_cclosure_new(cast(any ptr,@item_convert_upper_case_callback), 0 , 0)			
	
	gtk_accel_group_connect(accel_group, &h055 , GDK_CONTROL_MASK, 0, closure)		'CTRL+U
	
	closure = g_cclosure_new(cast(any ptr,@item_undo_callback), 0 , 0)			
	
	gtk_accel_group_connect(accel_group, &h05a , GDK_CONTROL_MASK, 0, closure)		'CTRL+Z	
	
	closure = g_cclosure_new(cast(any ptr,@item_redo_callback), 0 , 0)			
	
	gtk_accel_group_connect(accel_group, &h059 , GDK_CONTROL_MASK, 0, closure)		'CTRL+Y	
	
	closure = g_cclosure_new(cast(any ptr,@item_cut_callback), 0 , 0)			
	
	gtk_accel_group_connect(accel_group, &h058 , GDK_CONTROL_MASK, 0, closure)		'CTRL+X	
	
	closure = g_cclosure_new(cast(any ptr,@item_copy_callback), 0 , 0)			
	
	gtk_accel_group_connect(accel_group, &h043 , GDK_CONTROL_MASK, 0, closure)		'CTRL+C	
	
	closure = g_cclosure_new(cast(any ptr,@item_paste_callback), 0 , 0)			
	
	gtk_accel_group_connect(accel_group, &h056 , GDK_CONTROL_MASK, 0, closure)		'CTRL+V	
	
	closure = g_cclosure_new(cast(any ptr,@item_select_all_callback), 0 , 0)			
	
	gtk_accel_group_connect(accel_group, &h041 , GDK_CONTROL_MASK, 0, closure)		'CTRL+A								
	
End Sub
#endif

