
Sub set_checkbox_style_font_group(ih As Ihandle Ptr , iState As Integer)
   
   Dim As ZString*10 szBoldOption , szItalicOption
   
   Dim As String szTheme
   
   szTheme = *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , "VALUE")
   
	szBoldOption = *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme"),"bold" & szTheme)
	
	If Len(szBoldOption) < 9 Then szBoldOption = "000000000"
	
	szItalicOption = *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme"),"italic" & szTheme)	   
   
   If Len(szItalicOption) < 9 Then szItalicOption = "000000000"
   
   Select Case ih
      
      Case IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_str")
         
         szBoldOption[0] = Asc(Str(iState))
         
      Case IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_str") 
         
         szItalicOption[0] = Asc(Str(iState))
         
      Case IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_comm")
         
         szBoldOption[1] = Asc(Str(iState))
         
      Case IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_comm") 
         
         szItalicOption[1] = Asc(Str(iState))
         
      Case IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_numb")
         
         szBoldOption[2] = Asc(Str(iState))
         
      Case IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_numb") 
         
         szItalicOption[2] = Asc(Str(iState))
         
      Case IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_oper")
         
         szBoldOption[3] = Asc(Str(iState))
         
      Case IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_oper") 
         
         szItalicOption[3] = Asc(Str(iState))
         
      Case IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_iden")
         
         szBoldOption[4] = Asc(Str(iState))
         
      Case IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_iden") 
         
         szItalicOption[4] = Asc(Str(iState))
         
      Case IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_kw0")
         
         szBoldOption[5] = Asc(Str(iState))
         
      Case IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_kw0") 
         
         szItalicOption[5] = Asc(Str(iState))
         
      Case IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_kw1")
         
         szBoldOption[6] = Asc(Str(iState))
         
      Case IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_kw1")
         
         szItalicOption[6] = Asc(Str(iState))
         
      Case IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_kw2")
         
         szBoldOption[7] = Asc(Str(iState))
         
      Case IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_kw2") 
         
         szItalicOption[7] = Asc(Str(iState))
         
      Case IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_kw3")
         
         szBoldOption[8] = Asc(Str(iState))
         
      Case IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_kw3") 
         
         szItalicOption[8] = Asc(Str(iState))
      
   End Select
   
	IupSetStrAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , "bold" & szTheme , szBoldOption)
	
	IupSetStrAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , "italic" & szTheme , szItalicOption)   
   
End Sub

' Convert colors in string format (from: 255 255 255 , in: #FFFFFF)
Function convert_color_in_hex_proc(sColor As String) As String
	
	Dim As Byte r,g,b
	
	Dim As Integer iPos , iPos1
	
	iPos = InStr(sColor , " ")
	
	r = Val(Mid(sColor, 1, iPos))
	
	iPos = InStr(iPos , sColor , " ")
	
	iPos1 = InStr(iPos+1 , sColor , " ")
	
	g = Val(Mid(sColor, iPos+1, iPos1-(iPos+1)))
	
	b = Val(Mid(sColor, iPos1+1))
	
	Return "#" & Hex(r,2) & Hex(g,2) & Hex(b,2)
	
End Function

' System Dialog "COLOR"
Function get_color_dlg_proc(sPrevColor As String) As String
	
	Dim As Ihandle Ptr dlg = IupColorDlg()
	
	IupSetAttribute(dlg, "VALUE", sPrevColor)
	
	IupSetAttribute(dlg, "SHOWHEX", "YES")
	
	IupSetAttribute(dlg, "SHOWCOLORTABLE", "YES")
	
	IupPopup(dlg, IUP_CURRENT, IUP_CURRENT)
	
	if IupGetInt(dlg, "STATUS") = CInt(1) Then
	
	  Function = convert_color_in_hex_proc(*IupGetAttribute(dlg, "VALUE"))
	  
	EndIf
	
	IupDestroy(dlg)
	
End Function

' get theme ; get colors from theme 
Sub get_theme_color(iParam As Byte = 0)
	
	Dim As ZString*2 szTheme 
	
	Dim As ZString*260 szColTheme
	
	Dim As ZString*4 szAlpha 	
	
	Dim As ZString*10 szBoldOption
	
	Dim As ZString*10 szItalicOption
	
	If iParam = 0 Then
		
		szTheme = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme","0")
		
		szColTheme = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme",szTheme & "c")		
		
		szAlpha = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme",szTheme & "a")
		
		szBoldOption = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme",szTheme & "bold")
		
		szItalicOption = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme",szTheme & "italic")
		
	Else	
		
		szTheme = *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , "VALUE")
		
		szColTheme = *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme"),"b" & szTheme)	
		
		szAlpha = *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme"),"ba" & szTheme)
		
		szBoldOption = *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme"),"bold" & szTheme)
		
		szItalicOption = *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme"),"italic" & szTheme)			
		
	EndIf
	
	
	If Len(szColTheme) >= 255 Then
	
		For i As Long = 1 To 8
			
			TGlobalVariables->szColorbtn(i) = Mid( szColTheme , (i-1)*16+1 , 7)
			
			TGlobalVariables->szColorbtn(i+8) = Mid( szColTheme , (i-1)*16+9 , 7)
			
			TGlobalVariables->szColorbtn(i+16) =  Mid( szColTheme , (i-1)*16+129 , 7)
			
			TGlobalVariables->szColorbtn(i+24) =  Mid( szColTheme , (i-1)*16+137 , 7)
			
			If TGlobalVariables->hOptions Then
			
				Dim As Ihandle Ptr btn = IupGetDialogChild(TGlobalVariables->hOptions, "B1_" & i)
				
				IupSetAttribute(btn, "BGCOLOR" , TGlobalVariables->szColorbtn(i))
				
				btn = IupGetDialogChild(TGlobalVariables->hOptions, "B2_" & i)
				
				IupSetAttribute(btn, "BGCOLOR" , TGlobalVariables->szColorbtn(i+8))
				
				btn = IupGetDialogChild(TGlobalVariables->hOptions, "B3_" & i)
				
				IupSetAttribute(btn, "BGCOLOR" , TGlobalVariables->szColorbtn(i+16))	
				
				btn = IupGetDialogChild(TGlobalVariables->hOptions, "B4_" & i)
				
				IupSetAttribute(btn, "BGCOLOR" , TGlobalVariables->szColorbtn(i+24))		
			
			EndIf				
			
		Next
		
		TGlobalVariables->szAlphaCaret = szAlpha
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "updownalpha"), "VALUE" , TGlobalVariables->szAlphaCaret)	
		
		If Mid(szBoldOption,1,1) = "1" Then
		   
		   IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_str"), "VALUE", "ON")
		   
		Else
		   
		   IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_str"), "VALUE", "OFF")
		   
		EndIf
		
		If Mid(szItalicOption,1,1) = "1" Then
		   
		   IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_str"), "VALUE", "ON")
		   
		Else
		   
		   IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_str"), "VALUE", "OFF")
		   
		EndIf	
		
		If Mid(szBoldOption,2,1) = "1" Then
		   
		   IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_comm"), "VALUE", "ON")
		   
		Else
		   
		   IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_comm"), "VALUE", "OFF")
		   
		EndIf
		
		If Mid(szItalicOption,2,1) = "1" Then
		   
		   IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_comm"), "VALUE", "ON")
		   
		Else
		   
		   IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_comm"), "VALUE", "OFF")
		   
		EndIf			

		If Mid(szBoldOption,3,1) = "1" Then
		   
		   IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_numb"), "VALUE", "ON")
		   
		Else
		   
		   IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_numb"), "VALUE", "OFF")
		   
		EndIf
		
		If Mid(szItalicOption,3,1) = "1" Then
		   
		   IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_numb"), "VALUE", "ON")
		   
		Else
		   
		   IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_numb"), "VALUE", "OFF")
		   
		EndIf	

		If Mid(szBoldOption,4,1) = "1" Then
		   
		   IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_oper"), "VALUE", "ON")
		   
		Else
		   
		   IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_oper"), "VALUE", "OFF")
		   
		EndIf
		
		If Mid(szItalicOption,4,1) = "1" Then
		   
		   IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_oper"), "VALUE", "ON")
		   
		Else
		   
		   IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_oper"), "VALUE", "OFF")
		   
		EndIf	
		
		If Mid(szBoldOption,5,1) = "1" Then
		   
		   IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_iden"), "VALUE", "ON")
		   
		Else
		   
		   IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_iden"), "VALUE", "OFF")
		   
		EndIf
		
		If Mid(szItalicOption,5,1) = "1" Then
		   
		   IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_iden"), "VALUE", "ON")
		   
		Else
		   
		   IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_iden"), "VALUE", "OFF")
		   
		EndIf			
		
		If Mid(szBoldOption,6,1) = "1" Then
		   
		   IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_kw0"), "VALUE", "ON")
		   
		Else
		   
		   IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_kw0"), "VALUE", "OFF")
		   
		EndIf
		
		If Mid(szItalicOption,6,1) = "1" Then
		   
		   IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_kw0"), "VALUE", "ON")
		   
		Else
		   
		   IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_kw0"), "VALUE", "OFF")
		   
		EndIf	
		
		If Mid(szBoldOption,7,1) = "1" Then
		   
		   IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_kw1"), "VALUE", "ON")
		   
		Else
		   
		   IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_kw1"), "VALUE", "OFF")
		   
		EndIf
		
		If Mid(szItalicOption,7,1) = "1" Then
		   
		   IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_kw1"), "VALUE", "ON")
		   
		Else
		   
		   IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_kw1"), "VALUE", "OFF")
		   
		EndIf	
		
		If Mid(szBoldOption,8,1) = "1" Then
		   
		   IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_kw2"), "VALUE", "ON")
		   
		Else
		   
		   IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_kw2"), "VALUE", "OFF")
		   
		EndIf
		
		If Mid(szItalicOption,8,1) = "1" Then
		   
		   IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_kw2"), "VALUE", "ON")
		   
		Else
		   
		   IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_kw2"), "VALUE", "OFF")
		   
		EndIf	
		
		If Mid(szBoldOption,9,1) = "1" Then
		   
		   IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_kw3"), "VALUE", "ON")
		   
		Else
		   
		   IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_kw3"), "VALUE", "OFF")
		   
		EndIf
		
		If Mid(szItalicOption,9,1) = "1" Then
		   
		   IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_kw3"), "VALUE", "ON")
		   
		Else
		   
		   IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_kw3"), "VALUE", "OFF")
		   
		EndIf	
		
	EndIf
	
End Sub

' create tab "PATH" for dialog options "EDIT"
Function create_tab_path() As Ihandle Ptr
	
	'--------------------------- Path -------------------------------------
	Dim As Ihandle Ptr hBoxPath1, hBoxPath2, hBoxPath3, hBoxPath4 , hBoxPath5 , hBoxPath6 , vBoxPath, txtcompilierpath ,txtincludepath ,_
	 txtdebuggerpath , txthelppathFB , txtterminalpath, txtbrowserpath , lblcompilier , lblinclude , lbldebugger , lblhelpFB ,_
	 lblterminal , lblbrowser, btnselcompilier , btnselinclude ,btnseldebug , btnselhelpFB 
	
	
	lblcompilier = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionpathcompilier"))
	
	lblinclude = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionpathinclude"))
	
	lbldebugger = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionpathdebug"))
	
	lblhelpFB = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionpathhelpfb"))
	
	lblterminal = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionpathterminal"))
	
	lblbrowser = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionpathbrowser"))
	
	txtcompilierpath = IupText(0)
	
	IupSetAttribute(txtcompilierpath , "MINSIZE" , "300x20")
	
	IupSetAttribute(txtcompilierpath , "NAME" , "txtcomppath")
	
	IupSetAttribute(txtcompilierpath , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path","pathcompilier"))
	
	txtincludepath = IupText(0)
	
	IupSetAttribute(txtincludepath , "MINSIZE" , "300x20")
	
	IupSetAttribute(txtincludepath , "NAME" , "txtincludepath")
	
	IupSetAttribute(txtincludepath , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path","pathinclude"))	
	
	txtdebuggerpath = IupText(0)
	
	IupSetAttribute(txtdebuggerpath , "MINSIZE" , "300x20")
	
	IupSetAttribute(txtdebuggerpath , "NAME" , "txtdebugpath")
	
	IupSetAttribute(txtdebuggerpath , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path","pathdebugger"))
	
	txthelppathFB = IupText(0)
	
	IupSetAttribute(txthelppathFB , "MINSIZE" , "300x20")
	
	IupSetAttribute(txthelppathFB , "NAME" , "txthelpfbpath")
	
	IupSetAttribute(txthelppathFB, "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path","pathhelpfb"))
	
	txtterminalpath = IupText(0)
	
	IupSetAttribute(txtterminalpath , "MINSIZE" , "300x20")
	
	IupSetAttribute(txtterminalpath , "NAME" , "txtterminal")	
	
	IupSetAttribute(txtterminalpath, "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path","pathterminal"))
	
	txtbrowserpath = IupText(0) 
	
	IupSetAttribute(txtbrowserpath , "MINSIZE" , "300x20")
	
	IupSetAttribute(txtbrowserpath , "NAME" , "txtbrowser")	
	
	IupSetAttribute(txtbrowserpath, "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path","pathbrowser"))	
	
	btnselcompilier = IupButton("...", 0)
	
	IupSetAttribute(btnselcompilier , "MAXSIZE" , "x20")
	
	IupSetCallback(btnselcompilier , "ACTION" , Cast(Any Ptr, @option_btn_path_compilier_callback()))
	
	btnselinclude = IupButton("...", 0)
	
	IupSetAttribute(btnselinclude , "MAXSIZE" , "x20")
	
	IupSetCallback(btnselinclude , "ACTION" , Cast(Any Ptr, @option_btn_path_include_callback()))	
	
	btnseldebug = IupButton("...", 0)
	
	IupSetAttribute(btnseldebug , "MAXSIZE" , "x20")
	
	IupSetCallback(btnseldebug , "ACTION" , Cast(Any Ptr, @option_btn_path_debugger_callback()))
	
	btnselhelpFB = IupButton("...", 0)
	
	IupSetAttribute(btnselhelpFB , "MAXSIZE" , "x20")
	
	IupSetCallback(btnselhelpFB , "ACTION" , Cast(Any Ptr, @option_btn_path_helpfb_callback()))
	
	hBoxPath1 = IupHbox(txtcompilierpath , btnselcompilier, IupFill(),0)
	
	hBoxPath2 = IupHbox(txtdebuggerpath , btnseldebug, 0)
	
	hBoxPath3 = IupHbox(txthelppathFB , btnselhelpFB, 0)
	
	hBoxPath4 = IupHbox(txtterminalpath ,  0)
	
	hBoxPath5 = IupHbox(txtbrowserpath ,  0)
	
	hBoxPath6 = IupHbox(txtincludepath , btnselinclude, 0)
	
	vBoxPath = IupVBox(lblcompilier , hBoxPath1 , lblinclude , hBoxPath6 , lbldebugger , hBoxPath2 , lblhelpFB ,_
	 hBoxPath3 , lblterminal ,hBoxPath4, lblbrowser , hBoxPath5, IupFill(), 0)
	
	IupSetAttribute(vBoxPath, "NMARGIN", "85x60")
	
	Return vBoxPath	
	
End Function

' create tab "COLOR" for dialog options "EDIT"
Function create_tab_color() As Ihandle Ptr
	
	'----------------------- Theme --------------------
	
	Dim As Ihandle Ptr vBoxColor , fr_theme , fr_color , th_hbox ,  th_combo , th_txt, th_btn_ok ,_
	updown, col_hboxup, col_hbox , col_vbox1 , col_vbox2 , col_vbox3 , col_vbox4 , col_vbox5 , col_vbox6 ,_
   col_vboxcheck1,col_vboxcheck2,col_vboxcheck3,col_vboxcheck4,_
	lbl1 , lbl2 , lbl3 , lbl4 , lbl5 , lbl6 ,lbl7 , lbl8 , lbl9 ,lbl10 , lbl11 , lbl12 ,lbl13 , lbl14 ,_
	lbl15 , lbl16  , lblup, btn_dim1(8) , btn_dim2(8) , btn_dim3(8) , btn_dim4(8), checkstringB,checkstringI,_
	checkcommentB,checkcommentI, checknumbersB, checknumbersI ,  checkidentifiersB, checkidentifiersI,_
	checkoperB, checkoperI, checkkw0B,checkkw0I,checkkw1B,checkkw1I,checkkw2B,checkkw2I,checkkw3B,checkkw3I
	
	Static As ZString*6 szbtn_str_dim1(8) , szbtn_str_dim2(8) , szbtn_str_dim3(8) , szbtn_str_dim4(8)
	
	th_combo = IupList(0)

	IupSetAttribute(th_combo , "DROPDOWN", "YES")
	
	IupSetAttribute(th_combo , "MINSIZE", "170x")	
	
	For i As Long = 1 To 100
		
		If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme", i & "n") <> "" Then
			
			IupSetAttribute(th_combo , Str(i) , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme", i & "n"))
			
			IupSetStrAttribute(th_combo , "b" & Str(i) , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme", i & "c"))
			
			IupSetStrAttribute(th_combo , "ba" & Str(i) , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme", i & "a"))
			
			IupSetStrAttribute(th_combo , "bold" & Str(i) , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme", i & "bold"))
			
			IupSetStrAttribute(th_combo , "italic" & Str(i) , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme", i & "italic"))
			
		Else
			
			Exit For
			
		EndIf
	
	Next
	
	IupSetAttribute(th_combo , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme", "0"))
	
	IupSetCallback(th_combo , "ACTION" , Cast(Any Ptr , @options_combo_select_theme_callback()))
	
	IupSetAttribute(th_combo , "NAME" , "combotheme")
	
	th_txt = IupText("")
	
	IupSetAttribute(th_txt , "MINSIZE", "200x")
	
	IupSetAttribute(th_txt , "NAME" , "txtnewtheme")
	
	th_btn_ok = IupButton(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionthemeadd"),0)
	
	IupSetAttribute(th_btn_ok , "NAME" , "btnoknewtheme")
	
	IupSetCallback(th_btn_ok , "ACTION" , Cast(Any Ptr , @options_add_new_theme_callback()))
	
	th_hbox = IupHbox(th_combo , th_txt , IupFill() , th_btn_ok ,  0)
	
	IupSetAttribute(th_hbox , "GAP", "5")
	
	IupSetAttribute(th_hbox , "NCMARGIN", "3x7")
	
	fr_theme = IupFrame(th_hbox)
	
	IupSetAttribute(fr_theme , "TITLE", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optiontheme"))
	
	lbl1 = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optioncedit"))
	
	IupSetAttribute(lbl1 , "MAXSIZE" , "x20")
	
	IupSetAttribute(lbl1 , "MINSIZE" , "x20")
	
	lbl2 = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optioncwinout"))
	
	IupSetAttribute(lbl2 , "MAXSIZE" , "x20")
	
	IupSetAttribute(lbl2 , "MINSIZE" , "x20")
	
	lbl3 = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optioncpanelnumbers"))
	
	IupSetAttribute(lbl3 , "MAXSIZE" , "x20")
	
	IupSetAttribute(lbl3 , "MINSIZE" , "x20")
	
	lbl4 = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optioncmarker"))
	
	IupSetAttribute(lbl4 , "MAXSIZE" , "x20")
	
	IupSetAttribute(lbl4 , "MINSIZE" , "x20")
	
	lbl5 = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optioncpanelcollapse"))
	
	IupSetAttribute(lbl5 , "MAXSIZE" , "x20")
	
	IupSetAttribute(lbl5 , "MINSIZE" , "x20")
	
	lbl6 = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optioncseltext"))
	
	IupSetAttribute(lbl6 , "MAXSIZE" , "x20")
	
	IupSetAttribute(lbl6 , "MINSIZE" , "x20")
	
	lbl7 = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionccaret"))
	
	IupSetAttribute(lbl7 , "MAXSIZE" , "x20")
	
	IupSetAttribute(lbl7 , "MINSIZE" , "x20")
	
	lbl8 = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optioncstrings"))
	
	IupSetAttribute(lbl8 , "MAXSIZE" , "x20")
	
	IupSetAttribute(lbl8 , "MINSIZE" , "x20")
	
	checkstringB = IupToggle("B",0)
	
	IupSetAttribute(checkstringB , "NAME" , "ch_b_str")
	
	checkstringI = IupToggle("I",0)
	
	IupSetAttribute(checkstringI , "NAME" , "ch_i_str")
	
	IupSetCallback(checkstringB , "ACTION" , Cast(Any Ptr, @action_checkbox_style_group_callback))
	
	IupSetCallback(checkstringI , "ACTION" , Cast(Any Ptr, @action_checkbox_style_group_callback))
	
	lbl9 = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionccomments"))
	
	IupSetAttribute(lbl9 , "MAXSIZE" , "x20")
	
	IupSetAttribute(lbl9 , "MINSIZE" , "x20")
	
	checkcommentB = IupToggle("B",0)
	
	IupSetAttribute(checkcommentB , "NAME" , "ch_b_comm")
	
	checkcommentI = IupToggle("I",0)
	
	IupSetAttribute(checkcommentI , "NAME" , "ch_i_comm")	
	
	IupSetCallback(checkcommentB , "ACTION" , Cast(Any Ptr, @action_checkbox_style_group_callback))
	
	IupSetCallback(checkcommentI , "ACTION" , Cast(Any Ptr, @action_checkbox_style_group_callback))	
	
	lbl10 = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optioncnumbers"))
	
	IupSetAttribute(lbl10 , "MAXSIZE" , "x20")
	
	IupSetAttribute(lbl10 , "MINSIZE" , "x20")
	
	checknumbersB = IupToggle("B",0)
	
	IupSetAttribute(checknumbersB , "NAME" , "ch_b_numb")
	
	checknumbersI = IupToggle("I",0)
	
	IupSetAttribute(checknumbersI , "NAME" , "ch_i_numb")			

	IupSetCallback(checknumbersB , "ACTION" , Cast(Any Ptr, @action_checkbox_style_group_callback))
	
	IupSetCallback(checknumbersI , "ACTION" , Cast(Any Ptr, @action_checkbox_style_group_callback))
	
	lbl11 = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optioncoperator"))
	
	IupSetAttribute(lbl11 , "MAXSIZE" , "x20")
	
	IupSetAttribute(lbl11 , "MINSIZE" , "x20")
	
	checkoperB = IupToggle("B",0)
	
	IupSetAttribute(checkoperB , "NAME" , "ch_b_oper")
	
	checkoperI = IupToggle("I",0)
	
	IupSetAttribute(checkoperI , "NAME" , "ch_i_oper")	
	
	IupSetCallback(checkoperB , "ACTION" , Cast(Any Ptr, @action_checkbox_style_group_callback))
	
	IupSetCallback(checkoperI , "ACTION" , Cast(Any Ptr, @action_checkbox_style_group_callback))	
	
	lbl12 = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optioncidentifiers"))	
	
	IupSetAttribute(lbl12 , "MAXSIZE" , "x20")
	
	IupSetAttribute(lbl12 , "MINSIZE" , "x20")

	checkidentifiersB = IupToggle("B",0)
	
	IupSetAttribute(checkidentifiersB , "NAME" , "ch_b_iden")
	
	checkidentifiersI = IupToggle("I",0)
	
	IupSetAttribute(checkidentifiersI , "NAME" , "ch_i_iden")
	
	IupSetCallback(checkidentifiersB , "ACTION" , Cast(Any Ptr, @action_checkbox_style_group_callback))
	
	IupSetCallback(checkidentifiersI , "ACTION" , Cast(Any Ptr, @action_checkbox_style_group_callback))					
	
	lbl13 = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionckeywords0"))
	
	IupSetAttribute(lbl13 , "MAXSIZE" , "x20")
	
	IupSetAttribute(lbl13 , "MINSIZE" , "x20")

	checkkw0B = IupToggle("B",0)
	
	IupSetAttribute(checkkw0B , "NAME" , "ch_b_kw0")
	
	checkkw0I = IupToggle("I",0)
	
	IupSetAttribute(checkkw0I , "NAME" , "ch_i_kw0")	
	
	IupSetCallback(checkkw0B , "ACTION" , Cast(Any Ptr, @action_checkbox_style_group_callback))
	
	IupSetCallback(checkkw0I , "ACTION" , Cast(Any Ptr, @action_checkbox_style_group_callback))			
	
	lbl14 = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionckeywords1"))
	
	IupSetAttribute(lbl14 , "MAXSIZE" , "x20")
	
	IupSetAttribute(lbl14 , "MINSIZE" , "x20")
	
	checkkw1B = IupToggle("B",0)
	
	IupSetAttribute(checkkw1B , "NAME" , "ch_b_kw1")
	
	checkkw1I = IupToggle("I",0)
	
	IupSetAttribute(checkkw1I , "NAME" , "ch_i_kw1")	

	IupSetCallback(checkkw1B , "ACTION" , Cast(Any Ptr, @action_checkbox_style_group_callback))
	
	IupSetCallback(checkkw1I , "ACTION" , Cast(Any Ptr, @action_checkbox_style_group_callback))
	
	lbl15 = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionckeywords2"))
	
	IupSetAttribute(lbl15 , "MAXSIZE" , "x20")
	
	IupSetAttribute(lbl15 , "MINSIZE" , "x20")
	
	checkkw2B = IupToggle("B",0)
	
	IupSetAttribute(checkkw2B , "NAME" , "ch_b_kw2")
	
	checkkw2I = IupToggle("I",0)
	
	IupSetAttribute(checkkw2I , "NAME" , "ch_i_kw2")
	
	IupSetCallback(checkkw2B , "ACTION" , Cast(Any Ptr, @action_checkbox_style_group_callback))
	
	IupSetCallback(checkkw2I , "ACTION" , Cast(Any Ptr, @action_checkbox_style_group_callback))	
				
	lbl16 = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionckeywords3"))
	
	IupSetAttribute(lbl16 , "MAXSIZE" , "x20")
	
	IupSetAttribute(lbl16 , "MINSIZE" , "x20")
	
	checkkw3B = IupToggle("B",0)
	
	IupSetAttribute(checkkw3B , "NAME" , "ch_b_kw3")
	
	checkkw3I = IupToggle("I",0)
	
	IupSetAttribute(checkkw3I , "NAME" , "ch_i_kw3")
	
	IupSetCallback(checkkw3B , "ACTION" , Cast(Any Ptr, @action_checkbox_style_group_callback))
	
	IupSetCallback(checkkw3I , "ACTION" , Cast(Any Ptr, @action_checkbox_style_group_callback))		
	
	col_vbox1 = IupVbox(lbl1 , lbl2 , lbl3 , lbl4 , lbl5 , lbl6 , lbl7 , lbl8 , 0)
	
	IupSetAttribute(col_vbox1 , "GAP", "5")
	
	col_vbox4 = IupVbox(lbl9 , lbl10 , lbl11 , lbl12 , lbl13 , lbl14 , lbl15 , lbl16 , 0)
	
	IupSetAttribute(col_vbox4 , "GAP", "5")
	
	col_vboxcheck1 = IupVbox(IupFill() ,IupFill() ,IupFill() ,IupFill() ,IupFill() ,IupFill() ,IupFill() , checkstringB , 0)
	
	col_vboxcheck2 = IupVbox(IupFill() , IupFill() ,IupFill() ,IupFill() ,IupFill() ,IupFill() ,IupFill() ,checkstringI , 0)
	
	col_vboxcheck3 = IupVbox(checkcommentB ,checknumbersB, checkoperB, checkidentifiersB , checkkw0B,checkkw1B ,checkkw2B,checkkw3B,  0)
	
	col_vboxcheck4 = IupVbox(checkcommentI ,checknumbersI, checkoperI ,checkidentifiersI ,checkkw0I,checkkw1I ,checkkw2I,checkkw3I,  0)
	
	#Ifdef __FB_WIN32__
	
	IupSetAttribute(col_vboxcheck3 , "GAP", "9")
	
	IupSetAttribute(col_vboxcheck4 , "GAP", "9")
	
	IupSetAttribute(col_vboxcheck1 , "NCMARGIN", "3x1")
	
	IupSetAttribute(col_vboxcheck2 , "NCMARGIN", "3x1")
	
	IupSetAttribute(col_vboxcheck3 , "NCMARGIN", "3x1")
	
	IupSetAttribute(col_vboxcheck4 , "NCMARGIN", "3x1")	
	
	#else
	
	IupSetAttribute(col_vboxcheck3 , "GAP", "5")
	
	IupSetAttribute(col_vboxcheck4 , "GAP", "5")		
	
	#endif


	
	For i As Long = 1 To 8
		
		btn_dim1(i-1) = IupButton(0,0)
		
		szbtn_str_dim1(i-1) = "B1_" & i
		
		IupSetAttribute(btn_dim1(i-1) , "NAME" , szbtn_str_dim1(i-1))
		
		IupSetAttribute(btn_dim1(i-1) , "MINSIZE" , "30x20")
		
		IupSetAttribute(btn_dim1(i-1) , "MAXSIZE" , "30x20")
		
		IupSetCallback(btn_dim1(i-1) , "ACTION" , Cast(Any Ptr , @options_select_color_callback()))
		
		btn_dim2(i-1) = IupButton(0,0)
		
		szbtn_str_dim2(i-1) = "B2_" & i
		
		IupSetAttribute(btn_dim2(i-1) , "NAME" , szbtn_str_dim2(i-1))
		
		IupSetAttribute(btn_dim2(i-1) , "MINSIZE" , "30x20")
		
		IupSetAttribute(btn_dim2(i-1) , "MAXSIZE" , "30x20")
		
		IupSetCallback(btn_dim2(i-1) , "ACTION" , Cast(Any Ptr , @options_select_color_callback()))
		
		btn_dim3(i-1) = IupButton(0,0) 
		
		szbtn_str_dim3(i-1) = "B3_" & i
		
		IupSetAttribute(btn_dim3(i-1) , "NAME" , szbtn_str_dim3(i-1))
		
		IupSetAttribute(btn_dim3(i-1) , "MINSIZE" , "30x20")
		
		IupSetAttribute(btn_dim3(i-1) , "MAXSIZE" , "30x20")
		
		IupSetCallback(btn_dim3(i-1) , "ACTION" , Cast(Any Ptr , @options_select_color_callback()))
		
		btn_dim4(i-1) = IupButton(0,0)
		
		szbtn_str_dim4(i-1) = "B4_" & i
		
		IupSetAttribute(btn_dim4(i-1) , "NAME" , szbtn_str_dim4(i-1))	
		
		IupSetAttribute(btn_dim4(i-1) , "MINSIZE" , "30x20")	
		
		IupSetAttribute(btn_dim4(i-1) , "MAXSIZE" , "30x20")		
		
		IupSetCallback(btn_dim4(i-1) , "ACTION" , Cast(Any Ptr , @options_select_color_callback()))
		
	Next
	
	updown = IupText(0)
	
	lblup = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionalpha"))
	
	col_hboxup = IupHbox(lblup , updown , 0 )
	
	IupSetAttribute(updown , "SPIN", "YES")
	
	IupSetAttribute(updown , "MAXSIZE" , "50x")
	
	IupSetAttribute(updown , "NAME" , "updownalpha")
	
	IupSetAttribute(updown , "SPINMAX" , "255")
	
	Dim As ZString*4 szNull = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme", "0")
	
	IupSetAttribute(updown , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme", szNull & "a"))
	
	col_vbox2 = IupVboxv(Cast(Any Ptr , @btn_dim1(0)))
	
	IupSetAttribute(col_vbox2 , "GAP", "5")
	
	IupSetAttribute(col_vbox2 , "NCMARGIN", "3x")
	
	col_vbox3 = IupVboxv(Cast(Any Ptr , @btn_dim2(0)))
	
	IupSetAttribute(col_vbox3 , "GAP", "5")
	
	col_vbox5 = IupVboxv(Cast(Any Ptr , @btn_dim3(0)))
	
	IupSetAttribute(col_vbox5 , "GAP", "5")
	
	IupSetAttribute(col_vbox5 , "NCMARGIN", "3x")
	
	col_vbox6 = IupVboxv(Cast(Any Ptr , @btn_dim4(0)))	
	
	IupSetAttribute(col_vbox6 , "GAP", "5")
	
	col_hbox = IupHbox(	col_vbox1 , IupHbox(col_vbox2, 0) ,IupHbox(col_vbox3 , 0) , col_vboxcheck1, col_vboxcheck2,_
	  IupFill() , col_vbox4 , IupHbox(col_vbox5 , 0) , IupHbox(col_vbox6 , 0) , col_vboxcheck3,col_vboxcheck4, 0 )
	
	IupSetAttribute(col_hbox , "NCMARGIN", "3x7")
	
	fr_color = IupFrame(col_hbox)
	
	IupSetAttribute(fr_color , "TITLE", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionbackfront"))
	
	vBoxColor = IupVbox( IupFill() ,fr_theme, IupFill() ,col_hboxup ,IupFill() ,  fr_color ,  0)
	
	Return vBoxColor	
	
End Function

' create tab "GENERAL" for dialog options "EDIT"
Function create_tab_general() As iHandle Ptr
	
	'----------------------- general --------------------
	
	Dim As Ihandle Ptr genfrlineends , genfrtabs , genfrlang , genfreditor , genfrfont,_
	genfrcase , vboxle , vboxt1 , vboxt2 , hboxt , hboxlang , vboxedit1 , vboxedit2 , hboxedit , _
	vboxfont1 , vboxfont2 , hboxfont , hboxcase ,  mainbox , radiowin , radiolin , radiotab , radiospace , _
	updown , combo , checkwrap , checkwhitespace , checkspacesimv , checknumbers , radioupcase , radiodowncase ,_
	radiocamelcase , radiomixedcase , checkfolding, checkautocomplect, btnedit , btnwinout , btnstatus , txtedit ,  txtwinout , txtstatus
	
	radiowin = IupToggle(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionlinewin"),0)
	
	IupSetAttribute(radiowin , "NAME" , "radiowin")
	
	radiolin = IupToggle(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionlinelin"),0)
	
	IupSetAttribute(radiolin , "NAME" , "radiolin")
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Editor" , "lineends") = "WIN" Then
		
		IupSetAttribute(radiowin , "VALUE" , "ON")
		
	Else	
		
		IupSetAttribute(radiolin , "VALUE" , "ON")
		
	EndIf
	
	radiotab = IupToggle(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optiontab"),0)
	
	IupSetAttribute(radiotab , "NAME" , "radiotab")
	
	radiospace = IupToggle(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionspace"),0)
	
	IupSetAttribute(radiospace , "NAME" , "radiospace")
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Editor" , "indent") = "TAB" Then
		
		IupSetAttribute(radiotab , "VALUE" , "ON")
		
	Else
		
		IupSetAttribute(radiospace , "VALUE" , "ON")
		
	EndIf	
	
	updown = IupText(0)
	
	IupSetAttribute(updown , "SPIN", "YES")
	
	IupSetAttribute(updown , "MAXSIZE" , "50x")
	
	IupSetAttribute(updown , "NAME" , "updownindent")
	
	IupSetAttribute(updown , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Editor" , "indentsize"))
	
	combo = IupList(0)
	
	IupSetAttribute(combo , "DROPDOWN", "YES")
	
	IupSetAttribute(combo , "MINSIZE", "135x")	
	
	For i As Long  = 1 To 100
		
		If *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Lang" , "n" & i) <> "" Then
			
			IupSetAttribute(combo , Str(i) , *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Lang" , "n" & i) )
			
		Else	
			
			Exit For
			
		EndIf
		
	Next
	
	IupSetAttribute(combo , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Lang", "current"))
	
	IupSetAttribute(combo , "NAME" , "combolang")
	
	checkwrap = IupToggle(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionwrapline"),0)
	
	IupSetAttribute(checkwrap , "NAME" , "checkwrap")
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","wrap")  = "WORD" Then
		
		IupSetAttribute(checkwrap , "VALUE", "ON")
		
	EndIf
	 
	checkwhitespace = IupToggle(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionvisiblespace"),0)
	
	IupSetAttribute(checkwhitespace , "NAME" , "checkwhitespace")
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","whitespace")  = "VISIBLEALWAYS" Then
		
		IupSetAttribute(checkwhitespace , "VALUE" , "ON")
		
	EndIf	
	 
	checkspacesimv = IupToggle(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionvisibleindents"),0)
	
	IupSetAttribute(checkspacesimv , "NAME" , "checkspacesimv")
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","indentationguides")  = "REAL" Then
		
		IupSetAttribute(checkspacesimv , "VALUE" , "ON")
		
	EndIf		
	 
	checknumbers = IupToggle(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionvisiblenumbers"),0)
	
	IupSetAttribute(checknumbers , "NAME" , "checknumbers")
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","viewnumbers")  = "YES" Then
		
		IupSetAttribute(checknumbers , "VALUE" , "ON")
		
	EndIf			
	
	checkfolding = IupToggle(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionvisiblefolding"),0)
	
	IupSetAttribute(checkfolding , "NAME" , "checkfolding")
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","folding")  = "YES" Then
		
		IupSetAttribute(checkfolding , "VALUE" , "ON")
		
	EndIf		
	
	
	checkautocomplect = IupToggle(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionautocomplect"),0)
	
	IupSetAttribute(checkautocomplect , "NAME" , "checkautocomplect")
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","autocomplect")  = "YES" Then
		
		IupSetAttribute(checkautocomplect , "VALUE" , "ON")
		
	EndIf		
	
	radioupcase = IupToggle(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optioncaseup"),0)
	
	IupSetAttribute(radioupcase , "NAME" , "radioupcase")
	
	radiodowncase = IupToggle(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optioncasedown"),0)
	
	IupSetAttribute(radiodowncase , "NAME" , "radiodowncase")
	
	radiocamelcase = IupToggle(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optioncasecamel"),0)
	
	IupSetAttribute(radiocamelcase , "NAME" , "radiocamelcase")
	
	radiomixedcase = IupToggle(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optioncasemixed"),0)
	
	IupSetAttribute(radiomixedcase , "NAME" , "radiomixedcase")	
	
	Select Case *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Editor" , "case")
	   
	   Case "up"
	      
	      IupSetAttribute(radioupcase , "VALUE" , "ON")
	      
	   Case "down"
	      
	      IupSetAttribute(radiodowncase , "VALUE" , "ON")
	      
	   Case "camel"   
	      
	      IupSetAttribute(radiocamelcase , "VALUE" , "ON")
	      
	   Case Else   
	      
	      IupSetAttribute(radiomixedcase , "VALUE" , "ON")
	   
	End Select
	
	btnedit = IupButton(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionfontedit"),0)
	
	IupSetAttribute(btnedit , "MINSIZE" , "130x")
	
	IupSetAttribute(btnedit , "MAXSIZE" , "x21")
	
	IupSetCallback(btnedit , "ACTION" , Cast(Any Ptr , @options_select_fontedit_callback()))
	
	btnwinout = IupButton(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionfontwinout"),0)
	
	IupSetAttribute(btnwinout , "MINSIZE" , "130x")
	
	IupSetAttribute(btnwinout , "MAXSIZE" , "x21")
	
	IupSetCallback(btnwinout , "ACTION" , Cast(Any Ptr , @options_select_fontwinout_callback()))
	
	btnstatus = IupButton(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionfontstatus"),0)
	
	IupSetAttribute(btnstatus , "MINSIZE" , "130x")
	
	IupSetAttribute(btnstatus , "MAXSIZE" , "x21")
	
	IupSetCallback(btnstatus , "ACTION" , Cast(Any Ptr , @options_select_fontstatus_callback()))
	
	txtedit = IupText("")
	
	IupSetAttribute(txtedit , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Fonts","editor"))
	
	IupSetAttribute(txtedit , "NAME" , "ftxtedit")
	
	IupSetAttribute(txtedit , "MINSIZE" , "330x")
	
	IupSetAttribute(txtedit , "MAXSIZE" , "x21")
	
	txtwinout = IupText("")
	
	IupSetAttribute(txtwinout , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Fonts","winout"))
	
	IupSetAttribute(txtwinout , "NAME" , "ftxtwinout")
	
	IupSetAttribute(txtwinout , "MINSIZE" , "330x")
	
	IupSetAttribute(txtwinout , "MAXSIZE" , "x21")
	
	txtstatus = IupText("")
	
	IupSetAttribute(txtstatus , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Fonts","status"))
	
	IupSetAttribute(txtstatus , "NAME" , "ftxtstatus")
	
	IupSetAttribute(txtstatus , "MINSIZE" , "330x")
	
	IupSetAttribute(txtstatus , "MAXSIZE" , "x21")
	
	vboxle = IupVbox(radiowin , radiolin , 0 )
	
	IupSetAttribute(vboxle , "GAP", "5")
	
	IupSetAttribute(vboxle , "NCMARGIN", "3x5")
	
	genfrlineends = IupFrame(IupRadio(vboxle))
	
	IupSetAttribute(genfrlineends , "TITLE", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionlineend"))
	
	vboxt1 = IupVbox(radiotab , radiospace , 0 )
	
	IupSetAttribute(vboxt1 , "GAP", "5")
	
	vboxt2 = IupVbox(updown, 0 )
	
	hboxt = IupHbox(IupRadio(vboxt1) , vboxt2 , 0 )
	
	IupSetAttribute(hboxt , "NCMARGIN", "3x5")
	
	genfrtabs = IupFrame(hboxt)
	
	IupSetAttribute(genfrtabs , "TITLE", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionindents"))
	
	hboxlang = IupHbox(combo , 0 )
	
	IupSetAttribute(hboxlang , "NCMARGIN", "3x8")
	
	genfrlang = IupFrame(hboxlang)
	
	IupSetAttribute(genfrlang , "TITLE", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionlang"))
	
	vboxedit1 = IupVbox(checkwrap , checkwhitespace , checkfolding , 0 )
	
	IupSetAttribute(vboxedit1 , "GAP", "5")
	
	vboxedit2 = IupVbox( checkspacesimv , checknumbers , checkautocomplect , 0 )	
	
	IupSetAttribute(vboxedit2 , "GAP", "5")
	
	hboxedit = IupHbox(vboxedit1 , IupFill() , vboxedit2 , 0 )
	
	IupSetAttribute(hboxedit , "NCMARGIN", "3x7")
	
	genfreditor = IupFrame(hboxedit)
	
	IupSetAttribute(genfreditor , "TITLE", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionedit"))
	
	hboxcase = IupHbox(IupFill(),radioupcase , IupFill(), radiodowncase , IupFill(), radiocamelcase , IupFill(), radiomixedcase , IupFill(), 0) 
	
	IupSetAttribute(hboxcase , "NCMARGIN", "x3")
	
	genfrcase = IupFrame(IupRadio(hboxcase))
	
	IupSetAttribute(genfrcase , "TITLE", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optioncodecase"))
	
	vboxfont1 = IupVbox(btnedit , btnwinout , btnstatus , 0 )
	
	IupSetAttribute(vboxfont1 , "NCMARGIN", "3x4")
	
	IupSetAttribute(vboxfont1 , "GAP", "2")
	
	vboxfont2 = IupVbox(txtedit ,  txtwinout , txtstatus, 0 )
	
	IupSetAttribute(vboxfont2 , "NCMARGIN", "3x4")
	
	IupSetAttribute(vboxfont2 , "GAP", "2")
	
	hboxfont = IupHbox(vboxfont1 , IupFill(), vboxfont2 , 0 )
	
	genfrfont = IupFrame(hboxfont)
	
	IupSetAttribute(genfrfont , "TITLE", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionfont"))
	
	mainbox = IupVbox(IupFill(),IupHbox(genfrlineends , IupFill(), genfrtabs , IupFill(), genfrlang , 0) ,IupFill(), genfreditor ,IupFill(),genfrcase , IupFill(), genfrfont,IupFill(), 0 )	
	
	Return mainbox
	
End Function

' create  dialog options "EDIT"
Function create_options_dialog() As iHandle Ptr	
	
	Dim As Ihandle Ptr dlg, vboxMain , hBoxBut, tabs ,  btnOK , btnCancel , btnApply
	
	'----------------------- main options --------------------
	
	btnApply = IupButton(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionbtnapply"), 0) 
	
	btnOK = IupButton(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionbtnok"), 0)
	
	btnCancel = IupButton(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionbtncancel"), 0)
	
	IupSetAttribute(btnApply , "MINSIZE" , "80x20")
	
	IupSetCallback(btnApply , "ACTION", Cast(Any Ptr, @option_apply_callback()))
	
	IupSetAttribute(btnOK , "MINSIZE" , "80x20")
	
	IupSetCallback(btnOK , "ACTION", Cast(Any Ptr, @option_ok_callback()))
	
	IupSetAttribute(btnCancel , "MINSIZE" , "80x20")
	
	IupSetCallback(btnCancel , "ACTION", Cast(Any Ptr, @option_cancel_callback()))
	
	hBoxBut = IupHbox(IupFill() , btnApply , btnOK , btnCancel ,IupFill(), 0)
	
	IupSetAttribute(hBoxBut, "GAP", "10")
	
	IupSetAttribute(hBoxBut, "NMARGIN", "x10")
	
	tabs = IupTabs(create_tab_general() , create_tab_path(), create_tab_color()  ,0)
	
	IupSetAttribute(tabs, "EXPAND", "Yes")
	
	IupSetAttributeId(tabs, "TABTITLE",0 ,*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optiongen"))
	
	IupSetAttributeId(tabs, "TABTITLE",1 ,*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionpath"))
	
	IupSetAttributeId(tabs, "TABTITLE",2 ,*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optioncolor"))	
	
	vboxMain = IupVbox(tabs , hBoxBut , 0)
	
	dlg = IupDialog(vboxMain)
	
	TGlobalVariables->hOptions = dlg
	
	IupSetCallback(dlg, "CLOSE_CB", Cast(Any Ptr , @options_close_action_callback))
	
	IupSetAttribute(dlg, "TITLE", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"submenuoptions"))
	
	get_theme_color(1)

	IupSetAttribute(dlg, "DIALOGFRAME", "Yes")
	
	'IupSetAttribute(dlg, "RASTERSIZE" , "500x")
	
	IupShow(dlg)
	
	IupRefresh(dlg)
	
	Return dlg
	
End Function


'create dlg "TOOL" ; iParam =1 (Build) , iParam =2 (Help) , iParam =3 (tool) ,
Function create_options_tool_dialog(iParam As Byte) As iHandle Ptr
	
	Dim As Ihandle Ptr lbl1, lbl2 , txt1 , txt2 , _
	btnok, btncancel , btninsert , btndelete , btnup , btndown , btnpath, list ,_
	vboxM , vbox1 , vbox2 , vbox3 , hbox , dlg
	
	list = IupList(0)
	
	IupSetAttribute(list , "NAME" , "toollist")
	
	IupSetAttribute(list , "EXPAND" , "YES")
	
	IupSetAttribute(list , "MINSIZE" , "173x165")
	
	IupSetAttribute(list , "MAXSIZE" , "173x165")
	
	IupSetCallback(list, "ACTION", Cast(Any Ptr , @options_tool_action_list_callback))
	
	btnup = IupButton(0,0)
	
	IupSetAttribute(btnup , "IMAGE" , "img_toolup")
	
	IupSetAttribute(btnup , "MINSIZE" , "22x22")
	
	IupSetAttribute(btnup , "MAXSIZE" , "22x22")	
	
	IupSetAttribute(btnup , "NAME" , "tooldup")
	
	IupSetCallback(btnup, "ACTION", Cast(Any Ptr , @options_tool_action_btnup_callback))
	
	btndown = IupButton(0,0)
	
	IupSetAttribute(btndown , "IMAGE" , "img_tooldown")
	
	IupSetAttribute(btndown , "MINSIZE" , "22x22")
	
	IupSetAttribute(btndown , "MAXSIZE" , "22x22")		
	
	IupSetAttribute(btndown , "NAME" , "tooldown")
	
	IupSetCallback(btndown, "ACTION", Cast(Any Ptr , @options_tool_action_btndown_callback))
	
	btnok = IupButton(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionbtnok"),0)
	
	IupSetAttribute(btnok , "NAME" , "toolok") 
	
	IupSetAttribute(btnok , "MINSIZE" , "70x")
	
	IupSetCallback(btnok, "ACTION", Cast(Any Ptr , @options_tool_action_btnok_callback))
	
	btncancel = IupButton(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionbtncancel"),0)
	
	IupSetAttribute(btncancel , "NAME" , "toolcancel") 	
	
	IupSetAttribute(btncancel , "MINSIZE" , "70x")
	
	IupSetCallback(btncancel, "ACTION", Cast(Any Ptr , @options_tool_action_btncancel_callback))
	
	btninsert = IupButton(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionbtninsert"),0)
	
	IupSetAttribute(btninsert , "NAME" , "toolinsert") 
	
	IupSetAttribute(btninsert , "MINSIZE" , "70x")
	
	IupSetCallback(btninsert, "ACTION", Cast(Any Ptr , @options_tool_action_btninsert_callback))
	
	btndelete = IupButton(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionbtndelete"),0)
	
	IupSetAttribute(btndelete , "NAME" , "tooldelete") 
	
	IupSetAttribute(btndelete , "MINSIZE" , "70x")
	
	IupSetCallback(btndelete, "ACTION", Cast(Any Ptr , @options_tool_action_btndelete_callback))
	
	lbl1 = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionbuilditem"))
	
	lbl2 = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionbuildcommand"))	
	
	txt1 = IupText("")
	
	IupSetAttribute(txt1 , "MINSIZE" , "275x22")
	
	IupSetAttribute(txt1 , "MAXSIZE" , "275x22")
	
	IupSetAttribute(txt1 , "NAME" , "tooltxt1")
	
	txt2 = IupText("")
	
	IupSetAttribute(txt2 , "MINSIZE" , "260x22")
	
	IupSetAttribute(txt2 , "MAXSIZE" , "260x22")
	
	IupSetAttribute(txt2 , "NAME" , "tooltxt2")	
	
	btnpath = IupButton("...",0)
	
	IupSetAttribute(btnpath , "NAME" , "toolpath") 
	
	IupSetAttribute(btnpath , "MINSIZE" , "x22")
	
	IupSetAttribute(btnpath , "MAXSIZE" , "x22")
	
	If iParam = 1 Then
		
		IupSetAttribute(btnpath , "ACTIVE" , "NO")
		
	EndIf
	
	IupSetCallback(btnpath, "ACTION", Cast(Any Ptr , @options_tool_action_btnpath_callback))
	
	vbox1 = IupVbox(list,0)
	
	vbox2 = IupVbox(btnup, IupFill(), btndown,0)
	
	vbox3 = IupVbox(btnok , btncancel , IupFill() , btninsert , btndelete , 0)
	
	hBox = IupHbox(vbox1 , vbox2 , vbox3 , 0)
	
	IupSetAttribute(hBox , "GAP" , "3")
	
	vboxM = IupVbox( hBox , lbl1 , txt1,lbl2 , IupHbox(txt2 ,btnpath,0) ,0)
	
	IupSetAttribute(vboxM, "NMARGIN", "2x2")
	
	dlg = IupDialog(vboxM)
	
	TGlobalVariables->tool_dlg = dlg
	
	IupSetCallback(dlg, "CLOSE_CB", Cast(Any Ptr , @options_close_tool_callback))
	
	Dim As ZString*10 szOpt
	
	Select Case iParam
		
		Case 1
			
			IupSetAttribute(dlg, "TITLE", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstitletoolbuild"))
			
			szOpt = "BUILD"
			
		Case 2
			
			IupSetAttribute(dlg, "TITLE", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstitletoolhelp"))
			
			szOpt = "HELPF"
			
		Case 3	
			
			IupSetAttribute(dlg, "TITLE", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstitletool"))
			
			szOpt = "TOOL"
		
	End Select	
	
	TGlobalVariables->t_list = New Tlist
	
	For i As Long  = 1 To 100
		
		Dim As String sTempN = *IupConfigGetVariableStr(TGlobalVariables->hConfig, szOpt , "n" & i)
		
		Dim As String sTempC = *IupConfigGetVariableStr(TGlobalVariables->hConfig, szOpt , "c" & i)
		
		If sTempN <> "" Then
			
			Dim As ZString Ptr pszListStringName = Callocate(Len(sTempN)+1)
			
			Dim As ZString Ptr pszListStringCommand = Callocate(Len(sTempC)+1)
			
			*pszListStringName = sTempN
			
			*pszListStringCommand = sTempC	

			TGlobalVariables->t_list->insert( i-1 , pszListStringCommand , pszListStringName)	
			
			IupSetAttribute(list , Str(i) , *pszListStringName )
			
		Else	
			
			Exit For
			
		EndIf
		
	Next		

	IupSetAttribute(dlg, "DIALOGFRAME", "Yes")
	
	IupSetAttribute(dlg, "RASTERSIZE" , "285x")
	
	IupShow(dlg)
	
	IupRefresh(dlg)
	
	Return dlg	
	
End Function

' Processing Button "INSERT" in the dialog TOOL
Sub options_tool_btninsert()
	
	Dim As Ihandle Ptr txtN , txtC , list 
	
	txtN = IupGetDialogChild(TGlobalVariables->tool_dlg, "tooltxt1")
	
	txtC = IupGetDialogChild(TGlobalVariables->tool_dlg, "tooltxt2")
	
	list = IupGetDialogChild(TGlobalVariables->tool_dlg, "toollist")
	
	Dim As ZString Ptr pszTempN = IupGetAttribute (txtN , "VALUE")
	
	Dim As ZString Ptr pszTempC = IupGetAttribute (txtC , "VALUE")
	
	If Len(*pszTempN) = 0 OrElse Len(*pszTempC) = 0 Then
		
		IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstitlewarning"),_
			*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstextbuildempty"))
			
		Exit Sub	
		
	EndIf
	
	Dim As Long iInsertPos =  Val(*IupGetAttribute (list , "VALUE"))
	
	Dim As ZString Ptr pszListStringName = Callocate(Len(*pszTempN)+1)
	
	Dim As ZString Ptr pszListStringCommand = Callocate(Len(*pszTempC)+1)
	
	*pszListStringName = *pszTempN
	
	*pszListStringCommand = *pszTempC
	
	TGlobalVariables->t_list->insert(iInsertPos ,pszListStringCommand , pszListStringName) 
	
	IupSetAttribute (list , "INSERTITEM" & Str(iInsertPos+1) , pszListStringName )
	
	IupSetAttribute (list , "VALUE" , Str(iInsertPos+1))

End Sub

' Processing Button "DELETE" in the dialog TOOL
Sub options_tool_btndelete()
	
	Dim As Ihandle Ptr list 
	
	list = IupGetDialogChild(TGlobalVariables->tool_dlg, "toollist")	
	
	Dim As Long iDelPos =  Val(*IupGetAttribute (list , "VALUE"))
	
	If iDelPos = 0 Then Exit Sub
	
	TGlobalVariables->t_list->del(iDelPos - 1) 
	
	IupSetAttribute(list , "REMOVEITEM" , "ALL")
	
	Dim As Tlistnode Ptr TempNode = TGlobalVariables->t_list->pFirst
	
	Dim As Long iIndex = 1
	
	While TempNode
		
		IupSetAttribute(list , Str(iIndex) ,TempNode->pszName )
		
		TempNode = TempNode->pNext
		
		iIndex +=1
		
	Wend
	
	If iDelPos > 1 Then
		
		IupSetAttribute (list , "VALUE" , Str(iDelPos - 1))
		
	ElseIf iDelPos = 1 AndAlso Val(*IupGetAttribute (list,"COUNT")) > 0 Then
		
		IupSetAttribute (list , "VALUE" , "1")
		
	EndIf
	
End Sub

' Processing Button "CANCEL" in the dialog TOOL
Sub options_tool_btncancel()
	
	TGlobalVariables->t_list->delAll()
	
	Delete TGlobalVariables->t_list
	
	TGlobalVariables->t_list = 0
	
End Sub

' Processing Button "OK" in the dialog TOOL
Sub options_tool_btnok()
	
	Dim As Tlistnode Ptr tl = TGlobalVariables->t_list->pFirst
	
	Dim As Ihandle Ptr list_combo = IupGetDialogChild(TGlobalVariables->toolbar, "comboselectbuild")
	
	Dim As Long iIndex = 1
	
	Dim As ZString*10 zsOpt

	If *IupGetAttribute(TGlobalVariables->tool_dlg, "TITLE") = *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstitletoolbuild") Then
		
		zsOpt = "BUILD"
		
	ElseIf *IupGetAttribute(TGlobalVariables->tool_dlg, "TITLE") = *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstitletoolhelp") Then	
		
		zsOpt = "HELPF"
		
	Else	
		
		zsOpt = "TOOL"
		
	EndIf
	
	If zsOpt = "BUILD" Then
		
		IupSetAttribute(list_combo , "REMOVEITEM" , "ALL")
		
	ElseIf zsOpt = "HELPF" Then	
		
		While 1
			
			Dim As Ihandle Ptr hTemp = IupGetchild(IupGetParent(TGlobalVariables->hItemAbout),1)
			
			If hTemp <> TGlobalVariables->hItemAbout Then
				
				IupDestroy(hTemp)
				
			Else
				
				Exit while
				
			EndIf
			
		Wend		
		
	ElseIf zsOpt = "TOOL" Then	
		
		While 1
			
			Dim As Ihandle Ptr hTemp = IupGetchild(TGlobalVariables->hItemTools,0)
			
			If hTemp Then
				
				IupDestroy(hTemp)
				
			Else
				
				Exit while
				
			EndIf
			
		Wend
		
	EndIf
	
	While tl
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig , zsOpt , "n" & iIndex , *(tl->pszName) )
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig , zsOpt , "c" & iIndex , *(tl->pszCommand) )
		
		If zsOpt = "BUILD" Then
		
			IupSetAttribute(list_combo , Str(iIndex) , tl->pszName)
			
		ElseIf zsOpt = "HELPF" Then
			
			If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"HELPF", "n" & iIndex) <> "" Then
				
				Dim As Ihandle Ptr hTempMenu = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfig,"HELPF", "n" & iIndex ), NULL)
				
				IupInsert(IupGetParent(TGlobalVariables->hItemAbout), TGlobalVariables->hItemAbout , hTempMenu)
				
				IupSetCallback(hTempMenu, "ACTION", cast(any ptr , @item_helps_custom_callback))
				
				IupMap(hTempMenu)
				
			EndIf				
			
		ElseIf zsOpt = "TOOL" Then	
				
			If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"TOOL", "n" & iIndex) <> "" Then
				
				Dim As Ihandle Ptr hTempMenu = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfig,"TOOL", "n" & iIndex ), NULL)
				
				IupAppend(TGlobalVariables->hItemTools , hTempMenu)
				
				IupSetCallback(hTempMenu, "ACTION", cast(any ptr , @item_tools_custom_callback))
				
				IupMap(hTempMenu)
				
			EndIf		
			
		EndIf			
		
		tl = tl->pNext
		
		iIndex+=1
		
	Wend
	
	If zsOpt = "BUILD" Then
		
		IupSetAttribute(list_combo , "VALUE" , "1")
		
	EndIf
	
	IupConfigSetVariableStr(TGlobalVariables->hConfig , zsOpt , "n" & iIndex , "" )
	
	IupConfigSetVariableStr(TGlobalVariables->hConfig , zsOpt , "c" & iIndex , "" )		
	
	TGlobalVariables->t_list->delAll()
	
	Delete TGlobalVariables->t_list
	
	TGlobalVariables->t_list = 0	
	
End Sub

' Processing Button "UP" in the dialog TOOL
Sub options_tool_btnup()
	
	Dim As Ihandle Ptr list 
	
	list = IupGetDialogChild(TGlobalVariables->tool_dlg, "toollist")	
	
	Dim As Long iPos =  Val(*IupGetAttribute (list , "VALUE"))
	
	If iPos = 0 OrElse iPos = 1 Then Exit Sub	
	
	TGlobalVariables->t_list->move(iPos - 1 , iPos - 2 ) 
	
	IupSetAttribute(list , "REMOVEITEM" , "ALL")	
	
	Dim As Tlistnode Ptr TempNode = TGlobalVariables->t_list->pFirst
	
	Dim As Long iIndex = 1
	
	While TempNode
		
		IupSetAttribute(list , Str(iIndex) ,TempNode->pszName )
		
		TempNode = TempNode->pNext
		
		iIndex +=1
		
	Wend
	
	IupSetAttribute (list , "VALUE" , str(iPos - 1))
	
End Sub

' Processing Button "DOWN" in the dialog TOOL
Sub options_tool_btndown()
	
	Dim As Ihandle Ptr list 
	
	list = IupGetDialogChild(TGlobalVariables->tool_dlg, "toollist")	
	
	Dim As Long iPos =  Val(*IupGetAttribute (list , "VALUE"))
	
	If iPos = 0 OrElse iPos = Val(*IupGetAttribute (list , "COUNT")) Then Exit Sub	

	TGlobalVariables->t_list->move(iPos - 1 , iPos ) 
	
	IupSetAttribute(list , "REMOVEITEM" , "ALL")	
	
	Dim As Tlistnode Ptr TempNode = TGlobalVariables->t_list->pFirst
	
	Dim As Long iIndex = 1
	
	While TempNode
		
		IupSetAttribute(list , Str(iIndex) ,TempNode->pszName )
		
		TempNode = TempNode->pNext
		
		iIndex +=1
		
	Wend
	
	IupSetAttribute (list , "VALUE" , str(iPos+1))
	
End Sub

' Processing Click Mouse on "LIST" in the dialog "TOOL"
Sub options_tool_list_action(iItem As Integer)
	
	Dim As Tlistnode Ptr TempNode = TGlobalVariables->t_list->getNode(iItem - 1)
	
	Dim As Ihandle Ptr txtN , txtC 
	
	txtN = IupGetDialogChild(TGlobalVariables->tool_dlg, "tooltxt1")
	
	txtC = IupGetDialogChild(TGlobalVariables->tool_dlg, "tooltxt2")	
	
	IupSetAttribute(txtN , "VALUE" , TempNode->pszName)
	
	IupSetAttribute(txtC , "VALUE" , TempNode->pszCommand)
	
End Sub

' Processing Button "Cancel" in the options EDIT
Sub reset_options_proc()
	
	Dim As Integer ic = IupGetChildCount(TGlobalVariables->tabs)
	
	set_visual_params_build_info_proc(0)
	
	set_visual_params_statusbar_proc(0)	
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combolang") , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Lang", "current"))
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Editor" , "lineends") = "WIN" Then
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "radiowin") , "VALUE" , "ON")
		
	Else	
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "radiolin") , "VALUE" , "ON")
		
	EndIf	
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Editor" , "indent") = "TAB" Then
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "radiotab"), "VALUE" , "ON")
		
	Else
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "radiospace"), "VALUE" , "ON")
		
	EndIf		
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "updownindent") , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Editor" , "indentsize"))	
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","wrap")  = "WORD" Then
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checkwrap") , "VALUE", "ON")
		
	Else
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checkwrap") , "VALUE", "OFF")
		
	EndIf	
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","whitespace")  = "VISIBLEALWAYS" Then
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checkwhitespace") , "VALUE" , "ON")
		
	Else
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checkwhitespace") , "VALUE" , "OFF")
		
	EndIf		
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","indentationguides")  = "REAL" Then
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checkspacesimv") , "VALUE" , "ON")
		
	Else
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checkspacesimv") , "VALUE" , "OFF")
		
	EndIf	
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","viewnumbers")  = "YES" Then
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checknumbers") , "VALUE" , "ON")
		
	Else
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checknumbers") , "VALUE" , "OFF")
		
	EndIf	
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","autocomplect")  = "YES" Then
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checkautocomplect") , "VALUE" , "ON")
		
	Else
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checkautocomplect") , "VALUE" , "OFF")
		
	EndIf		
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","folding")  = "YES" Then
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checkfolding") , "VALUE" , "ON")
		
	Else
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checkfolding") , "VALUE" , "OFF")
		
	EndIf		
	
	
	Select Case *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Editor" , "case")
	   
	   Case "up"
	      
	      IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "radioupcase") , "VALUE" , "ON")
	      
	   Case "down"
	      
	      IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "radiodowncase") , "VALUE" , "ON")
	      
	   Case "camel"   
	      
	      IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "radiocamelcase") , "VALUE" , "ON")
	      
	   Case Else   
	      
	      IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "radiomixedcase") , "VALUE" , "ON")
	   
	End Select	
   
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ftxtedit")  , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Fonts","editor"))
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ftxtwinout") , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Fonts","winout"))
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ftxtstatus") , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Fonts","status"))
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , "REMOVEITEM" , "ALL")
	
	For i As Long = 1 To 100
		
		If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme", i & "n") <> "" Then
			
			IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , Str(i) , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme", i & "n"))
			
			IupSetStrAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , "b" & Str(i) , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme", i & "c"))
			
			IupSetStrAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , "ba" & Str(i) , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme", i & "a"))

         IupSetStrAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , "bold" & Str(i) , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme", i & "bold"))
         
         IupSetStrAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , "italic" & Str(i) , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme", i & "italic"))					
			
		Else
			
			Exit For
			
		EndIf
	
	Next	

	IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme", "0"))
	
	Dim As ZString*4 szNull = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme", "0")
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "updownalpha") , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme", szNull & "a"))
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txtcomppath") , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path","pathcompilier"))
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txtincludepath") , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path","pathinclude"))
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txtdebugpath") , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path","pathdebugger"))
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txthelpfbpath") , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path","pathhelpfb"))
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txtterminal") , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path","pathterminal"))
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txtbrowser") , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path","pathbrowser"))
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txtnewtheme") , "VALUE" , "")
	
	If ic < 2 Then 
		
		IupHide(TGlobalVariables->hOptions)
		
		Exit Sub
		
	EndIf
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	set_attribute_multitext_proc(TGlobalVariables->tTabsOptions(idTabs).multitext , 0)	
	
End Sub

' ' Processing Button "OK" in the options EDIT
Sub option_ok_proc()
	
	
	Dim As Integer ic = IupGetChildCount(TGlobalVariables->tabs)
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Lang", "current") <> *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combolang") , "VALUE") Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Lang", "current" , *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combolang") , "VALUE"))
		
		IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstitlewarning"),_
			*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstextlangreboot"))
		
	EndIf
	
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "radiowin") , "VALUE") =  "ON" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig, "Editor" , "lineends" , "WIN")
		
	Else
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig, "Editor" , "lineends" , "LIN")
		
	EndIf
	
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "radiotab"), "VALUE") =  "ON" Then 
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig, "Editor" , "indent" , "TAB")
		
	Else
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig, "Editor" , "indent" , "SPACE")
		
	EndIf


	IupConfigSetVariableStr(TGlobalVariables->hConfig, "Editor" , "indentsize" , *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "updownindent") , "VALUE"))

	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checkwrap") , "VALUE") =  "ON" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Editor","wrap" , "WORD")
		
	Else
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Editor","wrap" , "NONE")
		
	EndIf
	
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checkwhitespace") , "VALUE") =  "ON" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Editor", "whitespace" , "VISIBLEALWAYS")
		
	Else
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Editor", "whitespace" , "INVISIBLE")
		
	EndIf
	
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checkspacesimv") , "VALUE") = "ON" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Editor" , "indentationguides" ,  "REAL")
		
	Else
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Editor","indentationguides" ,  "NONE")
		
	EndIf
	
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checknumbers") , "VALUE") = "ON" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Editor","viewnumbers" , "YES")
				
	Else	
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Editor","viewnumbers" , "NO")
		
	EndIf
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checkfolding") , "VALUE") = "ON" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Editor","folding" , "YES")
				
	Else	
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Editor","folding" , "NO")
		
	EndIf	
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checkautocomplect") , "VALUE") = "ON" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Editor","autocomplect" , "YES")
				
	Else	
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Editor","autocomplect" , "NO")
		
	EndIf		
	
	
	Select Case "ON"
	   
	   Case *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "radioupcase") , "VALUE")
	      
	      IupConfigSetVariableStr(TGlobalVariables->hConfig, "Editor" , "case" , "up")
	      
	   Case *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "radiodowncase") , "VALUE")
	      
	      IupConfigSetVariableStr(TGlobalVariables->hConfig, "Editor" , "case" , "down")
	      
	   Case *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "radiocamelcase") , "VALUE")
	      
	      IupConfigSetVariableStr(TGlobalVariables->hConfig, "Editor" , "case" , "camel")
	      
	   Case Else   
	      
	      IupConfigSetVariableStr(TGlobalVariables->hConfig, "Editor" , "case" , "mixed")
	   
	End Select	
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ftxtedit")  , "VALUE") <> "" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Fonts","editor", *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ftxtedit")  , "VALUE"))
		
	EndIf
		
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ftxtwinout")  , "VALUE") <> "" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Fonts","winout", *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ftxtwinout")  , "VALUE"))
		
	EndIf

	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ftxtstatus")  , "VALUE") <> "" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Fonts","status", *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ftxtstatus")  , "VALUE"))
		
	EndIf
	
	For i As Long = 1 To *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , "COUNT")
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Theme", i & "n", *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , Str(i)))
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Theme", i & "c", *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , "b" & Str(i)))
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Theme", i & "a", *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , "ba" & Str(i)))	
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Theme", i & "bold", *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , "bold" & Str(i)))
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Theme", i & "italic", *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , "italic" & Str(i)))
	   
	Next	

	IupConfigSetVariableStr(TGlobalVariables->hConfig,"Theme", "0" , *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , "VALUE"))
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txtcomppath") , "VALUE") <> "" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Path","pathcompilier" , *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txtcomppath") , "VALUE"))
		
	EndIf
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txtincludepath") , "VALUE") <> "" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Path","pathinclude" , *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txtincludepath") , "VALUE"))
		
	EndIf	

	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txtdebugpath") , "VALUE") <> "" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Path","pathdebugger", *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txtdebugpath") , "VALUE"))
		
	EndIf
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txthelpfbpath") , "VALUE") <> "" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Path","pathhelpfb", *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txthelpfbpath") , "VALUE"))
		
	EndIf	
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txtterminal") , "VALUE") <> "" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Path","pathterminal", *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txtterminal") , "VALUE"))
		
	EndIf
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txtbrowser") , "VALUE") <> "" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Path","pathbrowser", *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txtbrowser") , "VALUE"))
		
	EndIf		
		
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txtnewtheme") , "VALUE" , "")
	
	If ic < 2 Then 
		
		IupHide(TGlobalVariables->hOptions)
		
		Exit Sub
		
	EndIf
	
	For i As Long  = 1 To ic - 1
		
		set_attribute_multitext_proc(TGlobalVariables->tTabsOptions(i).multitext , 0)
		
	Next
		
	
End Sub

' Processing Button "Apply" in the options EDIT
Sub option_apply_proc()
	
	Dim As Integer ic = IupGetChildCount(TGlobalVariables->tabs)
	
	Dim As String szTheme = *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , "VALUE")
	
	Dim As ZString Ptr pszColAlpha = IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme"),"ba" & szTheme)
	
	*pszColAlpha = *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "updownalpha"), "VALUE")
	
	set_visual_params_build_info_proc(1)
	
	set_visual_params_statusbar_proc(1)	
	
	If ic < 2 Then Exit Sub
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	set_attribute_multitext_proc(TGlobalVariables->tTabsOptions(idTabs).multitext , 1)	
	
End Sub

