Function item_close_proc (idTabs As Long) As Integer

	Dim As Integer ic = IupGetChildCount(TGlobalVariables->tabs)
	
	If ic < 2 Then Return IUP_DEFAULT
	
	Dim As Long iBeg,iEnd,iPositionActive
	
	If idTabs = 0 Then
		
		iBeg = ic
		
		iEnd = 1
		
	Else
		
		iBeg = idTabs
		
		iEnd = idTabs	
		
		If (idTabs - 1) > 0 Then		
			
			iPositionActive = idTabs - 1	
			
		Else
		   
		   If ic > 2 Then
		      
		      iPositionActive = idTabs
		      
		   EndIf
			
		EndIf
		
	EndIf
	
	For i As Long = iBeg To iEnd Step -1

		If *IupGetAttribute(TGlobalVariables->tTabsOptions(i).multitext, "ISCHANGES") = "YES" Then
			
			IupSetAttribute(TGlobalVariables->tabs, "VALUEPOS",Str(i))
			
			Dim As Integer iRet = dialog_message_yes_no_proc(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,_
				"dlgwarningtitle"),*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgissavemess"))
			
			If iRet = 1 Then
				
				If save_proc(i) = 0 Then Continue For
				
			ElseIf iRet = 3 Then	
				
				Return IUP_IGNORE
				
			EndIf
			
		EndIf
		
		IupDestroy(IupGetChild(TGlobalVariables->tabs, i))
		
		IupRefreshChildren(TGlobalVariables->tabs)	
		
		For j As Long = i To ic - 1
				
			TGlobalVariables->tTabsOptions(j).multitext = TGlobalVariables->tTabsOptions(j+1).multitext	
			
		Next
		
		TGlobalVariables->tTabsOptions(ic).multitext = 0	
		
	Next
	
	If iPositionActive Then
		
		IupSetAttribute(TGlobalVariables->tabs, "VALUEPOS",Str(iPositionActive))
		
		IupSetAttribute(TGlobalVariables->hTimer, "RUN", "YES")
		
	Else
	   
	   IupSetAttribute(TGlobalVariables->dlg, "TITLE", "IUP_FB_Editor")
	   
	   IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "EOLLBL"), "TITLE" , " ")
	   
	   IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "ENCLBL"), "TITLE" , " ")
	   
	   IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "INSLBL"), "TITLE" , "Ins")
	   
	   IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "CHANGLBL"), "TITLE", " ")
	   
	   IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "SELLBL"), "TITLE" , "Sel: ")
	   
	   IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "LINELBL"), "TITLE", "Lin 0, Col 0")
		
	EndIf

	Return IUP_DEFAULT

End Function

Function Create_Tabs_proc() As IHandle Ptr
	
	Dim As Ihandle Ptr vBox = IupVbox(null)
	
	
	#ifdef __FB_LINUX__
	
	#ifdef __FB_64BIT__
	
	dim as IHandle ptr tabs = IupFlatTabs(vBox,null)
	
	IupSetAttribute(tabs, "FORECOLOR", "0 0 0")
	
	IupSetAttribute(tabs, "BGCOLOR", "245 245 245")
	
	#else
	
	dim as IHandle ptr tabs = IupTabs(vBox,null)
	
	#endif
	
	#endif
	
	#ifdef __FB_WIN32__
	
	dim as IHandle ptr tabs = IupFlatTabs(vBox,null)
	
	IupSetAttribute(tabs, "FORECOLOR", "0 0 0")
	
	IupSetAttribute(tabs, "BGCOLOR", "245 245 245")
		
	#endif
	
	IupSetAttribute(tabs, "TABVISIBLE0", "NO")

	IupSetAttribute(tabs, "SHOWCLOSE", "Yes")
	 
	IupSetAttribute(tabs, "TABSFONTSIZE", "12")
 	
 	IupSetCallback(tabs, "TABCHANGEPOS_CB", Cast(Any Ptr,@tab_change_pos_callback))
 	
 	IupSetCallback(tabs, "TABCLOSE_CB", Cast(Any Ptr,@tab_close_callback))
	
	Return tabs

End Function


Sub next_tab_proc()
   
   Dim As Integer iCount , iCurent
   
   iCount = IupGetChildCount(TGlobalVariables->tabs)
   
   If iCount < 2 Then Exit Sub
   
   iCurent = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
   
   If iCurent + 1 >= iCount Then Exit Sub
   
   IupSetAttribute(TGlobalVariables->tabs, "VALUEPOS" , Str(iCurent + 1))
   
   IupSetAttribute(TGlobalVariables->hTimer, "RUN", "YES")
   
End Sub


Sub prev_tab_proc()
   
   Dim As Integer iCount , iCurent
   
   iCount = IupGetChildCount(TGlobalVariables->tabs)
   
   If iCount < 2 Then Exit Sub
   
   iCurent = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
   
   If (iCurent - 1) < 1 Then Exit Sub
   
   IupSetAttribute(TGlobalVariables->tabs, "VALUEPOS" , Str(iCurent - 1))
   
   IupSetAttribute(TGlobalVariables->hTimer, "RUN", "YES")   
   
End Sub
