' Create ToolBar
function create_toolbar_proc() As IHandle Ptr
	
	Dim As IHandle Ptr list_combo, hToolbar, btn_new , btn_open , btn_save , btn_saveall ,_
	btn_cut , btn_copy , btn_paste , btn_delete , btn_undo , btn_redo ,_
	btn_find , btn_replace , btn_setbookmark , btn_nextbookmark ,_
	btn_prevbookmark , btn_deletebookmarks , btn_indent , btn_noindent ,_
	btn_comment , btn_uncomment , btn_compile , btn_run , btn_compileandrun ,_
	btn_quickrun, btn_encoding
	
	' new
	btn_new = IupButton(NULL, NULL)

	IupSetAttribute(btn_new, "IMAGE", "img_new")

	IupSetAttribute(btn_new, "FLAT", "Yes")

	IupSetCallback(btn_new, "ACTION", cast(any ptr , @item_new_callback()))

	IupSetAttribute(btn_new, "TIP", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"toolnew"))

	IupSetAttribute(btn_new, "CANFOCUS", "No")
	
	' open
	btn_open = IupButton(NULL, NULL)

	IupSetAttribute(btn_open, "IMAGE", "img_open")

	IupSetAttribute(btn_open, "FLAT", "Yes")

	IupSetCallback(btn_open, "ACTION", cast(any ptr , @item_open_callback()))

	IupSetAttribute(btn_open, "TIP", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"toolopen"))

	IupSetAttribute(btn_open, "CANFOCUS", "No")	
	
	'save
	btn_save = IupButton(NULL, NULL)

	IupSetAttribute(btn_save, "IMAGE", "img_save")

	IupSetAttribute(btn_save, "FLAT", "Yes")

	IupSetCallback(btn_save, "ACTION", cast(any ptr , @item_save_callback()))

	IupSetAttribute(btn_save, "TIP", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"toolsave"))

	IupSetAttribute(btn_save, "CANFOCUS", "No")
	
	'save all
	btn_saveall = IupButton(NULL, NULL)

	IupSetAttribute(btn_saveall, "IMAGE", "img_save_all")

	IupSetAttribute(btn_saveall, "FLAT", "Yes")

	IupSetCallback(btn_saveall, "ACTION", cast(any ptr , @item_save_all_callback()))

	IupSetAttribute(btn_saveall, "TIP", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"toolsaveall"))

	IupSetAttribute(btn_saveall, "CANFOCUS", "No")
	
	'Cut
	btn_cut = IupButton(NULL, NULL)

	IupSetAttribute(btn_cut, "IMAGE", "img_cut")

	IupSetAttribute(btn_cut, "FLAT", "Yes")

	IupSetCallback(btn_cut, "ACTION", cast(any ptr , @item_cut_callback()))

	IupSetAttribute(btn_cut, "TIP", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"toolcut"))

	IupSetAttribute(btn_cut, "CANFOCUS", "No")	
	
	'Copy
	btn_copy = IupButton(NULL, NULL)

	IupSetAttribute(btn_copy, "IMAGE", "img_copy")

	IupSetAttribute(btn_copy, "FLAT", "Yes")

	IupSetCallback(btn_copy, "ACTION", cast(any ptr , @item_copy_callback()))

	IupSetAttribute(btn_copy, "TIP", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"toolcopy"))

	IupSetAttribute(btn_copy, "CANFOCUS", "No")	
	
	'Paste
	btn_paste = IupButton(NULL, NULL)

	IupSetAttribute(btn_paste, "IMAGE", "img_paste")

	IupSetAttribute(btn_paste, "FLAT", "Yes")

	IupSetCallback(btn_paste, "ACTION", cast(any ptr , @item_paste_callback()))

	IupSetAttribute(btn_paste, "TIP", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"toolpaste"))

	IupSetAttribute(btn_paste, "CANFOCUS", "No")
	
	'Delete
	btn_delete = IupButton(NULL, NULL)

	IupSetAttribute(btn_delete, "IMAGE", "img_delete")

	IupSetAttribute(btn_delete, "FLAT", "Yes")

	IupSetCallback(btn_delete, "ACTION", cast(any ptr , @item_delete_callback()))

	IupSetAttribute(btn_delete, "TIP", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"tooldelete"))

	IupSetAttribute(btn_delete, "CANFOCUS", "No")
	
	'Undo
	btn_undo = IupButton(NULL, NULL)

	IupSetAttribute(btn_undo, "IMAGE", "img_undo")

	IupSetAttribute(btn_undo, "FLAT", "Yes")

	IupSetCallback(btn_undo, "ACTION", cast(any ptr , @item_undo_callback()))

	IupSetAttribute(btn_undo, "TIP", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"toolundo"))

	IupSetAttribute(btn_undo, "CANFOCUS", "No")
	
	'Redo
	btn_redo = IupButton(NULL, NULL)

	IupSetAttribute(btn_redo, "IMAGE", "img_redo")

	IupSetAttribute(btn_redo, "FLAT", "Yes")

	IupSetCallback(btn_redo, "ACTION", cast(any ptr , @item_redo_callback()))

	IupSetAttribute(btn_redo, "TIP", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"toolredo"))

	IupSetAttribute(btn_redo, "CANFOCUS", "No")						
	
	'find
	btn_find = IupButton(NULL, NULL)

	IupSetAttribute(btn_find, "IMAGE", "img_find")

	IupSetAttribute(btn_find, "FLAT", "Yes")

	IupSetCallback(btn_find, "ACTION", cast(any ptr , @item_find_callback()))

	IupSetAttribute(btn_find, "TIP", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"toolfind"))

	IupSetAttribute(btn_find, "CANFOCUS", "No")	
	
	'replace
	btn_replace = IupButton(NULL, NULL)

	IupSetAttribute(btn_replace, "IMAGE", "img_replace")

	IupSetAttribute(btn_replace, "FLAT", "Yes")

	IupSetCallback(btn_replace, "ACTION", cast(any ptr , @item_replace_callback()))

	IupSetAttribute(btn_replace, "TIP", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"toolreplace"))

	IupSetAttribute(btn_replace, "CANFOCUS", "No")
	
	'Set BookMark
	btn_setbookmark = IupButton(NULL, NULL)

	IupSetAttribute(btn_setbookmark, "IMAGE", "img_set_bookmark")

	IupSetAttribute(btn_setbookmark, "FLAT", "Yes")

	IupSetCallback(btn_setbookmark, "ACTION", cast(any ptr , @item_bookmarks_toggle_callback()))

	IupSetAttribute(btn_setbookmark, "TIP", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"tooltogglebook"))

	IupSetAttribute(btn_setbookmark, "CANFOCUS", "No")		
	
	'Next BookMark
	btn_nextbookmark = IupButton(NULL, NULL)

	IupSetAttribute(btn_nextbookmark, "IMAGE", "img_next_bookmark")

	IupSetAttribute(btn_nextbookmark, "FLAT", "Yes")

	IupSetCallback(btn_nextbookmark, "ACTION", cast(any ptr , @item_bookmarks_next_callback()))

	IupSetAttribute(btn_nextbookmark, "TIP", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"toolnextbook"))

	IupSetAttribute(btn_nextbookmark, "CANFOCUS", "No")
	
	'Prev BookMark
	btn_prevbookmark = IupButton(NULL, NULL)

	IupSetAttribute(btn_prevbookmark, "IMAGE", "img_prev_bookmark")

	IupSetAttribute(btn_prevbookmark, "FLAT", "Yes")

	IupSetCallback(btn_prevbookmark, "ACTION", cast(any ptr , @item_bookmarks_prev_callback()))

	IupSetAttribute(btn_prevbookmark, "TIP", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"toolprevbook"))

	IupSetAttribute(btn_prevbookmark, "CANFOCUS", "No")
	
	'Delete All BookMarks
	btn_deletebookmarks = IupButton(NULL, NULL)

	IupSetAttribute(btn_deletebookmarks, "IMAGE", "img_delete_bookmark")

	IupSetAttribute(btn_deletebookmarks, "FLAT", "Yes")

	IupSetCallback(btn_deletebookmarks, "ACTION", cast(any ptr , @item_bookmarks_clear_all_callback()))

	IupSetAttribute(btn_deletebookmarks, "TIP", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"tooldeletebook"))

	IupSetAttribute(btn_deletebookmarks, "CANFOCUS", "No")
	
	'Indent
	btn_indent = IupButton(NULL, NULL)

	IupSetAttribute(btn_indent, "IMAGE", "img_indent")

	IupSetAttribute(btn_indent, "FLAT", "Yes")

	IupSetCallback(btn_indent, "ACTION", cast(any ptr , @item_indent_callback()))

	IupSetAttribute(btn_indent, "TIP", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"toolindent")) 

	IupSetAttribute(btn_indent, "CANFOCUS", "No")	
	
	'No Indent
	btn_noindent = IupButton(NULL, NULL)

	IupSetAttribute(btn_noindent, "IMAGE", "img_no_indent")

	IupSetAttribute(btn_noindent, "FLAT", "Yes")

	IupSetCallback(btn_noindent, "ACTION", cast(any ptr , @item_no_indent_callback()))

	IupSetAttribute(btn_noindent, "TIP", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"tooloutdent"))

	IupSetAttribute(btn_noindent, "CANFOCUS", "No")	
	
	'Comment
	btn_comment = IupButton(NULL, NULL)

	IupSetAttribute(btn_comment, "IMAGE", "img_comment")

	IupSetAttribute(btn_comment, "FLAT", "Yes")

	IupSetCallback(btn_comment, "ACTION", cast(any ptr , @item_comment_callback()))

	IupSetAttribute(btn_comment, "TIP", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"toolcomment"))

	IupSetAttribute(btn_comment, "CANFOCUS", "No")
	
	'UnComment
	btn_uncomment = IupButton(NULL, NULL)

	IupSetAttribute(btn_uncomment, "IMAGE", "img_un_comment")

	IupSetAttribute(btn_uncomment, "FLAT", "Yes")

	IupSetCallback(btn_uncomment, "ACTION", cast(any ptr , @item_uncomment_callback()))

	IupSetAttribute(btn_uncomment, "TIP", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"tooluncomment"))

	IupSetAttribute(btn_uncomment, "CANFOCUS", "No")				
							
	'Compile
	btn_compile = IupButton(NULL, NULL)

	IupSetAttribute(btn_compile, "IMAGE", "img_compile")

	IupSetAttribute(btn_compile, "FLAT", "Yes")

	IupSetCallback(btn_compile, "ACTION", cast(any ptr , @item_compile_callback()))

	IupSetAttribute(btn_compile, "TIP", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"toolcompile"))

	IupSetAttribute(btn_compile, "CANFOCUS", "No")
	
	'Run
	btn_run = IupButton(NULL, NULL)

	IupSetAttribute(btn_run, "IMAGE", "img_run")

	IupSetAttribute(btn_run, "FLAT", "Yes")

	IupSetCallback(btn_run, "ACTION", cast(any ptr , @item_run_callback()))

	IupSetAttribute(btn_run, "TIP", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"toolrun"))

	IupSetAttribute(btn_run, "CANFOCUS", "No")
	
	'Compile and Run
	btn_compileandrun = IupButton(NULL, NULL)

	IupSetAttribute(btn_compileandrun, "IMAGE", "img_compile_and_run")

	IupSetAttribute(btn_compileandrun, "FLAT", "Yes")

	IupSetCallback(btn_compileandrun, "ACTION", cast(any ptr , @item_compile_and_run_callback()))

	IupSetAttribute(btn_compileandrun, "TIP", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"toolcompileandrun"))

	IupSetAttribute(btn_compileandrun, "CANFOCUS", "No")
	
	'Quick Run
	btn_quickrun = IupButton(NULL, NULL)

	IupSetAttribute(btn_quickrun, "IMAGE", "img_quick_run")

	IupSetAttribute(btn_quickrun, "FLAT", "Yes")

	IupSetCallback(btn_quickrun, "ACTION", cast(any ptr , @item_quick_run_callback()))

	IupSetAttribute(btn_quickrun, "TIP", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"toolquickrun"))

	IupSetAttribute(btn_quickrun, "CANFOCUS", "No")	
	
	list_combo = IupList(NULL)
	
	IupSetAttribute(list_combo, "MAXSIZE", "160x")
	
	IupSetAttributes(list_combo, "DROPDOWN=YES")	
	
	IupSetCallback(list_combo, "ACTION", Cast(Any Ptr, @list_combo_build_callback()))
	
	IupSetAttribute(list_combo, "NAME" , "comboselectbuild")
	
	For i As Long  = 1 To 100
		
		If *IupConfigGetVariableStr(TGlobalVariables->hConfig, "BUILD" , "n" & i) <> "" Then
			
			IupSetAttribute(list_combo , Str(i) , *IupConfigGetVariableStr(TGlobalVariables->hConfig, "BUILD" , "n" & i) )
			
		Else	
			
			Exit For
			
		EndIf
		
	Next	
	
	IupSetAttribute(list_combo , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig, "BUILD" , "current") )
	
	btn_encoding = IupButton(NULL, NULL)

	IupSetAttribute(btn_encoding, "IMAGE", "img_encoding")

	IupSetAttribute(btn_encoding, "FLAT", "Yes")

	IupSetCallback(btn_encoding, "ACTION", cast(any ptr , @encoding_menu_popup_callback()))

	IupSetAttribute(btn_encoding, "TIP", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"toolencoding"))

	IupSetAttribute(btn_encoding, "CANFOCUS", "No")	
	
	Var hb = IupHbox(list_combo, NULL)
	
	IupSetAttribute(hb, "MARGIN", "7x")
	
	hToolbar = IupHbox(_
	btn_new,_
	btn_open,_
	btn_save,_
	btn_saveall,_
	IupSetAttributes(IupLabel(NULL), "SEPARATOR=VERTICAL"),_
	btn_cut,_
	btn_copy,_
	btn_paste,_
	btn_delete,_
	IupSetAttributes(IupLabel(NULL), "SEPARATOR=VERTICAL"),_
	btn_undo,_
	btn_redo,_
	IupSetAttributes(IupLabel(NULL), "SEPARATOR=VERTICAL"),_
	btn_find,_
	btn_replace,_
	IupSetAttributes(IupLabel(NULL), "SEPARATOR=VERTICAL"),_
	btn_setbookmark,_
	btn_prevbookmark,_
	btn_nextbookmark,_
	btn_deletebookmarks,_
	IupSetAttributes(IupLabel(NULL), "SEPARATOR=VERTICAL"),_
	btn_indent,_
	btn_noindent,_
	btn_comment,_
	btn_uncomment,_
	IupSetAttributes(IupLabel(NULL), "SEPARATOR=VERTICAL"),_
	btn_compile,_
	btn_run,_
	btn_compileandrun,_
	btn_quickrun,_
	hb,_
	btn_encoding,_
	NULL)	
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"ChildParam","toolbarvisible") = "1" Then
	
		IupSetAttribute(hToolbar, "FLOATING", "NO" )
	
		IupSetAttribute(hToolbar, "VISIBLE", "YES")
	
	Else
		
		IupSetAttribute(hToolbar, "FLOATING", "YES" )
	
		IupSetAttribute(hToolbar, "VISIBLE", "NO")		
	
	EndIf
	
	Return hToolbar
	
End Function
