Dim Shared As ZString*13 sDimAutoEndsKeywords(1 To 19) = {"function" , "sub" , "type" , "scope" , "union" , "enum" ,_
"namespace" , "with" , "extern" , "constructor" , "destructor" , "operator" , "property" , "wend" , "loop" , "next" , "endif" , "select" , "#endif"}

ReDim Shared As Byte bDimFlagLinesAutoEnds(0)

Function k_function_proc(sLineText As String) As Integer
	
	If Len(sLineText) < 15 Then Return 0
	
	If Left(sLineText,9) = "function " Then
		
		If InStr(sLineText , " as ") Then
			
			Return 1
			
		EndIf
		
	EndIf
	
End Function

Function k_private_proc(sLineText As String) As Integer
	
	If Len(sLineText) < 15 Then Return 0
	
	If Left(sLineText,8) = "private " Then
		
		If InStr(sLineText , " function ") Then
			
			If InStr(sLineText , " as ") Then
				
				Return 1
				
			EndIf
			
		ElseIf InStr(sLineText , " sub ") Then
			
			Return 2
			
		EndIf
		
	EndIf
	
End Function

Function k_public_proc(sLineText As String) As Integer
	
	If Len(sLineText) < 14 Then Return 0
	
	If Left(sLineText,7) = "public " Then
		
		If InStr(sLineText , " function ") Then
			
			If InStr(sLineText , " as ") Then
				
				Return 1
				
			EndIf
			
		ElseIf InStr(sLineText , " sub ") Then
			
			Return 2
			
		EndIf
		
	EndIf
	
End Function

Function k_static_proc(sLineText As String) As Integer
	
	If Len(sLineText) < 14 Then Return 0
	
	If Left(sLineText,7) = "static " Then
		
		If InStr(sLineText , " function ") Then
			
			If InStr(sLineText , " as ") Then
				
				Return 1
				
			EndIf
			
		ElseIf InStr(sLineText , " sub ") Then
			
			Return 2
			
		EndIf
		
	EndIf
	
End Function

Function k_sub_proc(sLineText As String) As Integer
	
	If Len(sLineText) < 7 Then Return 0
	
	If Left(sLineText,4) = "sub " Then
		
		If InStr(sLineText , ")") Then
			
			Return 1
			
		EndIf
		
	EndIf
	
End Function

Function k_type_proc(sLineText As String) As Integer
	
	If Len(sLineText) < 6 Then Return 0
	
	If Left(sLineText,5) = "type " Then
		
		If InStr(sLineText , " as ") Then
			
			Return 0
			
		EndIf
		
		Return 1
		
	EndIf
	
End Function

Function k_scope_proc(sLineText As String) As Integer
	
	Dim As Integer iLen = Len(sLineText)
	
	If iLen < 5 Then Return 0
	
	If Left(sLineText,5) = "scope" Then
		
		If iLen = 5 OrElse Mid(sLineText , 6 , 1) = " " Then
			
			Return 1
			
		EndIf
		
	EndIf
	
End Function

Function k_union_proc(sLineText As String) As Integer
	
	Dim As Integer iLen = Len(sLineText)
	
	If iLen < 5 Then Return 0
	
	If Left(sLineText,5) = "union" Then
		
		If iLen = 5 OrElse Mid(sLineText , 6 , 1) = " " Then
			
			Return 1
			
		EndIf
		
	EndIf
	
End Function

Function k_enum_proc(sLineText As String) As Integer
	
	Dim As Integer iLen = Len(sLineText)
	
	If iLen < 4 Then Return 0
	
	If Left(sLineText,4) = "enum" Then
		
		If iLen = 4 OrElse Mid(sLineText , 5 , 1) = " " Then
			
			Return 1
			
		EndIf
		
	EndIf
	
End Function

Function k_namespace_proc(sLineText As String) As Integer
	
	If Len(sLineText) < 11 Then Return 0
	
	If Left(sLineText,10) = "namespace " Then
		
		Return 1
		
	EndIf
	
End Function

Function k_with_proc(sLineText As String) As Integer
	
	If Len(sLineText) < 5 Then Return 0
	
	If Left(sLineText,5) = "with " Then
		
		Return 1
		
	EndIf
	
End Function

Function k_extern_proc(sLineText As String) As Integer
	
	If Len(sLineText) < 8 Then Return 0
	
	If Left(sLineText,7) = "extern " Then
		
		If InStr(sLineText , " as ") Then
			
			Return 0
			
		EndIf
		
		Return 1
		
	EndIf
	
End Function

Function k_constructor_proc(sLineText As String) As Integer
	
	If Len(sLineText) < 12 Then Return 0
	
	If Left(sLineText,12) = "constructor " Then
		
		Return 1
		
	EndIf
	
End Function

Function k_destructor_proc(sLineText As String) As Integer
	
	If Len(sLineText) < 11 Then Return 0
	
	If Left(sLineText,11) = "destructor " Then
		
		Return 1
		
	EndIf
	
End Function

Function k_operator_proc(sLineText As String) As Integer
	
	If Len(sLineText) < 11 Then Return 0
	
	If Left(sLineText,9) = "operator " Then
		
		If InStr(sLineText , ")") Then
			
			Return 1
			
		EndIf
		
	EndIf
	
End Function

Function k_property_proc(sLineText As String) As Integer
	
	If Len(sLineText) < 11 Then Return 0
	
	If Left(sLineText,9) = "property " Then
		
		If InStr(sLineText , ")") Then
			
			Return 1
			
		EndIf
		
	EndIf
	
End Function

Function k_while_proc(sLineText As String) As Integer
	
	If Len(sLineText) < 7 Then Return 0
	
	If Left(sLineText,6) = "while " Then
		
		Return 1
		
	EndIf
	
End Function

Function k_do_proc(sLineText As String) As Integer
	
	Dim As Integer iLen = Len(sLineText)
	
	If iLen < 2 Then Return 0
	
	If Left(sLineText,2) = "do" Then
		
		If iLen = 2 OrElse Mid(sLineText , 3 , 1) = " " Then
			
			Return 1
			
		EndIf
		
	EndIf
	
End Function

Function k_for_proc(sLineText As String) As Integer
	
	If Len(sLineText) < 12 Then Return 0
	
	If Left(sLineText,4) = "for " Then
		
		If InStr(sLineText , " to ") Then
			
			Return 1
			
		EndIf
		
	EndIf
	
End Function

Function k_if_proc(sLineText As String) As Integer
	
	If Len(sLineText) < 7 Then Return 0
	
	If Left(sLineText,3) = "if " Then
		
		dim as Long iPos = instr(3, sLineText , " then")
		
		If iPos Then
			
			if len(sLineText) = iPos+4 then
				
				return 1
				
			else
				
				for i as Long = iPos+4 to len(sLineText)-1
					
					select case sLineText[i]
						
						Case 32 , 9 
						
							continue for
						
						case 39 
						
							function = 1
						
							exit for
						
						case else
						
							exit for
						
					End Select 
					
				Next
				
			EndIf
			
		EndIf
		
	EndIf
	
End Function

Function k_select_proc(sLineText As String) As Integer
	
	If Len(sLineText) < 13 Then Return 0
	
	If Left(sLineText,7) = "select " Then
		
		If InStr(sLineText , " case ") Then
			
			Return 1
			
		EndIf
		
	EndIf
	
End Function

Function k_m_if_proc(sLineText As String) As Integer
	
	If Len(sLineText) < 5 Then Return 0
	
	If Left(sLineText,4) = "#if " Then
		
		Return 1
		
	EndIf
	
End Function

Function get_autocomplect_proc(iLine As Integer , sAdded As String) As Integer
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	Dim As Ihandle Ptr mt = TGlobalVariables->tTabsOptions(idTabs).multitext
	
	Dim As String sTextLine = *IupGetAttribute(mt , "LINE" & iLine)
	
	Dim As Integer iL1  = Len(sTextLine), iL2
	
	If iL1 < 2 Then Return 0
	
	Dim As String sTextL = LTrim(sTextLine , Any Chr(9) & " ")
	
	sAdded = Left(sTextLine , iL1 - Len(sTextL) )
	
	sTextL = RTrim(sTextL , Any Chr(9) & Chr(32) & Chr(13) & Chr(10))
	
	iL2 = Len(sTextL)
	
	If iL2 < 2 OrElse InStr(sTextL , ":") Then Return 0
	
	sTextL = LCase(sTextL)
	
	Select Case Left(sTextL , 1)
		
		Case "f"
		
			if k_for_proc(sTextL) Then Return 16
		
			If k_function_proc(sTextL) Then Return 1
		
		Case "s"
		
			if k_sub_proc(sTextL) Then Return 2
		
			If k_scope_proc(sTextL) Then Return 4
		
			If k_select_proc(sTextL) Then Return 18
		
			Return k_static_proc(sTextL)
		
		Case "t"
		
			if k_type_proc(sTextL) Then Return 3
		
		Case "u"
		
			if k_union_proc(sTextL) Then Return 5
		
		Case "e"
		
			if k_enum_proc(sTextL) Then Return 6
		
			if k_extern_proc(sTextL) Then Return 9
		
		Case "n"
		
			if k_namespace_proc(sTextL) Then Return 7
		
		Case "w"
		
			if k_with_proc(sTextL) Then Return 8
		
			if k_while_proc(sTextL) Then Return 14
		
		Case "c"
		
			if k_constructor_proc(sTextL) Then Return 10
		
		Case "d"
		
			if k_do_proc(sTextL) Then Return 15
		
			if k_destructor_proc(sTextL) Then Return 11
		
		Case "o"
		
			if k_operator_proc(sTextL) Then Return 12
		
		Case "p"
		
			if k_property_proc(sTextL) Then Return 13
		
			Select Case  k_private_proc(sTextL)
			
				Case 1
			
					Return 1
			
				Case 2
			
					Return 2
			
			End Select
		
			Return k_public_proc(sTextL)
		
		Case "i"
		
			if k_if_proc(sTextL) Then Return 17
		
		Case "#"
		
			if k_m_if_proc(sTextL) Then Return 19
		
	End Select
	
End Function

Sub cursor_on_column_proc(iLine As Integer , sAdded As String)
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	Dim As Ihandle Ptr mt = TGlobalVariables->tTabsOptions(idTabs).multitext
	
	Dim As Integer iPos = IupGetInt(mt, "CARETPOS")
	
	If Len(sAdded) Then
		
		IupSetAttribute(mt, "INSERT-1", sAdded )
		
		iPos = iPos + Len(sAdded)
		
	Else
		
		Dim As String sTextLine = *IupGetAttribute(mt , "LINE" & iLine)
		
		Dim As Integer iL1  = Len(sTextLine)
		
		Dim As String sTextL = LTrim(sTextLine , Any Chr(9) & " ")
		
		Dim As String sAdded = Left(sTextLine , iL1 - Len(sTextL) )
		
		If Len(sAdded) Then
			
			IupSetAttribute(mt, "INSERT-1", sAdded )
			
			iPos = iPos + Len(sAdded)
			
		EndIf
		
	EndIf
	
	IupSetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "CARETPOS", iPos)
	
	IupSetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "SCROLLTOPOS", iPos)
	
	
End Sub

Sub autocomplect_proc(iLine As Integer)
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	Dim As Ihandle ptr mt = TGlobalVariables->tTabsOptions(idTabs).multitext
	
	Dim As String EOL
	
	Dim As Integer iPos = IupGetInt(mt, "CARETPOS")
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Editor" , "lineends") = "WIN" Then
		
		EOL = Chr(13) & Chr(10)
		
	Else
		
		EOL = Chr(10)
		
	EndIf
	
	Dim As String sAdded
	
	Dim As Integer iResult = get_autocomplect_proc(iLine , sAdded)
	
	Dim As String sAddedFull = Chr(9) & EOL & sAdded & Chr(9) & EOL & EOL & sAdded
	
	Select Case iResult
		
		Case 0
		
			cursor_on_column_proc(iLine  , sAdded )
		
		Case 1 ' FUNCTION
		
			IupSetAttribute(mt, "INSERT-1", sAddedFull & "End Function")
		
		Case 2 ' SUB
		
			IupSetAttribute(mt, "INSERT-1", sAddedFull & "End Sub")
		
		Case 3  'TYPE
		
			IupSetAttribute(mt, "INSERT-1", sAddedFull & "End Type")
		
		Case 4  'SCOPE
		
			IupSetAttribute(mt, "INSERT-1", sAddedFull & "End Scope")
		
		Case 5  'UNION
		
			IupSetAttribute(mt, "INSERT-1", sAddedFull & "End Union")
		
		Case 6  'ENUM
		
			IupSetAttribute(mt, "INSERT-1", sAddedFull & "End Enum")
		
		Case 7  'NAMESPACE
		
			IupSetAttribute(mt, "INSERT-1", sAddedFull & "End Namespace")
		
		Case 8  'WITH
		
			IupSetAttribute(mt, "INSERT-1", sAddedFull & "End With")
		
		Case 9  'EXTERN
		
			IupSetAttribute(mt, "INSERT-1", sAddedFull & "End Extern")
		
		Case 10 'CONSTRUCTOR
		
			IupSetAttribute(mt, "INSERT-1", sAddedFull & "End Constructor")
		
		Case 11 'DESTRUCTOR
		
			IupSetAttribute(mt, "INSERT-1", sAddedFull & "End Destructor")
		
		Case 12 'OPERATOR
		
			IupSetAttribute(mt, "INSERT-1", sAddedFull & "End Operator")
		
		Case 13 'PROPERTY
		
			IupSetAttribute(mt, "INSERT-1", sAddedFull & "End Property")
		
		Case 14 'WHILE
		
			IupSetAttribute(mt, "INSERT-1", sAddedFull & "Wend")
		
		Case 15 'DO
		
			IupSetAttribute(mt, "INSERT-1", sAddedFull & "Loop")
		
		Case 16 'FOR
		
			IupSetAttribute(mt, "INSERT-1", sAddedFull & "Next")
		
		Case 17 'IF
		
			IupSetAttribute(mt, "INSERT-1", sAddedFull & "EndIf")
		
		Case 18 'SELECT
		
			IupSetAttribute(mt, "INSERT-1", Chr(9) & EOL & sAdded & Chr(9) & "Case " & EOL & EOL & sAdded & "End Select")
		
			iPos +=5
		
		Case 19 '#If
		
			IupSetAttribute(mt, "INSERT-1", sAddedFull & "#EndIf")
		
	End Select
	
	If iResult Then
		
		iPos  = iPos + Len(sAdded) + 2 + Len(EOL)
		
		IupSetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "CARETPOS", iPos)
		
		IupSetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "SCROLLTOPOS", iPos)
		
	EndIf
	
End Sub

Function autoindent0_proc(mt As Ihandle Ptr , iLine As Integer , iId As Long) As Integer
	
	Dim As Integer iLine2 = iLine
	
	Dim As String sIndent
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","indent") = "TAB" Then
		
		sIndent = Chr(9)
		
	Else
		
		sIndent = Space(Val(*IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","indentsize")))
		
	EndIf   
	
	Do
		
		Dim As String sTextLine = *IupGetAttribute(mt , "LINE" & iLine2)
		
		If Len(sTextLine) < 2 Then
			
			iLine2 +=1
			
			If IupGetInt(mt, "LINECOUNT") < iLine2 Then Exit Do
			
			Continue Do
			
		EndIf
		
		Select Case iId
			
			Case 1 To 13 , 17 ,18
			
				If iId = 17 Then
				
					If LCase(Left(sTextLine , 5)) =  "endif" Then
					
						If (iLine2 - iLine) > 0 Then
							
							For j As Integer = iLine To iLine2-1
								
								Dim As String sTextTemp = *IupGetAttribute(mt , "LINE" & j)
								
								If Len(sTextTemp) >=4 Then
									
									If LCase(Left(sTextTemp,4)) = "else" Then
										
										If bDimFlagLinesAutoEnds(j) = 0 Then
											
											bDimFlagLinesAutoEnds(j) = 1
											
											Continue For
											
										EndIf 
										
									EndIf
									
								EndIf
								
								Dim As Integer iPos
								
								IupTextConvertLinColToPos(mt, j , 0 , cast(any ptr,@iPos))
								
								IupSetAttribute(mt, "INSERT" & iPos, sIndent)
								
							Next
							
						EndIf
					
						iLine2+=1
					
						Exit Do
					
					EndIf
				
				EndIf
			
			
				If LCase(Left(sTextLine , 4)) =  "end " Then
				
					Dim i As Long
				
					For i = 5 To Len(sTextLine)
					
						If Mid(sTextLine, i , 1) <> " " Then
							
							Exit For
							
						EndIf
					
					Next
				
					If LCase(Mid(sTextLine, i , Len(sDimAutoEndsKeywords(iId)))) = sDimAutoEndsKeywords(iId) OrElse ( iId = 17 AndAlso (LCase(Mid(sTextLine, i , 2)) = "if")) Then
					
						If (iLine2 - iLine) > 0 Then
							
							For j As Integer = iLine To iLine2-1
								
								If iId = 17 Then
									
									Dim As String sTextTemp = *IupGetAttribute(mt , "LINE" & j)
									
									If Len(sTextTemp) >=4 Then
										
										If LCase(Left(sTextTemp,4)) = "else" Then
											
											If bDimFlagLinesAutoEnds(j) = 0 Then
												
												bDimFlagLinesAutoEnds(j) = 1
												
												Continue For
												
											EndIf      
											
										EndIf
										
									EndIf
									
								ElseIf iId = 18 Then  
									
									Dim As String sTextTemp = *IupGetAttribute(mt , "LINE" & j)
									
									dim as Long iLen = Len(sTextTemp)
									
									If (iLen < 5) orelse ((iLen >=5) andalso (LCase(Left(sTextTemp,5)) <> "case ")) Then
										
										Dim As Integer iPos
										
										IupTextConvertLinColToPos(mt, j , 0 , cast(any ptr,@iPos))
										
										IupSetAttribute(mt, "INSERT" & iPos, sIndent)                                 									
										
									EndIf                           
									
								EndIf
								
								Dim As Integer iPos
								
								IupTextConvertLinColToPos(mt, j , 0 , cast(any ptr,@iPos))
								
								IupSetAttribute(mt, "INSERT" & iPos, sIndent)
								
							Next
							
						EndIf
					
						iLine2+=1
					
						Exit Do
					
					EndIf
				
				EndIf
			
			Case 14 To 16 , 19
			
				If (LCase(Left(sTextLine , Len(sDimAutoEndsKeywords(iId)))) = sDimAutoEndsKeywords(iId)) Then
				
					if (len(sTextLine) = Len(sDimAutoEndsKeywords(iId))) orelse sTextLine[Len(sDimAutoEndsKeywords(iId))] = 32 orelse _
					sTextLine[Len(sDimAutoEndsKeywords(iId))] = 39 orelse sTextLine[Len(sDimAutoEndsKeywords(iId))] = 13 orelse _
					sTextLine[Len(sDimAutoEndsKeywords(iId))] = 9 orelse sTextLine[Len(sDimAutoEndsKeywords(iId))] = 10 then
				
					If (iLine2 - iLine) > 0 Then
					
						For j As Integer = iLine To iLine2-1
							
							Dim As String sTextTemp = *IupGetAttribute(mt , "LINE" & j)
							
							If iId = 19 Then
								
								If Len(sTextTemp) >=5 Then
									
									If LCase(Left(sTextTemp,5)) = "#else" Then
										
										If bDimFlagLinesAutoEnds(j) = 0 Then
											
											bDimFlagLinesAutoEnds(j) = 1
											
											Continue For
											
										EndIf 
										
									EndIf
									
								EndIf
								
							EndIf
							
							Dim As Integer iPos
							
							IupTextConvertLinColToPos(mt, j , 0 , cast(any ptr,@iPos))
							
							IupSetAttribute(mt, "INSERT" & iPos, sIndent)
							
						Next
					
					EndIf
				
					iLine2+=1
				
					Exit Do
				
				endif
			
				EndIf
			
		End Select
		
		Dim As String sAdded
		
		Dim As Integer iRet = get_autocomplect_proc(iLine2 , sAdded)
		
		If iRet Then
			
			iLine2 = autoindent0_proc(mt , iLine2+1 , iRet)
			
		Else
			
			iLine2 +=1
			
		EndIf
		
		If IupGetInt(mt, "LINECOUNT") < iLine2 Then Exit Do
		
	Loop
	
	Return iLine2
	
End Function

Sub autoindent_proc()
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Exit Sub
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	Dim As Ihandle ptr mt = TGlobalVariables->tTabsOptions(idTabs).multitext
	
	Dim As Integer iLine  , iLineCount = IupGetInt(mt, "LINECOUNT")
	
	If iLineCount < 3 Then Exit Sub
	
	ReDim As Byte bDimFlagLinesAutoEnds(iLineCount)
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "BEGIN")
	
	tab_to_spaces_begin_proc()
	
	remove_leading_spaces_proc(mt)
	
	Dim As String sAdded
	
	Do
		
		Dim As Integer iRet = get_autocomplect_proc(iLine , sAdded)
		
		If iRet Then
			
			iLine = autoindent0_proc(mt , iLine + 1 , iRet)
			
		Else
			
			iLine +=1
			
		EndIf  
		
		If iLineCount <= iLine Then Exit Do
		
	Loop
	
	ReDim As Byte bDimFlagLinesAutoEnds(0)
	
	IupSetAttribute(mt, "ISCHANGES", "YES")
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "END")
	
End Sub
