
' ######################################Callback######################################
' ####################################################################################
' ####################################################################################


' ############################# MENU and TOOLBAR

' Close main dialog
Function close_dialog_callback Cdecl(dlg As Ihandle Ptr) As Integer
	
	If item_close_proc (0) = IUP_IGNORE Then return IUP_IGNORE
	
	de_init_IUP_proc()
	
	return IUP_CLOSE
	
End Function

' New
Function item_new_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	new_file_proc()
	
	return IUP_DEFAULT
	
End Function

' Open
Function item_open_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	Dim As ZString Ptr pszPath = open_dialog_files_proc()
	
	open_file_proc (pszPath)
	
	return IUP_DEFAULT
	
End Function

' Save as
Function item_save_as_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	save_as_proc(idTabs)
	
	return IUP_DEFAULT
	
End Function

' Save
Function item_save_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	save_proc(idTabs)
	
	return IUP_DEFAULT
	
End Function

' Save all
Function item_save_all_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	save_all_proc()
	
	return IUP_DEFAULT
	
End Function

' Close
Function item_close_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	return item_close_proc(Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS")))
	
End Function

' Close all
Function item_close_all_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	return item_close_proc (0)
	
End Function

'Recent files
Function config_recent_callback Cdecl (ih As Ihandle Ptr) As Long
	
	Dim As ZString Ptr pszFilename = IupGetAttribute(ih, "TITLE")
	
	Dim As ZString*256 szTempBufPath = *pszFilename
	
	Dim As ZString*2 szEncZero = ""
	
	Dim As Integer iSizeRet
	
	Dim As ZString Ptr pszEncPath = Cast(ZString Ptr,encode_buffer_proc(StrPtr(szEncZero),"UTF-8", Cast(Byte Ptr,@szTempBufPath), Len(szTempBufPath) , iSizeRet))
	
	open_file_proc(pszEncPath)
	
	If pszEncPath Then DeAllocate (pszEncPath)
	
	return IUP_DEFAULT
	
End Function

' Exit
Function item_exit_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	de_init_IUP_proc()
	
	return IUP_CLOSE
	
End Function

' Undo
Function item_undo_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext  , "UNDO", "YES")
	
	return IUP_DEFAULT
	
End Function

' Redo
Function item_redo_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext  , "REDO", "YES")
	
	return IUP_DEFAULT
	
End Function

' Cut
Function item_cut_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext, SCI_CUT,  0 ,  0 ) 
	
	return IUP_DEFAULT
	
End Function

' Copy
Function item_copy_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext, SCI_COPY,  0 ,  0 ) 
	
	return IUP_DEFAULT
	
End Function

' Paste
Function item_paste_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext, SCI_PASTE,  0 ,  0 ) 
	
	return IUP_DEFAULT
	
End Function

' Delete
Function item_delete_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "SELECTEDTEXT", "")
	
	Return IUP_DEFAULT
	
End Function

' Bookmarks Toggle
Function item_bookmarks_toggle_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	Dim As integer iPos = IupGetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "CARETPOS")
	
	Dim As Integer iLine, iColumn
	
	IupTextConvertPosToLinCol(TGlobalVariables->tTabsOptions(idTabs).multitext, iPos, cast(any ptr,@iLine), cast(any ptr,@iColumn))
	
	toggle_marker_proc(TGlobalVariables->tTabsOptions(idTabs).multitext, iLine, 1)
	
	return IUP_DEFAULT
	
End Function

' Bookmarks Next
Function item_bookmarks_next_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Return bookmark_next_prev(ih , 1)
	
End Function

' Bookmarks Prev
Function item_bookmarks_prev_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Return bookmark_next_prev(ih , 0)
	
End Function

' Bookmarks Clear All
Function item_bookmarks_clear_all_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	IupSetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "MARKERDELETEALL", 0)
	
	return IUP_DEFAULT
	
End Function

' TRIM spaces in trailing
Function item_space_trim_trailing_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "BEGIN")
	
	remove_trailing_spaces_proc(TGlobalVariables->tTabsOptions(idTabs).multitext)
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "END")
	
	return IUP_DEFAULT
	
End Function

' TRIM spaces in leading
Function item_space_trim_leading_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "BEGIN")
	
	remove_leading_spaces_proc(TGlobalVariables->tTabsOptions(idTabs).multitext)
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "END")
	
	return IUP_DEFAULT
	
End Function

' TRIM spaces in trailing and leading
Function item_space_trim_trailing_and_leading_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "BEGIN")
	
	remove_leading_spaces_proc(TGlobalVariables->tTabsOptions(idTabs).multitext)
	
	remove_trailing_spaces_proc(TGlobalVariables->tTabsOptions(idTabs).multitext)
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "END")	
	
	return IUP_DEFAULT
	
End Function

' Spaces to Tabs begin
Function item_space_to_tab_begin_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "BEGIN")
	
	tab_to_spaces_begin_proc()
	
	spaces_to_tab_begin_proc()
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "END")
	
	return IUP_DEFAULT
	
End Function

' Spaces to Tabs
Function item_space_to_tab_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "BEGIN")
	
	tab_to_spaces_proc()
	
	spaces_to_tab_proc()
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "END")
	
	return IUP_DEFAULT
	
End Function

' Tabs to Spaces
Function item_tab_to_space_begin_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "BEGIN")
	
	tab_to_spaces_begin_proc()
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "END")
	
	return IUP_DEFAULT
	
End Function

' Tabs to Spaces
Function item_tab_to_space_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "BEGIN")
	
	tab_to_spaces_proc()
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "END")
	
	return IUP_DEFAULT
	
End Function

' Simvols to lowercase
Function item_convert_lower_case_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	convert_lower_or_upper_case_proc(0)
	
	return IUP_DEFAULT
	
End Function

' Simvols to uppercase
Function item_convert_upper_case_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	convert_lower_or_upper_case_proc(1)
	
	return IUP_DEFAULT
	
End Function

' Select all text
Function item_select_all_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	IupSetFocus(TGlobalVariables->tTabsOptions(idTabs).multitext)
	
	Dim As Integer count = IupGetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "COUNT")
	
	IupSetStrf(TGlobalVariables->tTabsOptions(idTabs).multitext, "SELECTIONPOS", !"%d:%d", 0, count)
	
	return IUP_DEFAULT
	
End Function

' autoindent
Function item_autoindent_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	autoindent_proc()
	
	return IUP_DEFAULT
	
End Function

' Zoom plus
Function item_view_zoom_plus_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "ZOOMIN", "10")
	
	return IUP_DEFAULT
	
End Function

' Zoom minus
Function item_view_zoom_minus_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "ZOOMOUT", "10")
	
	return IUP_DEFAULT
	
End Function

' Zoom default
Function item_view_zoom_default_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "ZOOM", "0")	
	
	return IUP_DEFAULT
	
End Function

' Word Wrap
Function item_view_word_wrap_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	if (IupGetInt(ih, "VALUE")) Then
		
		IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "WORDWRAP", "WORD")
		
	Else
		
		IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "WORDWRAP", "NONE")
		
	EndIf
	
	return IUP_DEFAULT
	
End Function

' Show White Spaces
Function item_view_show_white_spaces_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	if (IupGetInt(ih, "VALUE")) Then
		
		IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "WHITESPACEVIEW", "VISIBLEALWAYS")
		
	Else
		
		IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "WHITESPACEVIEW", "INVISIBLE")
		
	EndIf
	
	return IUP_DEFAULT
	
End Function

' View toolbar
Function item_view_toolbar_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	child_widget_visibility_proc(TGlobalVariables->toolbar,ih)
	
	If *IupGetAttribute(TGlobalVariables->toolbar, "VISIBLE") = "YES" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig, "ChildParam", "toolbarvisible", "1")
		
	Else
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig, "ChildParam", "toolbarvisible", "0")
		
	EndIf
	
	return IUP_DEFAULT
	
End Function

' View statusbar
Function item_view_statusbar_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	child_widget_visibility_proc(TGlobalVariables->statusbar,ih)
	
	If *IupGetAttribute(TGlobalVariables->statusbar, "VISIBLE") = "YES" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig, "ChildParam", "statusbarvisible", "1")
		
	Else
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig, "ChildParam", "statusbarvisible", "0")
		
	EndIf
	
	return IUP_DEFAULT
	
End Function

' View Line Numbers
Function item_view_line_numbers_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	if (IupGetInt(ih, "VALUE")) Then
		
		IupSetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "MARGINWIDTH0", 30)
		
		IupSetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "MARGINWIDTH1", 15)
		
		If TGlobalVariables->bFlagFolding = 1 Then
			
			IupSetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "MARGINWIDTH2", 15)
			
		EndIf
		
	else
		
		IupSetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "MARGINWIDTH0", 0)
		
		IupSetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "MARGINWIDTH1", 0)
		
		If TGlobalVariables->bFlagFolding = 1 Then
			
			IupSetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "MARGINWIDTH2", 0)
			
		EndIf
		
	EndIf
	
	return IUP_DEFAULT
	
End Function

' Compile
Function item_compile_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	prepare_compile()
	
	return IUP_DEFAULT
	
End Function

' Run
Function item_run_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	start_program_proc()
	
	return IUP_DEFAULT
	
End Function

' Compile and Run
Function item_compile_and_run_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If prepare_compile() Then
		
		start_program_proc()
		
	EndIf
	
	return IUP_DEFAULT
	
End Function

' Quick Run
Function item_quick_run_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	quick_run_proc()
	
	return IUP_DEFAULT
	
End Function

' Run with debugger
Function item_debug_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	run_with_debug_proc()
	
	return IUP_DEFAULT
	
End Function

' TOOLS CUSTOM
Function item_tools_custom_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	Dim As Integer iPos = IupGetChildPos(IupGetParent(ih),ih)
	
	If iPos = -1 Then 
		
		return IUP_DEFAULT
		
	Else
		
		Dim As String sPath = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"TOOL","c" & (iPos+1))
		
		If Len(sPath) Then
			
					sPath = encode_path(sPath , 0)
			
			If Left(sPath , 2) = "$A" Then
				
				sPath = ExePath() & Mid( sPath , 3)
				
			EndIf
			
			#Ifdef __FB_WIN32__
			#Else
			
			sPath = replace_string_proc(sPath , " " , "\ " , , 1)
			
			#endif
			
					IupExecute(sPath, "")	
			
		EndIf	
		
	EndIf	
	
	return IUP_DEFAULT
	
End Function

' Help for FB help and custom helps
Function item_helps_custom_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	Dim As Integer iPos = IupGetChildPos(IupGetParent(ih),ih)
	
	If iPos = -1 Then 
		
		return IUP_DEFAULT
		
	ElseIf iPos = 0 Then 
		
		Dim As String sPath = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path","pathhelpfb")
		
		If Len(sPath) Then
			
			sPath = encode_path(sPath , 0)
			
			If Left(sPath , 2) = "$A" Then
				
				sPath = ExePath() & Mid( sPath , 3)
				
			EndIf
			
			#Ifdef __FB_WIN32__
			
			IupExecute(sPath, "")
			
			#else
			
			sPath = replace_string_proc(sPath , " " , "\ " , , 1)
			
			dim as string sBrowser = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path","pathbrowser")
			
			if len(sBrowser) then
				
				IupExecute(sBrowser, sPath)			
				
			endif			
			
			#endif
			
		EndIf
		
	Else
		
		Dim As String sPath = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"HELPF","c" & iPos)
		
		if len(sPath) then
			
			sPath = encode_path(sPath , 0)		
			
			If Left(sPath , 2) = "$A" Then
				
				sPath = ExePath() & Mid( sPath , 3)
				
			EndIf
			
			#Ifdef __FB_WIN32__
			
			IupExecute(sPath, "")
			
			#else
			
			if lcase(right(sPath , 5)) = ".html" orelse lcase(right(sPath , 4)) = ".htm" then
				
				dim as string sBrowser = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path","pathbrowser")
				
				sPath = replace_string_proc(sPath , " " , "\ " , , 1)
				
				if len(sBrowser) then
					
					IupExecute(sBrowser, sPath)			
					
				endif
				
			else
			
				IupExecute(sPath, "")				
				
			EndIf
			
			#endif
			
		endif
		
	EndIf
	
	return IUP_DEFAULT
	
End Function

' Help About
Function item_help_about_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuabout"),_
	*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"aboutmessage"))
	
	return IUP_DEFAULT
	
End Function


' ##################################### MARGIN ####################################

'marginclick
Function marginclick_callback Cdecl (ih As Ihandle Ptr, iMargin As Integer, iLine As Integer, pszStatus As ZString Ptr) As Integer
	
	If iMargin = 1 Then
		
		toggle_marker_proc(ih, iLine, iMargin)
		
	ElseIf TGlobalVariables->bFlagFolding = 1 AndAlso iMargin = 2 Then	
		
		IupSetfAttribute(ih, "FOLDTOGGLE", "%d", iLine)
		
	Else
		
		Return IUP_IGNORE
		
	EndIf
	
	return IUP_DEFAULT
	
End Function

' ##################################### GOTO ####################################

Function  goto_ok_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As integer iLineCount = IupGetInt(ih, "TEXT_LINECOUNT")
	
	Dim As Ihandle Ptr hTxt = IupGetDialogChild(ih, "LINE_TEXT")
	
	Dim As integer iLine = IupGetInt(hTxt, "VALUE")
	
	if iLine < 1 orelse iLine > iLineCount Then
		
		IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrorendtitle"),_
		*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"errorgoto"))
		
		return IUP_DEFAULT
		
	EndIf
	
	IupSetAttribute(IupGetDialog(ih), "STATUS", "1")
	
	return IUP_CLOSE
	
End Function

Function goto_cancel_callback Cdecl(ih As Ihandle Ptr) As Integer
	
	IupSetAttribute(IupGetDialog(ih), "STATUS", "0")
	
	return IUP_CLOSE
	
End Function

' Goto
Function item_goto_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	goto_proc ()
	
	return IUP_DEFAULT
	
End Function


' ##################################### FIND | REPLACE ####################################

' Find
Function item_find_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	find_replace_visibility_proc(0)	
	
	return IUP_DEFAULT
	
End Function

' Find Next
Function item_find_next_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->find_dlg, "FIND_DOWN") , "VALUE" , "ON")
	
	find_proc(0)
	
	return IUP_DEFAULT
	
End Function

' Find Prev
Function item_find_prev_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->find_dlg, "FIND_UP") , "VALUE" , "ON")
	
	find_proc(0)
	
	return IUP_DEFAULT
	
End Function

' Replace
Function item_replace_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	find_replace_visibility_proc(1)	
	
	return IUP_DEFAULT
	
End Function

Function find_close_action_callback Cdecl(dlg As Ihandle Ptr) As Integer
	
	IupHide(dlg)  
	
	return IUP_DEFAULT
	
End Function

Function find_cancel_action_callback Cdecl(ih As Ihandle Ptr) As Integer
	
	IupHide(TGlobalVariables->find_dlg)  
	
	return IUP_DEFAULT
	
End Function

Function find_btnfind_action_callback Cdecl(ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	find_proc(0)
	
	return IUP_DEFAULT
	
End Function

Function find_btnfindall_action_callback Cdecl(ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	find_proc(1)
	
	return IUP_DEFAULT
	
End Function

Function find_btnreplace_action_callback Cdecl(ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	replace_proc()
	
	return IUP_DEFAULT
	
End Function

Function find_btnreplaceall_action_callback Cdecl(ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	replace_all_proc()
	
	return IUP_DEFAULT
	
End Function


' ##################################### INDENT ####################################

' Indent
Function item_indent_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "BEGIN")
	
	indent_proc()
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "END")
	
	return IUP_DEFAULT
	
End Function

' No Indent
Function item_no_indent_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "BEGIN")
	
	outdent_proc()
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "END")
	
	return IUP_DEFAULT
	
End Function

' #################################### COMMENTS ##############################################

' Comment
Function item_comment_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	comment_proc()
	
	return IUP_DEFAULT
	
End Function

' UnComment
Function item_uncomment_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	uncomment_proc()
	
	return IUP_DEFAULT
	
End Function

' ######################################## CARET_CB ####################################

Function multitext_caret_callback Cdecl ( ih As Ihandle Ptr, iLine As integer, iColumn As Integer) As Integer
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	If TGlobalVariables->bFlagAutoComplect = 1 AndAlso TGlobalVariables->bLineAutocomplect = 1 Then
		
		autocomplect_proc(iLine - 1)
		
		TGlobalVariables->bLineAutocomplect = 0
		
	ElseIf TGlobalVariables->bLineAutocomplect = 1 Then
		
		cursor_on_column_proc(iLine - 1 , "")
		
		TGlobalVariables->bLineAutocomplect = 0
		
	EndIf
	
	Static iCurIndent As Integer
	
	dim as integer iLen = Len(Str(iLine+1))
	
	If iLen < 3 Then iLen = 3
	
	If iCurIndent <> iLen Then
		
		Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
		
		IupSetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "MARGINWIDTH0", Val(TGlobalVariables->szFontEditorSize)*iLen)
		
		iCurIndent = iLen
		
	EndIf
	
	Dim As integer iPos = IupGetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "CARETPOS")
	
	Dim As integer iPosEnd = IupGetIntId( TGlobalVariables->tTabsOptions(idTabs).multitext, "BRACEMATCH", iPos - 1 )
	
	if (iPosEnd >= 0) Then
		
		IupScintillaSendMessage( TGlobalVariables->tTabsOptions(idTabs).multitext ,2351 , iPos-1 , cast(any ptr,iPosEnd)) 'SCI_BRACEHIGHLIGHT = 2351
		
	else
		
		IupScintillaSendMessage( TGlobalVariables->tTabsOptions(idTabs).multitext ,2351 , -1 , cast(any ptr,-1))
		
	EndIf 	
	
	return IUP_DEFAULT
	
End Function

' ######################################## ACTION MULTITEXT ####################################

Function action_multitext_callback Cdecl ( ih As Ihandle Ptr, iInsert As integer, iPos As Integer , iLenght As Integer , szText As ZString Ptr) As Integer
	
	Return IUP_DEFAULT
	
End Function

' ######################################## BUTTON_CB MULTITEXT ####################################

Function button_cb_multitext_callback Cdecl ( ih As Ihandle Ptr, iButton As integer, iPressed As Integer , ix As Integer , iy As Integer , pszStatus As ZString Ptr) As Integer
	
	If iPressed = 0 Then
		
		If iButton = IUP_BUTTON3 Then
			
			menu_popup_editor_proc()
			
		ElseIf iButton = IUP_BUTTON1 Then  
			
			If iup_iscontrol(pszStatus) Then
				
				open_include_files()
				
			EndIf
			
		EndIf
		
	EndIf
	
	Return IUP_DEFAULT
	
End Function

' ######################################## CONVERT CRLF\LF MULTITEXT ####################################

Function convert_crlf_multitext_callback Cdecl ( ih As Ihandle Ptr) As Integer
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	Dim As Ihandle Ptr mt = TGlobalVariables->tTabsOptions(idtabs).multitext
	
	IupScintillaSendMessage(mt, SCI_SETEOLMODE,  SC_EOL_CRLF ,  0 )
	
	IupScintillaSendMessage(mt, SCI_CONVERTEOLS,  SC_EOL_CRLF ,  0 )   
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "EOLLBL"), "TITLE" , "EOL: WIN (CRLF)")
	
	Return IUP_DEFAULT
	
End Function

Function convert_lf_multitext_callback Cdecl ( ih As Ihandle Ptr) As Integer
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	Dim As Ihandle Ptr mt = TGlobalVariables->tTabsOptions(idtabs).multitext   
	
	IupScintillaSendMessage(mt, SCI_SETEOLMODE,  SC_EOL_LF ,  0 )
	
	IupScintillaSendMessage(mt, SCI_CONVERTEOLS,  SC_EOL_LF ,  0 ) 
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "EOLLBL"), "TITLE" , "EOL: UNIX (LF)")		  
	
	Return IUP_DEFAULT
	
End Function


' ###################### CHANGED EDITORS ###############################################

Function multitext_valuechanged_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	IupSetAttribute(ih, "ISCHANGES", "YES")
	
	return IUP_DEFAULT
	
End Function


'############################# DROPFILES ##############################################
Function dropfiles_callback Cdecl (ih As Ihandle Ptr , pszFileName As ZString Ptr) As Integer
	
	open_file_proc(pszFileName)
	
	return IUP_DEFAULT
	
End Function



'############################# Window Output INFO ##############################################

' ' Processing Click in the window output info (compilation , search)
Function buildbox_button_callback Cdecl ( ih As Ihandle ptr, button As Integer , pressed As Integer, x As Integer , y As Integer , pszStatus As ZString Ptr) As Integer
	
	processing_click_mouse_buildbox_proc( ih , button , pressed , x ,y , pszStatus )
	
	return IUP_DEFAULT
	
End Function

'List combo (compilier options)
Function list_combo_build_callback Cdecl (ih As Ihandle ptr, pszText As ZString ptr, iItem As Integer, iState As Integer) As Integer
	
	If iState = 1 Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig, "BUILD" , "current" , Str(iItem))
		
	EndIf
	
	return IUP_DEFAULT
	
End Function

' popup menu buildbox copy text from select items
Function item_popup_buildbox_copy_sel_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	copy_text_from_buildbox ( 0 )
	
	return IUP_DEFAULT
	
End Function

' popup menu buildbox copy text from all items
Function item_popup_buildbox_copy_all_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	copy_text_from_buildbox ( 1 )
	
	return IUP_DEFAULT
	
End Function

' popup menu buildbox show only errors
Function item_popup_buildbox_only_errors_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	popup_buildbox_only_errors ()
	
	return IUP_DEFAULT
	
End Function

' popup menu buildbox show only warnings
Function item_popup_buildbox_only_warnings_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	popup_buildbox_only_warnings ()
	
	return IUP_DEFAULT
	
End Function

' popup menu buildbox show warnings and errors
Function item_popup_buildbox_errors_and_warnings_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	popup_buildbox_errors_and_warnings ()
	
	return IUP_DEFAULT
	
End Function

' popup menu buildbox clear items
Function item_popup_buildbox_clear_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	IupSetfAttribute(TGlobalVariables->buildbox , "REMOVEITEM", "ALL")
	
	return IUP_DEFAULT
	
End Function



' ############################################## Timers #############################################

Function timer_activate_multitext_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	IupSetFocus(TGlobalVariables->tTabsOptions(idtabs).multitext)
	
	Static As String szPath
	
	szPath = "IUP_FB_Editor - " & _
	*IupGetAttribute(TGlobalVariables->tTabsOptions(idtabs).multitext,"FILEPATH") & _
	*IupGetAttribute(TGlobalVariables->tTabsOptions(idtabs).multitext,"FILENAME")
	
	If *IupGetAttribute(TGlobalVariables->tTabsOptions(idtabs).multitext,"FILEPATH") <> "" Then
		
		szPath = encode_path(szPath , 1 )
		
		IupSetAttribute(TGlobalVariables->dlg, "TITLE", szPath)
		
	Else
		
		IupSetAttribute(TGlobalVariables->dlg, "TITLE", "IUP_FB_Editor - New")
		
	EndIf
	
	If IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idtabs).multitext, SCI_GETEOLMODE, 0  ,  0 ) = SC_EOL_CRLF Then
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "EOLLBL"), "TITLE" , "EOL: WIN (CRLF)")
		
	Else
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "EOLLBL"), "TITLE" , "EOL: UNIX (LF)")
		
	EndIf
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "ENCLBL"), "TITLE" , _
	*IupGetAttribute(TGlobalVariables->tTabsOptions(idtabs).multitext, "CURRENTENCODING"))
	
	If IupGetInt(TGlobalVariables->tTabsOptions(idtabs).multitext, "MARGINWIDTH1") = 0 Then
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "menuviewnumbers"), "VALUE", "OFF")
		
	Else
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "menuviewnumbers"), "VALUE", "ON")
		
	EndIf
	
	If *IupGetAttribute(TGlobalVariables->tTabsOptions(idtabs).multitext, "WHITESPACEVIEW") =  "INVISIBLE" Then
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "menuwhitespaces"), "VALUE", "OFF")
		
	Else
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "menuwhitespaces"), "VALUE", "ON")
		
	EndIf
	
	If *IupGetAttribute(TGlobalVariables->tTabsOptions(idtabs).multitext, "WORDWRAP") =  "NONE" Then
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "menuwordwrap"), "VALUE", "OFF")
		
	Else
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "menuwordwrap"), "VALUE", "ON")
		
	EndIf
	
	If *IupGetAttribute(TGlobalVariables->tTabsOptions(idtabs).multitext , "OVERWRITE") = "ON" Then
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "INSLBL"), "TITLE" , "Ovr")
		
	Else
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "INSLBL"), "TITLE" , "Ins")
		
	EndIf	
	
	IupSetAttribute(TGlobalVariables->hTimer, "RUN", "NO")	
	
	return IUP_DEFAULT	
	
End Function

Function timer_update_statusbar_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	If TGlobalVariables->tTabsOptions(idTabs).multitext = 0 Then Return IUP_DEFAULT
	
	Dim As Integer iBegPos , iEndPos , iRange , iLine , iColumn  , iChanges
	
	Static As Integer iRangeb , iLineb , iColumnb , iChangesb = 1
	
	iBegPos = CInt(IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext , SCI_GETSELECTIONSTART, 0,  0))
	
	iEndPos = CInt(IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext , SCI_GETSELECTIONEND, 0 ,  0))
	
	iRange =  CInt(IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext , SCI_COUNTCHARACTERS, Cast(UInteger,iBegPos) , Cast(Any Ptr,iEndPos) ))
	
	If iRangeb <> iRange Then
		
		iRangeb = iRange
		
		Static As ZString*15 szSel 
		
		szSel = "Sel: " & iRange
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "SELLBL"), "TITLE" , szSel)
		
	EndIf  
	
	Dim As String sResultCaret = *IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext , "CARET" )
	
	Dim As Long iPosF = InStr(sResultCaret , ",")
	
	If iPosF = 0 Then return IUP_DEFAULT
	
	iLine = Val( Mid( sResultCaret  , 1 , iPosF -1 ) )
	
	iColumn = Val( Mid( sResultCaret  , iPosF + 1  ) )
	
	If iLine <> iLineb OrElse iColumn <> iColumnb Then
		
		iLineb = iLine
		
		iColumnb = iColumn
		
		IupSetfAttribute(IupGetDialogChild(TGlobalVariables->dlg, "LINELBL"), "TITLE", !"Lin %d, Col %d", iLine+1, iColumn)
		
	EndIf
	
	If *IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "ISCHANGES") = "YES" Then
		
		iChanges = 1
		
	Else
		
		iChanges = 0
		
	EndIf
	
	If iChangesb <> iChanges Then
		
		iChangesb = iChanges
		
		If iChangesb Then
			
			IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "CHANGLBL"), "TITLE", _
			*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"statuschangesyes"))
			
			IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "CHANGLBL"),"FGCOLOR" , "#FF0000")
			
		Else
			
			IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "CHANGLBL"), "TITLE", _
			*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"statuschangesno"))
			
			IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "CHANGLBL"),"FGCOLOR" , "#000000")	      
			
		EndIf
		
	EndIf
	
	return IUP_DEFAULT	
	
End Function

' ############################################# KEYS ################################################

Function k_any_multitext_callback Cdecl ( ih As Ihandle Ptr, c As integer) As Integer
	
	If c = K_INS Then
		
		If *IupGetAttribute(ih , "OVERWRITE") = "OFF" Then
			
			IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "INSLBL"), "TITLE" , "Ovr")
			
		Else
			
			IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "INSLBL"), "TITLE" , "Ins")
			
		EndIf
		
	ElseIf c = K_CR Then   
		
		TGlobalVariables->bLineAutocomplect = 1
		
	ElseIf c = K_cS Then
		
		item_save_callback(0)
		
		Return IUP_IGNORE
		
	EndIf
	
	
	return IUP_CONTINUE
	
End Function

Function k_any_dialog_callback Cdecl ( ih As Ihandle Ptr, c As integer) As Integer
	
	hotkeys_proc(c)

	Select Case c
		#Ifdef __FB_WIN32__
		Case K_cL , K_cU 
		#else
		Case K_cL , K_cU , 805371424 , K_cZ , K_cY , K_cX , K_cC , K_cV , K_cA
		#endif
		
			return IUP_IGNORE
		
	End Select
	
	return IUP_CONTINUE
	
End Function

' ############################################# TABS ################################################


Function tab_change_pos_callback Cdecl ( ih As Ihandle Ptr, new_tab As integer, old_tab As integer) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	IupSetAttribute(TGlobalVariables->hTimer, "RUN", "YES")
	
	return IUP_DEFAULT
	
End Function

' close tabs
Function tab_close_callback Cdecl ( ih As Ihandle Ptr, iPos As Integer) As Integer
	
	item_close_proc(iPos)
	
	return IUP_IGNORE
	
End Function



' ################################## ENCODIND #########################################


Function select_default_system_menu_callback Cdecl ( ih As Ihandle Ptr) As Integer
	
	select_default_system_encoding_dialog_proc ()
	
	return IUP_DEFAULT
	
End Function

Function re_open_file_as_encoding_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	re_open_file_proc(IupGetAttribute(ih, "IDMENUENC"))
	
	Return IUP_DEFAULT
	
End Function

Function set_encoding_file_for_save_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	IupSetStrAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "CURRENTENCODING", IupGetAttribute(ih, "IDMENUENC"))
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "ENCLBL"), "TITLE" , *IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "CURRENTENCODING"))
	
	Return IUP_DEFAULT
	
End Function

' Convert the editor text in the selecting encoding on fly
Function convert_document_as_encoding_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Return convert_document_as_encoding_proc(ih)
	
End Function

Function numbers_encoding_in_the_menu_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	encoding_dialog_proc ()
	
	Return IUP_DEFAULT
	
End Function

' Create\Call Popup menu "Encoding"
Function encoding_menu_popup_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	Return encoding_menu_popup_proc(ih)
	
End Function

' Processing checkboxs from dialogue "count encodings in the menu"
Function encoding_check_callback Cdecl(ih As Ihandle Ptr, state As integer) As Integer
	
	If state = 1 Then
		
		bEncodingBool(Val(*IupGetAttribute(ih, "IDCHECKBUTTONS"))) = 1
		
	Else
		
		bEncodingBool(Val(*IupGetAttribute(ih, "IDCHECKBUTTONS"))) = 0
		
	EndIf
	
	Dim As ZString*123 szCountEncodeItems 
	
	For i As Long = 0 To 121
		
		szCountEncodeItems &= bEncodingBool(i)
		
	Next
	
	IupConfigSetVariableStr(TGlobalVariables->hConfig,"CountEncodeItems","CountEncode",szCountEncodeItems)
	
	Return IUP_DEFAULT
	
End Function

' Processing radiobuttons from dialogue "system default encoding"
Function encoding_radio_check_callback Cdecl(ih As Ihandle Ptr, state As integer) As Integer
	
	If state = 1 Then
		
		TGlobalVariables->szDefaultSystemEncoding = szEncodingString(Val(*IupGetAttribute(ih, "IDCHECKBUTTONS")))
		
	EndIf
	
	IupConfigSetVariableStr(TGlobalVariables->hConfig,"SystemDefaultEncode","DefaultEncode",TGlobalVariables->szDefaultSystemEncoding)
	
	Return IUP_DEFAULT
	
End Function

' Destroy dialogs "System default encoding" OR "Count encodings in the menu"
Function encoding_check_exit_action_callback Cdecl(ih As Ihandle Ptr ) As Integer
	
	IupDestroy(ih)
	
	Return IUP_IGNORE
	
End Function


' ############################### Options ######################################

' Options menu Edit
Function item_options_edit_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	create_options_dialog()
	
	return IUP_DEFAULT
	
End Function

' Options menu Build
Function item_options_build_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If TGlobalVariables->tool_dlg = 0 Then
		
		create_options_tool_dialog(1)
		
	EndIf
	
	return IUP_DEFAULT
	
End Function

' Options menu TOOLS
Function item_options_tools_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If TGlobalVariables->tool_dlg = 0 Then
		
		create_options_tool_dialog(3)
		
	EndIf
	
	return IUP_DEFAULT
	
End Function

' Options menu HELP
Function item_options_helps_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If TGlobalVariables->tool_dlg = 0 Then
		
		create_options_tool_dialog(2)
		
	EndIf
	
	return IUP_DEFAULT
	
End Function

' Options checkbox (font style group)
Function action_checkbox_style_group_callback Cdecl (ih As Ihandle Ptr , iState As Integer) As Integer
	
	set_checkbox_style_font_group(ih , iState)
	
	return IUP_DEFAULT
	
End Function

'--------------------------- colors \theme------------------------------

' ' Processing "color" buttons for setting COLOR
Function options_select_color_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	Dim As String szColor = get_color_dlg_proc(*IupGetAttribute(ih, "BGCOLOR"))
	
	If szColor = "" Then Return IUP_DEFAULT
	
	Dim As String szNamebtn = *IupGetAttribute(ih ,"NAME")
	
	Dim As String szTheme
	
	Dim As ZString Ptr pszColTheme , pszColAlpha
	
	Dim As Long iIndex = (Val(Mid(szNamebtn,2,1))-1)*8 + Val(Mid(szNamebtn,4))
	
	TGlobalVariables->szColorbtn(iIndex) = szColor
	
	IupSetAttribute(ih, "BGCOLOR" , TGlobalVariables->szColorbtn(iIndex))
	
	szTheme = *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , "VALUE")
	
	pszColTheme = IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme"),"b" & szTheme)	
	
	For i As Long = 1 To 8
		
		Mid( *pszColTheme , (i-1)*16+1 , 7) = TGlobalVariables->szColorbtn(i)
		
		Mid( *pszColTheme , (i-1)*16+9 , 7) = TGlobalVariables->szColorbtn(i+8)
		
		Mid( *pszColTheme , (i-1)*16+129 , 7) =  TGlobalVariables->szColorbtn(i+16)
		
		Mid( *pszColTheme , (i-1)*16+137 , 7) =  TGlobalVariables->szColorbtn(i+24)			
		
	Next	
	
	Return IUP_DEFAULT
	
End Function

' Select THEME
Function options_combo_select_theme_callback Cdecl (ih As Ihandle ptr, pszText As ZString ptr, iItem As Integer, iState As integer) As Integer
	
	If iState = 1 Then
		
		get_theme_color(1)
		
	EndIf
	
	Return IUP_DEFAULT
	
End Function

Function options_add_new_theme_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	Dim As Ihandle Ptr combo = IupGetDialogChild(TGlobalVariables->hOptions, "combotheme")
	
	Dim As Ihandle Ptr txt = IupGetDialogChild(TGlobalVariables->hOptions, "txtnewtheme")
	
	Dim As Integer iCount = val(*IupGetAttribute( combo , "COUNT"))
	
	IupSetAttribute(combo , Str(iCount+1) , *IupGetAttribute(txt,"VALUE"))
	
	IupSetStrAttribute(combo , "b" & Str(iCount+1) , *IupGetAttribute(combo, ("b" & *IupGetAttribute(combo, "VALUE") )))
	
	IupSetStrAttribute(combo , "ba" & Str(iCount+1) , *IupGetAttribute(combo, ("ba" & *IupGetAttribute(combo, "VALUE") )))
	
	IupSetStrAttribute(combo , "bold" & Str(iCount+1) , *IupGetAttribute(combo, ("bold" & *IupGetAttribute(combo, "VALUE") )))
	
	IupSetStrAttribute(combo , "italic" & Str(iCount+1) , *IupGetAttribute(combo, ("italic" & *IupGetAttribute(combo, "VALUE") )))
	
	IupSetAttribute(combo, "VALUE" , Str(iCount+1))
	
	IupSetAttribute(txt, "VALUE" , "")
	
	Return IUP_DEFAULT
	
End Function

'--------------------------- path ------------------------------

Function option_btn_path_compilier_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	Dim As String sPath  = dlg_open_proc(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionpathcompilier") , _
	!"FILTER =\"*fbc.exe\", FILTERINFO=\"fbc.exe\"")
	
	If Len(sPath) Then
		
		sPath = encode_path(sPath , 1)
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txtcomppath") , "VALUE" ,  sPath)
		
	EndIf
	'
	Return IUP_DEFAULT
	
End Function

Function option_btn_path_include_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	Dim As String sPath  = dlg_opendir_proc()
	
	If Len(sPath) Then
		
		sPath = encode_path(sPath , 1)
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txtincludepath") , "VALUE" ,  sPath)
		
	EndIf
	'
	Return IUP_DEFAULT
	
End Function

Function option_btn_path_debugger_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	Dim As String sPath  = dlg_open_proc(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionpathdebug") , _
	!"FILTER =\"*.exe\", FILTERINFO=\"Debugger\"")
	
	If Len(sPath) Then
		
		sPath = encode_path(sPath , 1)
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txtdebugpath") , "VALUE" ,  sPath)
		
	EndIf
	
	Return IUP_DEFAULT
	
End Function

Function option_btn_path_helpfb_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	Dim As String sPath  = dlg_open_proc(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionpathhelpfb") , _
	!"FILTER =\"*.*\", FILTERINFO=\"Help\"")
	
	If Len(sPath) Then
		
		sPath = encode_path(sPath , 1)
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txthelpfbpath") , "VALUE" ,  sPath)
		
	EndIf
	
	Return IUP_DEFAULT
	
End Function


' --------------------- Actions with dialog Options Editor ------------------------------ 
Function option_apply_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	option_apply_proc()
	
	Return IUP_DEFAULT
	
End Function

Function option_ok_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	option_apply_proc()
	
	option_ok_proc()
	
	IupDestroy(TGlobalVariables->hOptions)
	
	Return IUP_DEFAULT
	
End Function

Function option_cancel_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	reset_options_proc()
	
	IupDestroy(TGlobalVariables->hOptions)
	
	Return IUP_DEFAULT
	
End Function

Function options_close_action_callback Cdecl (dlg As Ihandle Ptr) As Integer
	
	reset_options_proc()
	
	IupDestroy(TGlobalVariables->hOptions)
	
	Return IUP_IGNORE
	
End Function

' ----------------------------Actions with dialog TOOL------------------------
Function options_close_tool_callback Cdecl (dlg As Ihandle Ptr) As Integer
	
	options_tool_btncancel()
	
	TGlobalVariables->tool_dlg = 0
	
	Return IUP_Continue
	
End Function

Function options_tool_action_list_callback Cdecl (ih As Ihandle Ptr , pszText As ZString Ptr , iItem As Integer , iState As integer) As Integer 
	
	If iState = 1 Then
		
		options_tool_list_action(iItem)
		
	EndIf
	
	Return IUP_DEFAULT
	
End Function

Function options_tool_action_btnup_callback Cdecl (ih As Ihandle Ptr) As Integer 
	
	options_tool_btnup()
	
	Return IUP_DEFAULT
	
End Function

Function options_tool_action_btndown_callback Cdecl (ih As Ihandle Ptr) As Integer 
	
	options_tool_btndown()
	
	Return IUP_DEFAULT
	
End Function

Function options_tool_action_btnok_callback Cdecl (ih As Ihandle Ptr) As Integer 
	
	options_tool_btnok()
	
	IupDestroy(TGlobalVariables->tool_dlg)
	
	TGlobalVariables->tool_dlg = 0	
	
	Return IUP_DEFAULT
	
End Function

Function options_tool_action_btncancel_callback Cdecl (ih As Ihandle Ptr) As Integer 
	
	options_tool_btncancel()
	
	IupDestroy(TGlobalVariables->tool_dlg)
	
	TGlobalVariables->tool_dlg = 0
	
	Return IUP_DEFAULT
	
End Function

Function options_tool_action_btninsert_callback Cdecl (ih As Ihandle Ptr) As Integer 
	
	options_tool_btninsert()
	
	Return IUP_DEFAULT
	
End Function

Function options_tool_action_btndelete_callback Cdecl (ih As Ihandle Ptr) As Integer 
	
	options_tool_btndelete()
	
	Return IUP_DEFAULT
	
End Function

Function options_tool_action_btnpath_callback Cdecl (ih As Ihandle Ptr) As Integer 
	
	#Ifdef __FB_WIN32__
	
	Dim As String sPath  = dlg_open_proc("" , _
	!"FILTER =\"*.*\"")
	
	#else
	
	Dim As String sPath  = dlg_open_proc("" , _
	!"FILTER =\"**\"")	
	
	#endif
	
	If Len(sPath) Then
		
		sPath = encode_path(sPath , 1)
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->tool_dlg, "tooltxt2") , "VALUE" ,  sPath)
		
	EndIf	
	
	Return IUP_DEFAULT
	
End Function

'-------------------------------------- FONTS --------------------------------------

' Selecting a font editor
Function options_select_fontedit_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	Dim As Ihandle Ptr txt = IupGetDialogChild(TGlobalVariables->hOptions, "ftxtedit")
	
	Dim As String sFont = font_dialog ( IupGetAttribute(txt , "VALUE") )
	
	If Len(sFont) Then
		
		IupSetAttribute(txt , "VALUE" , sFont )
		
	EndIf
	
	Return IUP_DEFAULT
	
End Function

' Selecting a font window output info (compilation, search)	
Function options_select_fontwinout_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	Dim As Ihandle Ptr txt = IupGetDialogChild(TGlobalVariables->hOptions, "ftxtwinout")
	
	Dim As String sFont = font_dialog ( IupGetAttribute(txt , "VALUE") )
	
	If Len(sFont) Then
		
		IupSetAttribute(txt , "VALUE" , sFont )	
		
	EndIf	
	
	Return IUP_DEFAULT
	
End Function

' Selecting a font STATUSBAR
Function options_select_fontstatus_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	Dim As Ihandle Ptr txt = IupGetDialogChild(TGlobalVariables->hOptions, "ftxtstatus")
	
	Dim As String sFont = font_dialog ( IupGetAttribute(txt , "VALUE") )
	
	If Len(sFont) Then	
		
		IupSetAttribute(txt , "VALUE" , sFont )		
		
	EndIf	
	
	Return IUP_DEFAULT
	
End Function



