Function getword_proc() As ZString Ptr
   
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return 0
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS")) 
	
	Dim As Ihandle Ptr mt = TGlobalVariables->tTabsOptions(idTabs).multitext  
	
	Dim As Integer iPos1 , iPos2 , iCurPos
	
	Dim As zString Ptr pszBuf

	iCurPos = CInt(IupScintillaSendMessage(mt , SCI_GETCURRENTPOS , 0 , 0 ))
	
	iPos1 = CInt(IupScintillaSendMessage( mt, SCI_WORDSTARTPOSITION, iCurPos, Cast(Any Ptr,-1)))
	
	iPos2 = CInt(IupScintillaSendMessage( mt, SCI_WORDENDPOSITION, iCurPos, Cast(Any Ptr,0)))

	If iPos2 > iPos1 Then
	  
		Dim tr  As SCI_TEXTRANGE

		tr.chrg.cpMin = iPos1

		tr.chrg.cpMax = iPos2 

		pszBuf = Callocate((iPos2 - iPos1) + 2)

		tr.lpstrText = pszBuf

		IupScintillaSendMessage( mt, SCI_GETTEXTRANGE, 0, cast(Any ptr, @tr)) 

		Return pszBuf
	  
	EndIf
   
End Function

#Ifdef __FB_WIN32__
' code from library window9 , edited for 64x-bit
Enum eHelp
	HH_DISPLAY_TOPIC  = 0
	HH_DISPLAY_TOC    = 1
	HH_DISPLAY_INDEX  = 2
	HH_KEYWORD_LOOKUP = 13
	HH_HELP_CONTEXT =   15
	HH_CLOSE_ALL      = 18
End Enum

#Ifndef HH_AKLINK
Type HH_AKLINK
	cbStruct      As Long
	fReserved     As BOOLEAN
	pszKeywords   As ZString Ptr
	pszUrl        As ZString Ptr
	pszMsgText    As ZString Ptr
	pszMsgTitle   As ZString Ptr
	pszWindow     As ZString Ptr
	fIndexOnFail  As BOOLEAN
End Type
#EndIf

Type THelp
	Memdll As Any Ptr
	HtmlHelp As Function ( ByVal hwndCaller As HWND, pszFile As ZString Ptr,_
	ByVal uCommand As Long, ByVal dwData As long ptr) As HWND
	bFlag As BOOL
End Type

Dim Shared tHelp As THelp

Function OpenHelp(szPathHelp As String ,szTopic As String , iParam As Integer ) As HWND 

	If tHelp.bFlag = FALSE Then

		tHelp.bFlag = TRUE

		tHelp.Memdll=DylibLoad("hhctrl.ocx")

		If tHelp.Memdll=0 Then

			Print "Error Load hhctrl.ocx"

			Return 0

		EndIf

		tHelp.HtmlHelp=DylibSymbol(tHelp.Memdll, "HtmlHelpA")

		If tHelp.HtmlHelp = 0 Then

			Print "Error Get HtmlHelpA"

			Return 0

		EndIf

	EndIf

	Dim HHAKLINK As HH_AKLINK

	HHAKLINK.cbStruct = SizeOf(HH_AKLINK)

	HHAKLINK.pszKeywords = StrPtr(szTopic)

	HHAKLINK.fIndexOnFail = TRUE

	Select Case iparam

		Case 1

			Return Cast(HWND,tHelp.HtmlHelp(0,szPathHelp,HH_KEYWORD_LOOKUP,Cast(Long ptr,@HHAKLINK)))

		Case 2

			tHelp.HtmlHelp(0,szPathHelp,HH_DISPLAY_TOC,Cast(Long Ptr,StrPtr(szTopic)))

			Return Cast(HWND,tHelp.HtmlHelp(0,szPathHelp,HH_KEYWORD_LOOKUP,Cast(Long Ptr,@HHAKLINK)))

		Case 3

			tHelp.HtmlHelp(0,szPathHelp,HH_DISPLAY_INDEX,Cast(Long Ptr,StrPtr(szTopic)))

			Return Cast(HWND,tHelp.HtmlHelp(0,szPathHelp,HH_KEYWORD_LOOKUP,Cast(Long Ptr,@HHAKLINK)))
			
		Case Else
			
			Return Cast(HWND, tHelp.HtmlHelp(0,szPathHelp,HH_DISPLAY_TOPIC,Cast(Long Ptr,StrPtr(szTopic))))

	End Select

End Function

Sub CloseHelp() 

	If tHelp.bFlag = TRUE Then tHelp.HtmlHelp(0,0,HH_CLOSE_ALL,0)

	Sleep(50)

	If tHelp.bFlag = TRUE Then DylibFree tHelp.Memdll

End Sub

Sub processing_f1_proc()
   
   Dim As String sPath = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path","pathhelpfb")
   
   If Len(sPath) Then
      
      sPath = encode_path(sPath , 0)

      If Left(sPath , 2) = "$A" Then
         
         sPath = ExePath() & Mid( sPath , 3)
         
      EndIf
         
      Dim As ZString Ptr pszBuf = getword_proc()
      
      Dim As String sBuf

      If pszBuf  Then
         
         If Len(*pszBuf)>1 Then
         
            sBuf = trim(*pszBuf, any chr(13) & chr(10) & chr(32))
         
         EndIf
         
         DeAllocate(pszBuf)
         
         If Len(sBuf)>1 Then
         
            OpenHelp(sPath , sBuf , 2)  
         
         Else
            
            IupExecute(sPath, 0)
            
         EndIf   
         
      Else
   		
   		IupExecute(sPath, 0)
   		           
      EndIf
   
   EndIf 
   
End Sub

#Else

Sub processing_f1_proc()

   Dim As String sPath = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path","pathhelpfb")
   
   Dim As String sBrowser = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path","pathbrowser")

   If Len(sPath) AndAlso Len(sBrowser) Then

      If Left(sPath , 2) = "$A" Then
         
         sPath = ExePath() & Mid( sPath , 3)
         
      EndIf

	   sPath = replace_string_proc(sPath , " " , "\ " , , 1)  

      Dim As ZString Ptr pszBuf = getword_proc()

      Dim As String sBuf
      
      If pszBuf > 0  Then
         
         If Len(*pszBuf)>1 Then
         
            sBuf = trim(*pszBuf, any chr(13) & chr(10) & chr(32))
         
         EndIf

         DeAllocate(pszBuf)

         If Len(sBuf)>1 Then

            if left( sBuf , 1) = "#" then
            
				if lcase(sBuf) = "#include" orelse lcase(sBuf) = "#inclib" then
					
					sBuf = "KeyPg" & Ucase(mid(sBuf , 2,1)) & lcase(mid(sBuf , 3)) & ".html"
					
				else
				
					sBuf = "KeyPgPp" & lcase(mid(sBuf , 2)) & ".html"
					
				endif
				
			elseif 	left( sBuf , 1) = "$" then
			
				sBuf = "KeyPgMeta" & Ucase(mid(sBuf , 2,1)) & lcase(mid(sBuf , 3)) & ".html"
				
			else
			
				sBuf = "KeyPg" & Ucase(mid(sBuf , 1,1)) & lcase(mid(sBuf , 2)) & ".html"
            
            endif
            
            dim as Long iFindPos = instrrev(sPath , "/")
            
            sPath = mid(sPath , 1, iFindPos) & sBuf
            
            IupExecute(sBrowser, sPath )
         
         Else
            
            IupExecute(sBrowser, sPath)
            
         EndIf   
         
      Else

   		IupExecute(sBrowser, sPath)
   		           
      EndIf   

   EndIf 
   
End Sub

#EndIf

