
Sub indent_proc()
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	Dim As Integer iPosCaret = IupGetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "CARETPOS")
	
	Dim As Integer iStartPos , iEndPos , iLineBegin,iLineEnd , iColumn
	
	IupGetIntInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "SELECTIONPOS", cast(any ptr,@iStartPos), cast(any ptr,@iEndPos))
	
	IupTextConvertPosToLinCol(TGlobalVariables->tTabsOptions(idTabs).multitext, iStartPos, cast(any ptr, @iLineBegin), cast(any ptr, @iColumn))
	
	IupTextConvertPosToLinCol(TGlobalVariables->tTabsOptions(idTabs).multitext, iEndPos, cast(any ptr, @iLineEnd), cast(any ptr, @iColumn))
	
	If iLineBegin <> iLineEnd  Then
	
		For i As Long = iLineBegin To iLineEnd
			
			Dim As Integer iPos 
			
			IupTextConvertLinColToPos(TGlobalVariables->tTabsOptions(idTabs).multitext, i, 0, cast(any ptr, @iPos))
			
			IupSetAttributeId(TGlobalVariables->tTabsOptions(idTabs).multitext, "INSERT", iPos, !"\t")			
			
		Next	
		
		iColumn = 0
		
		IupTextConvertLinColToPos(TGlobalVariables->tTabsOptions(idTabs).multitext,iLineBegin, iColumn , cast(any ptr, @iStartPos))
		
		Dim As ZString Ptr pszText = IupGetAttributeId(TGlobalVariables->tTabsOptions(idTabs).multitext, "LINE",iLineEnd )
		
		iColumn = Len(*pszText)
		
		IupTextConvertLinColToPos(TGlobalVariables->tTabsOptions(idTabs).multitext,iLineEnd, iColumn , cast(any ptr, @iEndPos))
		
		IupSetStrf(TGlobalVariables->tTabsOptions(idTabs).multitext, "SELECTIONPOS", !"%d:%d", iStartPos, iEndPos)
		
	Else
		
		IupTextConvertPosToLinCol(TGlobalVariables->tTabsOptions(idTabs).multitext, iPosCaret, cast(any ptr, @iLineBegin), cast(any ptr, @iColumn))
		
		IupTextConvertLinColToPos(TGlobalVariables->tTabsOptions(idTabs).multitext, iLineBegin, 0, cast(any ptr, @iStartPos))
		
		IupSetAttributeId(TGlobalVariables->tTabsOptions(idTabs).multitext, "INSERT", iStartPos, !"\t")

		IupSetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "CARETPOS", iPosCaret+1)
	
	EndIf
	
End Sub

Sub outdent_proc()
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	Dim As Integer iPosCaret = IupGetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "CARETPOS")
	
	Dim As Integer iStartPos , iEndPos , iLineBegin,iLineEnd , iColumn
	
	IupGetIntInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "SELECTIONPOS", cast(any ptr,@iStartPos), cast(any ptr,@iEndPos))
	
	IupTextConvertPosToLinCol(TGlobalVariables->tTabsOptions(idTabs).multitext, iStartPos, cast(any ptr, @iLineBegin), cast(any ptr, @iColumn))
	
	IupTextConvertPosToLinCol(TGlobalVariables->tTabsOptions(idTabs).multitext, iEndPos, cast(any ptr, @iLineEnd), cast(any ptr, @iColumn))
	
	If iLineBegin <> iLineEnd  Then
	
		For i As Long = iLineBegin To iLineEnd
			
			Dim As Integer iPos 
			
			Dim As ZString Ptr pszText = IupGetAttributeId(TGlobalVariables->tTabsOptions(idTabs).multitext, "LINE", i )
			
			If (*pszText)[0] = 9 Then
				
				IupTextConvertLinColToPos(TGlobalVariables->tTabsOptions(idTabs).multitext, i, 0, cast(any ptr, @iPos))
				
				IupSetStrf(TGlobalVariables->tTabsOptions(idTabs).multitext, "DELETERANGE", !"%d,%d", iPos, 1)
				
			Else
				
				Dim As Long iCountSpaces
				
				For j As Long = 0 To val(*IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "TABSIZE"))-1
					
					If (*pszText)[j] = 32 Then
						
						iCountSpaces+=1
						
					Else
						
						Exit For
						
					EndIf
					
				Next
				
				If iCountSpaces > 0 Then
					
					IupTextConvertLinColToPos(TGlobalVariables->tTabsOptions(idTabs).multitext, i, 0, cast(any ptr, @iPos))
					
					IupSetStrf(TGlobalVariables->tTabsOptions(idTabs).multitext, "DELETERANGE", !"%d,%d", iPos, iCountSpaces)					
					
				EndIf
				
			EndIf		
			
		Next	
		
		iColumn = 0
		
		IupTextConvertLinColToPos(TGlobalVariables->tTabsOptions(idTabs).multitext,iLineBegin, iColumn , cast(any ptr, @iStartPos))
		
		Dim As ZString Ptr pszText = IupGetAttributeId(TGlobalVariables->tTabsOptions(idTabs).multitext, "LINE",iLineEnd )
		
		iColumn = Len(*pszText)
		
		IupTextConvertLinColToPos(TGlobalVariables->tTabsOptions(idTabs).multitext,iLineEnd, iColumn , cast(any ptr, @iEndPos))
		
		IupSetStrf(TGlobalVariables->tTabsOptions(idTabs).multitext, "SELECTIONPOS", !"%d:%d", iStartPos, iEndPos)
		
	Else
		
		IupTextConvertPosToLinCol(TGlobalVariables->tTabsOptions(idTabs).multitext, iPosCaret, cast(any ptr, @iLineEnd), cast(any ptr, @iColumn))
		
		IupTextConvertLinColToPos(TGlobalVariables->tTabsOptions(idTabs).multitext, iLineEnd, 0, cast(any ptr, @iStartPos))		
		
		
		If Asc(*IupGetAttributeId(TGlobalVariables->tTabsOptions(idTabs).multitext, "CHAR", iStartPos)) = 9 Then
			
			IupSetStrf(TGlobalVariables->tTabsOptions(idTabs).multitext, "DELETERANGE", !"%d,%d", iStartPos, 1)
			
			IupSetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "CARETPOS", iPosCaret-1)
			
		Else
				
				Dim As ZString Ptr pszText = IupGetAttributeId(TGlobalVariables->tTabsOptions(idTabs).multitext, "LINE", iLineEnd)
		
				Dim As Integer iLen = StrSpn(pszText, !" ") , iTabSize = val(*IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "TABSIZE"))
				
				If iLen > 0 Then
					
					If iLen > iTabSize Then
						
						iLen = iTabSize
						
					EndIf
					
					IupSetStrf(TGlobalVariables->tTabsOptions(idTabs).multitext, "DELETERANGE", !"%d,%d", iStartPos, iLen)
					
					IupSetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "CARETPOS", iPosCaret-iLen)	
					
				Else
					
					IupSetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "CARETPOS", iPosCaret)	
					
				EndIf
					
		EndIf
		
	EndIf
	
End Sub
