#Ifdef __FB_WIN32__
	
	#Include "windows.bi"
	
	#Include "libiconv.bi"
	
	#Inclib "iconv-2"
	
	#LibPath "."
	
	Declare Function OpenHelp(szPathHelp As String ,szTopic As String , iParam As Integer ) As HWND 

#Else

	#Include "crt/iconv.bi"
	
	#include "gtk/gtk.bi"

#EndIf

#include once "IUP/iup.bi"

#include once "IUP/iup_scintilla.bi"

#include once "IUP/iup_config.bi"

#include Once "crt.bi"

#Include Once "vbcompat.bi"

Extern "C"
declare function IupScintillaSendMessage(byval ih as Ihandle ptr, byval iMessage as ulong, byval wParam as UInteger , byval lParam as ZString Ptr) as integer Ptr
Declare Function IupExecute(As ZString Ptr , As ZString Ptr) As Integer
End Extern

#define SCFIND_WHOLEWORD &h2
#define SCFIND_MATCHCASE &h4
#define SCFIND_WORDSTART &h00100000
#define SCFIND_REGEXP &h00200000
#define SCFIND_POSIX &h00400000
#define SCI_SETSEARCHFLAGS 2198
#define SCI_SETTARGETRANGE 2686
#define SCI_SEARCHINTARGET 2197
#define SCI_SETTARGETSTART 2190
#define SCI_GETTARGETSTART 2191
#define SCI_SETTARGETEND 2192
#define SCI_REPLACESEL 2170
#Define SCI_SETSELFORE 2067
#Define SCI_SETSELBACK 2068
#Define SCI_SETCARETLINEVISIBLE 2096
#Define SCI_CONVERTEOLS 2029
#Define SC_EOL_CRLF 0
#Define SC_EOL_LF 2
#Define SCI_SETEOLMODE 2031
#Define SCI_GETSELECTIONSTART 2143
#Define SCI_GETSELECTIONEND 2145
#Define SCI_COUNTCHARACTERS 2633
#Define SCI_GETCURLINE 2027
#Define SCI_GETCURRENTPOS 2008
#define SCI_WORDSTARTPOSITION 2266
#define SCI_WORDENDPOSITION 2267
#define SCI_GETTEXTRANGE 2162
#Define SCI_STYLESETCASE = 2060
#define SCI_SETWORDCHARS 2077
#define SCI_COPY 2178
#define SCI_PASTE 2179
#define SCI_CUT 2177
#define SCI_GETEOLMODE 2030

Type SCI_CHARACTERRANGE 
   
   #Ifdef __FB_WIN32__
   '  windows 32  64-bit  4-   cpMin, cpMax 
      cpMin As Long
      
      cpMax As Long
   
   #Else
   '  Linux 64 bit ,    ,    Integer (8 ). 
      cpMin As Integer
      
      cpMax As Integer   
   
   #EndIf
   
End Type

Type SCI_TEXTRANGE  
   
   chrg      As SCI_CHARACTERRANGE
   
   lpstrText As ZString Ptr
   
End Type

Type TProcess
   
	pszFileName As ZString Ptr
	
	pszExeName As ZString Ptr
	
End Type

Type T_TabsOptions
	
	As IHandle Ptr multitext
	
End Type

Type T_GlobalVariables
	
	As Tlist Ptr t_list
	
	As IHandle Ptr dlg
	
	As IHandle Ptr find_dlg
	
	As Ihandle Ptr tool_dlg
	
	As IHandle Ptr tabs
	
	As IHandle Ptr toolbar
	
	As IHandle Ptr statusbar
	
	As IHandle Ptr buildbox
	
	As IHandle Ptr split
	
	As Ihandle Ptr hTimer 
	
	As Ihandle Ptr hTimerUpdateStatusBar
	
	As ihandle Ptr hConfig
	
	As ihandle Ptr hConfigL
	
	As ihandle Ptr hOptions
	
	As ihandle Ptr hItemTools
	
	As ihandle Ptr hItemFB
	
	As ihandle Ptr hItemAbout
	
	As Byte bFlagFindInfo
	
	As ZString*4 szLangid
	
	As ZString*40 szLangName
	
	As ZString*8 szColorbtn(1 To 32)
	
	As ZString*4 szAlphaCaret
	
	As ZString*100 szFontEditor
	
	As ZString*4 szFontEditorSize
		
	As ZString*100 szFontStatus
	
	As ZString*4 szFontStatusSize
	
	As ZString*100 szFontWinOut
	
	As ZString*4 szFontWinOutSize
		
	As Byte blangCurrent
	
	As Byte bLineAutocomplect
	
	As Byte bFlagAutoComplect
	
	As Byte bFlagFolding
	
	As ZString*21 szDefaultSystemEncoding
	
	As ZString Ptr pszKeywords0
	
	As ZString Ptr pszKeywords1
	
	As ZString Ptr pszKeywords2
	
	As ZString Ptr pszKeywords3	
	
	As T_TabsOptions tTabsOptions(100)
	
End Type

Declare Sub config_proc()

Declare Function goto_proc () As Integer

Declare Sub comment_proc()

Declare Sub uncomment_proc()

Declare Sub indent_proc()

Declare Sub outdent_proc()

Declare Sub replace_proc()

Declare Sub replace_all_proc()

Declare Sub find_replace_visibility_proc(iParam As integer)

Declare Function create_options_dialog() As iHandle Ptr

Declare Function create_options_tool_dialog(iParam As Byte) As iHandle Ptr

Declare Sub get_theme_color(iParam As Byte = 0)

Declare Function get_color_dlg_proc(szPrevColor As String ) As String

Declare Sub reset_options_proc()

Declare Sub option_apply_proc()

Declare Sub option_ok_proc()

Declare Sub options_tool_btninsert()

Declare Sub options_tool_btndelete()

Declare Sub options_tool_btncancel()

Declare Sub options_tool_btnok()

Declare Sub options_tool_btndown()

Declare Sub options_tool_btnup()

Declare Sub options_tool_list_action(As integer)

Declare Sub set_checkbox_style_font_group(ih As Ihandle Ptr , iState As Integer)

Declare Sub load_keywords_proc()

Declare Sub set_visual_params_build_info_proc(iParam As Byte = 0)

Declare Sub processing_click_mouse_buildbox_proc(ih As Ihandle ptr, button As Integer , pressed As Integer, x As Integer , y As Integer , pszStatus As ZString Ptr)

Declare Sub copy_text_from_buildbox( bParam As Byte)

Declare Sub popup_buildbox_only_errors ()

declare Sub popup_buildbox_only_warnings ()

Declare Sub popup_buildbox_errors_and_warnings ()

Declare Sub set_visual_params_statusbar_proc(iParam As Byte = 0)

Declare Function item_close_proc (idTabs As Long) As Integer

Declare Function create_find_dialog (iParamReplace As Integer ) As Ihandle Ptr

Declare Sub find_proc(iAllfind As integer)

Declare Sub child_widget_visibility_proc  (ih As Ihandle Ptr , hItemMenu As Ihandle Ptr )

Declare Sub spaces_to_tab_begin_proc()

Declare Sub spaces_to_tab_proc()

Declare Sub tab_to_spaces_begin_proc()

Declare Sub tab_to_spaces_proc()

Declare sub convert_lower_or_upper_case_proc (iParam As Integer )

Declare Sub remove_leading_spaces_proc (mt As Ihandle Ptr)

Declare Sub remove_trailing_spaces_proc (mt As Ihandle Ptr)

Declare Sub toggle_marker_proc (ih As Ihandle Ptr, iLine As Integer, iMargin As Integer)

Declare Function bookmark_next_prev(ih As Ihandle Ptr , iParamNextPrev As Integer ) As Integer

Declare Function encode_buffer_proc(szEncTo As ZString Ptr , szEncFrom As ZString Ptr , bBuf As byte Ptr, iSizeBuf As integer , ByRef iSizeReturnBytes As integer , mt As Ihandle Ptr = 0) As Byte Ptr

Declare Function dialog_message_yes_no_proc(szTitle As ZString Ptr , szMessage As ZString ptr) As Integer

Declare function encoding_menu_popup_callback cdecl (ih as Ihandle ptr) as integer 

Declare Sub select_default_system_encoding_dialog_proc()

Declare Sub set_attribute_multitext_proc(multitext As Ihandle Ptr , iTempFlag As Byte = 0) 

Declare Function convert_document_as_encoding_proc(ih As Ihandle ptr) As Integer

Declare Function encoding_menu_popup_proc (ih As Ihandle Ptr) As Integer

Declare Sub encoding_dialog_proc ()

Declare Function encode_path(sPath As String , iParamUtf As Long) As String

Declare Function font_dialog(pszPrevNameFont As ZString Ptr) As String 

Declare Function prepare_compile() As Integer

Declare Sub start_program_proc()

Declare Sub quick_run_proc() 

Declare Sub run_with_debug_proc()

Declare Sub hotkeys_proc(iKey As Integer)

Declare Sub CloseHelp()

Declare Sub processing_f1_proc()

Declare Sub menu_popup_editor_proc()

Declare Sub cursor_on_column_proc(iLine As Integer , sAdded As String)

Declare Sub autoindent_proc()

Declare Function replace_string_proc (ByVal sString As String, ByVal sSearchStr As String, ByVal sReplaceStr As String, ByVal iPosition As Integer = 1 , ByVal iSearchParam As Integer = 0 ) As String 

extern "C"

declare function IupFlatTabs (byval child as Ihandle ptr, ...) as Ihandle Ptr

End Extern

Dim Shared As T_GlobalVariables Ptr TGlobalVariables 

TGlobalVariables = New T_GlobalVariables

Dim Shared As ZString Ptr pszDimErrors(1 To 1000)

Dim Shared As Byte bEncodingBool(121)  = {1}

Dim Shared As ZString*21 szEncodingString(121) = {_
"Default System",_
"UTF-8",_
"UTF-8 BOM",_
"UTF-16",_
"UTF-16LE",_
"UTF-16BE",_
"UTF-32",_
"UTF-32LE",_
"UTF-32BE",_
"UTF-7",_
"UCS-2",_
"UCS-2BE",_
"UCS-2LE",_
"UCS-2-INTERNAL",_
"UCS-4",_
"UCS-4BE",_
"UCS-4LE",_
"UCS-4-INTERNAL",_
"ISO-2022-CN",_
"ISO-2022-CN-EXT",_
"ISO-2022-KR",_
"ISO-2022-JP",_
"ISO-2022-JP-1",_
"ISO-2022-JP-2",_
"ISO-2022-JP-3",_
"ISO-2022-JP-MS",_
"ISO-8859-1",_
"ISO-8859-2",_
"ISO-8859-3",_
"ISO-8859-4",_
"ISO-8859-5",_
"ISO-8859-6",_
"ISO-8859-7",_
"ISO-8859-8",_
"ISO-8859-9",_
"ISO-8859-10",_
"ISO-8859-11",_
"ISO-8859-12",_
"ISO-8859-13",_
"ISO-8859-14",_
"ISO-8859-15",_
"ISO-8859-16",_ 
"KOI8-R",_
"KOI8-U",_
"KOI8-RU",_
"KOI8-T",_
"CP437",_
"CP737",_
"CP775",_
"CP850",_
"CP852",_
"CP853",_
"CP855",_
"CP857",_
"CP858",_
"CP860",_
"CP861",_
"CP862",_
"CP863",_
"CP864",_
"CP865",_
"CP866",_
"CP869",_
"CP874",_
"CP932",_
"CP936",_
"CP949",_
"CP950",_
"CP1125",_
"CP1131",_
"CP1133",_
"CP1250",_
"CP1251",_
"CP1252",_
"CP1253",_
"CP1254",_
"CP1255",_
"CP1256",_
"CP1257",_
"CP1258",_
"MacRoman",_
"MacCentralEurope",_
"MacIceland",_
"MacCroatian",_
"MacRomania",_
"MacCyrillic",_
"MacUkraine",_
"MacGreek",_
"MacTurkish",_
"Macintosh",_
"MacHebrew",_
"MacArabic",_
"MacThai",_
"HZ",_
"GBK",_
"GB18030",_
"EUC-KR",_
"EUC-CN",_
"EUC-TW",_
"EUC-JP",_
"EUC-JISX0213",_
"BIG5",_
"BIG5-HKSCS",_
"BIG5-HKSCS:2004",_
"BIG5-HKSCS:2001",_
"BIG5-HKSCS:1999",_
"JOHAB",_
"ARMSCII-8",_
"SHIFT_JIS",_
"Georgian-Academy",_
"Georgian-PS",_
"PT154",_
"RK1048",_
"TIS-620",_
"MuleLao-1",_
"VISCII",_
"TCVN",_
"HP-ROMAN8",_
"NEXTSTEP",_
"Shift_JISX0213",_
"TDS565",_
"RISCOS-LATIN1"_
}


Sub init_IUP_proc()

	IupOpen(0,0)
	
	IupSetGlobal("UTF8MODE","YES")
		
	IupScintillaOpen()
	
	config_proc()

End Sub

Sub de_init_IUP_proc()
	
	IupConfigSetVariableStr(TGlobalVariables->hConfig,"DialogSize","dlgsize",IupGetAttribute(TGlobalVariables->dlg, "RASTERSIZE"))
	
	IupConfigSetVariableStr(TGlobalVariables->hConfig,"DialogSize","splitsize",IupGetAttribute(TGlobalVariables->split, "VALUE"))
	
	ChDir(ExePath)
	
	IupConfigSave(TGlobalVariables->hConfig)
	
	'IupConfigSave(TGlobalVariables->hConfigL)

	IupDestroy(TGlobalVariables->hConfig)
	
	IupDestroy(TGlobalVariables->hConfigL)
	
	DeAllocate(	TGlobalVariables->pszKeywords0 )
	
	DeAllocate(	TGlobalVariables->pszKeywords1 )
	
	DeAllocate(	TGlobalVariables->pszKeywords2 )
	
	DeAllocate(	TGlobalVariables->pszKeywords3 )

	#Ifdef __FB_WIN32__
	
	CloseHelp()
	
	#endif

End Sub
