' Create Main Menu
Sub create_main_menu_proc()
	
	Dim As IHandle Ptr main_menu , item_file , item_new , item_open , item_save , item_save_as , item_save_all ,_
	item_close , item_close_all , recent_menu , item_recent_files , item_exit , item_edit , item_undo ,_
	item_redo , item_cut , item_copy , item_paste , item_delete , item_find ,item_find_next, _
	item_find_prev , item_replace , item_goto , item_bookmarks , item_bookmarks_toggle ,_
	item_bookmarks_next , item_bookmarks_prev , item_bookmarks_clear_all , item_spaces ,_
	item_space_trim_trailing, item_space_trim_leading , item_space_trim_trailing_and_leading ,_
	item_space_to_tab_begin,item_space_to_tab , item_tab_to_space_begin , item_tab_to_space , item_convert_case ,_
	 item_convert_lower_case, item_convert_upper_case , item_autoindent ,item_select_all , item_view, item_view_zoom , item_view_zoom_plus ,_
	item_view_zoom_minus , item_view_zoom_default , item_view_word_wrap , item_view_show_white_spaces ,_
	item_view_toolbar , item_view_statusbar , item_view_line_numbers, item_build , item_compile ,_
	item_run , item_compile_and_run , item_quick_run , item_debug , item_options , item_options_item_edit ,_
	item_options_item_build ,item_options_item_tools,item_options_item_help, item_tools , item_help 
	
	' New
	item_new = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menunew") & !"\tCtrl+N", NULL)
	
	IupSetAttribute(item_new, "IMAGE", "img_new")

	IupSetCallback(item_new, "ACTION", cast(any ptr , @item_new_callback))
	
	' Open
	item_open = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuopen") & !"\tCtrl+O", NULL)
	
	IupSetAttribute(item_open, "IMAGE", "img_open")

	IupSetCallback(item_open, "ACTION", cast(any ptr , @item_open_callback))
	
	' Save
	item_save = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menusave") & !"\tCtrl+S", NULL)
	
	IupSetAttribute(item_save, "IMAGE", "img_save")

	IupSetCallback(item_save, "ACTION", cast(any ptr , @item_save_callback))			
	
	' Save As
	item_save_as = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menusaveas") & !"\tCtrl+Alt+S", NULL)

	IupSetCallback(item_save_as, "ACTION", cast(any ptr , @item_save_as_callback))	
	
	' Save All
	item_save_all = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menusaveall") & !"\tShift+Ctrl+S", NULL)
	
	IupSetAttribute(item_save_all, "IMAGE", "img_save_all")

	IupSetCallback(item_save_all, "ACTION", cast(any ptr , @item_save_all_callback))
	
	' Close
	item_close = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuclose") & !"\tF4", NULL)

	IupSetCallback(item_close, "ACTION", cast(any ptr , @item_close_callback))		
	
	' Close All
	item_close_all = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menucloseall") & !"\tCtrl+F4", NULL)

	IupSetCallback(item_close_all, "ACTION", cast(any ptr , @item_close_all_callback))
	
	' Recent files
	recent_menu = IupMenu(NULL)

	item_recent_files = IupSubmenu(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menurecent") , recent_menu)
	
	IupConfigRecentInit(TGlobalVariables->hConfig, recent_menu, @config_recent_callback, 10)

	' Exit
	item_exit = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuexit") & !"\tAlt+F4", NULL)

	IupSetCallback(item_exit, "ACTION", cast(any ptr , @item_exit_callback))	
	
	
	item_file = IupSubmenu(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"submenufile"), _
		IupMenu(item_new ,_
		item_open ,_
		item_save , _
		item_save_as , _
		item_save_all ,_
		item_close , _
		item_close_all , _
		IupSeparator(),_
		item_recent_files , _
		IupSeparator(),_
		item_exit,_
		NULL))
	
	'---------------------------		
		' Undo
	item_undo = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuundo") & !"\tCtrl+Z", NULL)
	
	IupSetAttribute(item_undo, "IMAGE", "img_undo")

	IupSetCallback(item_undo, "ACTION", cast(any ptr , @item_undo_callback))	
	
		' Redo
	item_redo = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuredo") & !"\tCtrl+Y", NULL)
	
	IupSetAttribute(item_redo, "IMAGE", "img_redo")

	IupSetCallback(item_redo, "ACTION", cast(any ptr , @item_redo_callback))
	
		' Cut
	item_cut = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menucut") & !"\tCtrl+X", NULL)
	
	IupSetAttribute(item_cut, "IMAGE", "img_cut")

	IupSetCallback(item_cut, "ACTION", cast(any ptr , @item_cut_callback))
	
		' Copy
	item_copy = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menucopy") & !"\tCtrl+C", NULL)
	
	IupSetAttribute(item_copy, "IMAGE", "img_copy")

	IupSetCallback(item_copy, "ACTION", cast(any ptr , @item_copy_callback))	
	
		' Paste
	item_paste = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menupaste") & !"\tCtrl+V", NULL)
	
	IupSetAttribute(item_paste, "IMAGE", "img_paste")

	IupSetCallback(item_paste, "ACTION", cast(any ptr , @item_paste_callback))		
				
		' Delete
	item_delete = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menudelete") & !"\tDel", NULL)
	
	IupSetAttribute(item_delete, "IMAGE", "img_delete")

	IupSetCallback(item_delete, "ACTION", cast(any ptr , @item_delete_callback))	
	
		' Find
	item_find = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menufind") & !"\tCtrl+F", NULL)
	
	IupSetAttribute(item_find, "IMAGE", "img_find")

	IupSetCallback(item_find, "ACTION", cast(any ptr , @item_find_callback))	
	
		' Find next
	item_find_next = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menufindnext") & !"\tF3", NULL)

	IupSetCallback(item_find_next, "ACTION", cast(any ptr , @item_find_next_callback))	
	
		' Find Prev
	item_find_prev = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menufindprev") & !"\tCtrl+F3", NULL)

	IupSetCallback(item_find_prev, "ACTION", cast(any ptr , @item_find_prev_callback))		
	
		' Replace
	item_replace = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menureplace") & !"\tCtrl+R", NULL)
	
	IupSetAttribute(item_replace, "IMAGE", "img_replace")

	IupSetCallback(item_replace, "ACTION", cast(any ptr , @item_replace_callback))		
	
		' Goto
	item_goto = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menugoto") & !"\tCtrl+G", NULL)

	IupSetCallback(item_goto, "ACTION", cast(any ptr , @item_goto_callback))	
	
	' Toggle bookmarks
	item_bookmarks_toggle = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menutogglebook") & !"\tShift+F8", NULL)
	
	IupSetAttribute(item_bookmarks_toggle, "IMAGE", "img_set_bookmark")

	IupSetCallback(item_bookmarks_toggle, "ACTION", cast(any ptr , @item_bookmarks_toggle_callback))	
	
	' Next bookmarks
	item_bookmarks_next = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menunextbook") & !"\tF8", NULL)
	
	IupSetAttribute(item_bookmarks_next, "IMAGE", "img_next_bookmark")

	IupSetCallback(item_bookmarks_next, "ACTION", cast(any ptr , @item_bookmarks_next_callback))		
	
	' Prev bookmarks
	item_bookmarks_prev = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuprevbook") & !"\tCtrl+F8", NULL)
	
	IupSetAttribute(item_bookmarks_prev, "IMAGE", "img_prev_bookmark")

	IupSetCallback(item_bookmarks_prev, "ACTION", cast(any ptr , @item_bookmarks_prev_callback))		
	
	' Clear All bookmarks
	item_bookmarks_clear_all = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuclearbook") & !"\tShift+Ctrl+F8", NULL)
	
	IupSetAttribute(item_bookmarks_clear_all, "IMAGE", "img_delete_bookmark")

	IupSetCallback(item_bookmarks_clear_all, "ACTION", cast(any ptr , @item_bookmarks_clear_all_callback))		
	
	'submenu bookmarks
	item_bookmarks = IupSubmenu(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"submenubook"), IupMenu(_
		item_bookmarks_toggle,_
		item_bookmarks_next ,_
		item_bookmarks_prev ,_
		item_bookmarks_clear_all,_
		 NULL))
	
	' Trim Spaces in trailing
	item_space_trim_trailing = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menutrimspaceintr"), NULL)

	IupSetCallback(item_space_trim_trailing, "ACTION", cast(any ptr , @item_space_trim_trailing_callback))
	
	' Trim Spaces in leading
	item_space_trim_leading = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menutrimspaceinle"), NULL)

	IupSetCallback(item_space_trim_leading, "ACTION", cast(any ptr , @item_space_trim_leading_callback))	
	
	' Trim Spaces in trailing and leading
	item_space_trim_trailing_and_leading = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menutrimspaceintrle"), NULL)

	IupSetCallback(item_space_trim_trailing_and_leading, "ACTION", cast(any ptr , @item_space_trim_trailing_and_leading_callback))
	
	' Spaces to Tab in Begin
	item_space_to_tab_begin = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuspacetotabbegin"), NULL)

	IupSetCallback(item_space_to_tab_begin, "ACTION", cast(any ptr , @item_space_to_tab_begin_callback))	
	
	' Spaces to Tab
	item_space_to_tab = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuspacetotab"), NULL)

	IupSetCallback(item_space_to_tab, "ACTION", cast(any ptr , @item_space_to_tab_callback))	
	
	' Tab to Spaces in Begin
	item_tab_to_space_begin = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menutabtospacebegin"), NULL)

	IupSetCallback(item_tab_to_space_begin, "ACTION", cast(any ptr , @item_tab_to_space_begin_callback))		
	
	' Tab to Spaces 
	item_tab_to_space = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menutabtospace"), NULL)

	IupSetCallback(item_tab_to_space, "ACTION", cast(any ptr , @item_tab_to_space_callback))	
	
	'submenu Spaces
	item_spaces = IupSubmenu(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"submenuoperationswithspace"), IupMenu(_
		item_space_trim_trailing,_
		item_space_trim_leading ,_
		item_space_trim_trailing_and_leading ,_
		item_space_to_tab_begin,_
		item_space_to_tab,_
		item_tab_to_space_begin,_
		item_tab_to_space,_
		 NULL))	
	
	' convert Lower Case
	item_convert_lower_case = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menulowercase") & !"\tCtrl+L", NULL)

	IupSetCallback(item_convert_lower_case, "ACTION", cast(any ptr , @item_convert_lower_case_callback))
	
	' convert Upper Case
	item_convert_upper_case = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuuppercase") & !"\tCtrl+U", NULL)

	IupSetCallback(item_convert_upper_case, "ACTION", cast(any ptr , @item_convert_upper_case_callback))
	
		
	'submenu Convert
	item_convert_case = IupSubmenu(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"submenuconvertsimvols") , IupMenu(_
		item_convert_upper_case,_
		item_convert_lower_case ,_
		 NULL))	
		 
	' AutoIndent
   item_autoindent = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuautoindent") & !"\tCtrl+Shift+F12", NULL)

	IupSetCallback(item_autoindent, "ACTION", cast(any ptr , @item_autoindent_callback))		 
	
	' Select All
   item_select_all = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuselectall") & !"\tCtrl+A", NULL)

	IupSetCallback(item_select_all, "ACTION", cast(any ptr , @item_select_all_callback))	
   
   
	item_edit = IupSubmenu(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"submenuedit"), _
		IupMenu(item_undo ,_
		item_redo ,_
		item_cut , _
		item_copy , _
		item_paste ,_
		item_delete , _
		item_find , _
		item_find_next,_
		item_find_prev , _
		item_replace,_
		item_goto,_
		item_bookmarks,_
		item_spaces,_
		item_convert_case,_
		item_autoindent,_
		item_select_all,_
		NULL))		
		
		'--------------------------------------------
		
		' zoom plus
		item_view_zoom_plus = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuzoomin") & !"\tCtrl_Num +", NULL)

		IupSetCallback(item_view_zoom_plus, "ACTION", cast(any ptr , @item_view_zoom_plus_callback))
		
		' zoom minus
		item_view_zoom_minus = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuzoomout") & !"\tCtrl_Num -", NULL)

		IupSetCallback(item_view_zoom_minus, "ACTION", cast(any ptr , @item_view_zoom_minus_callback))		
		
		' zoom default
		item_view_zoom_default = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuzoomdefault") & !"\tCtrl_Num /", NULL)

		IupSetCallback(item_view_zoom_default, "ACTION", cast(any ptr , @item_view_zoom_default_callback))			
		
		'submenu ZOOM
		item_view_zoom = IupSubmenu(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"submenuzoom"), IupMenu(_
			item_view_zoom_plus,_
			item_view_zoom_minus ,_
			item_view_zoom_default ,_
			 NULL))
			 
		
		' word wrap
		item_view_word_wrap = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuwordwrap"), NULL)

		IupSetCallback(item_view_word_wrap, "ACTION", cast(any ptr , @item_view_word_wrap_callback))	 	
		
		IupSetAttribute(item_view_word_wrap, "AUTOTOGGLE", "YES")
		
		IupSetAttribute(item_view_word_wrap, "VALUE", "OFF")
		
		IupSetAttribute(item_view_word_wrap, "NAME", "menuwordwrap")
		
		' show white spaces
		item_view_show_white_spaces = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menushowwhitespaces") , NULL)

		IupSetCallback(item_view_show_white_spaces, "ACTION", cast(any ptr , @item_view_show_white_spaces_callback))
		
		IupSetAttribute(item_view_show_white_spaces, "AUTOTOGGLE", "YES")
		
		IupSetAttribute(item_view_show_white_spaces, "VALUE", "OFF")
		
		IupSetAttribute(item_view_show_white_spaces, "NAME", "menuwhitespaces")
		
		'View toolbar
		item_view_toolbar = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuviewtoolbar"), NULL)

		IupSetCallback(item_view_toolbar, "ACTION", cast(any ptr , @item_view_toolbar_callback))
		
		IupSetAttribute(item_view_toolbar, "AUTOTOGGLE", "YES")
		
		If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"ChildParam","toolbarvisible") = "1" Then
			
			IupSetAttribute(item_view_toolbar, "VALUE", "ON")
			
		Else
			
			IupSetAttribute(item_view_toolbar, "VALUE", "OFF")
			
		EndIf
		
		'View statusbar
		item_view_statusbar = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuviewstatusbar"), NULL)

		IupSetCallback(item_view_statusbar, "ACTION", cast(any ptr , @item_view_statusbar_callback))
		
		IupSetAttribute(item_view_statusbar, "AUTOTOGGLE", "YES")	
		
		If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"ChildParam","statusbarvisible") = "1" Then
			
			IupSetAttribute(item_view_statusbar, "VALUE", "ON")
			
		Else
			
			IupSetAttribute(item_view_statusbar, "VALUE", "OFF")
			
		EndIf
		
		'View Line Numbers
		item_view_line_numbers = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuviewlinenumbers"), NULL)

		IupSetCallback(item_view_line_numbers, "ACTION", cast(any ptr , @item_view_line_numbers_callback))
		
		IupSetAttribute(item_view_line_numbers, "AUTOTOGGLE", "YES")	
		
		IupSetAttribute(item_view_line_numbers, "VALUE", "ON")
		
		IupSetAttribute(item_view_line_numbers, "NAME", "menuviewnumbers")		

		item_view = IupSubmenu(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"submenuview") , _
			IupMenu(item_view_zoom ,_
			item_view_word_wrap ,_
			item_view_show_white_spaces , _
			item_view_toolbar , _
			item_view_statusbar ,_
			item_view_line_numbers , _
			NULL))
		
		'----------------------------------------------
		
				' compile
		item_compile = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menucompile") & !"\tShift+Ctrl+F5", NULL)
		
		IupSetAttribute(item_compile, "IMAGE", "img_compile")
	
		IupSetCallback(item_compile, "ACTION", cast(any ptr , @item_compile_callback))	
		
				' Run
		item_run = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menurun") & !"\tShift+F5", NULL)
		
		IupSetAttribute(item_run, "IMAGE", "img_run")
	
		IupSetCallback(item_run, "ACTION", cast(any ptr , @item_run_callback))			
	
				' compile and run
		item_compile_and_run = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menucompileandrun") & !"\tCtrl+F5", NULL)
		
		IupSetAttribute(item_compile_and_run, "IMAGE", "img_compile_and_run")
	
		IupSetCallback(item_compile_and_run, "ACTION", cast(any ptr , @item_compile_and_run_callback))
		
				' quick run
		item_quick_run = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuquickrun") & !"\tF5", NULL)
		
		IupSetAttribute(item_quick_run, "IMAGE", "img_quick_run")
	
		IupSetCallback(item_quick_run, "ACTION", cast(any ptr , @item_quick_run_callback))
		
				' run with debugger
		item_debug = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menudebug"), NULL)
	
		IupSetCallback(item_debug, "ACTION", cast(any ptr , @item_debug_callback))			
		
		
		item_build = IupSubmenu(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"submenubuild"), _
			IupMenu(item_compile ,_
			item_run ,_
			item_compile_and_run , _
			item_quick_run , _
			item_debug ,_
			NULL))		
			
		'----------------------------------------------------	
		
			' TOOLS
		
		TGlobalVariables->hItemTools = IupMenu(0)
		
		item_tools = IupSubmenu(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"submenutools"),TGlobalVariables->hItemTools)		
		
		For i As Long = 1 To 100
			
			If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"TOOL", "n" & i) <> "" Then
				
				Dim As Ihandle Ptr hTempMenu = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfig,"TOOL", "n" & i), NULL)
				
				IupAppend(TGlobalVariables->hItemTools , hTempMenu)
				
				IupSetCallback(hTempMenu, "ACTION", cast(any ptr , @item_tools_custom_callback))
				
				IupMap(hTempMenu)
				
			Else
				
				Exit For
				
			EndIf
		
		Next			
		
		
		
		'----------------------------------------------------
		
		
		'options 
		item_options_item_edit = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionseditor"), NULL)
	
		IupSetCallback(item_options_item_edit, "ACTION", cast(any ptr , @item_options_edit_callback))	
		
		item_options_item_build = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionsbuild"), NULL)	
		
		IupSetCallback(item_options_item_build, "ACTION", cast(any ptr , @item_options_build_callback))		
		
		item_options_item_tools = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionstools"), NULL)	
		
		IupSetCallback(item_options_item_tools, "ACTION", cast(any ptr , @item_options_tools_callback))
		
		item_options_item_help = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionshelps"), NULL)	
		
		IupSetCallback(item_options_item_help, "ACTION", cast(any ptr , @item_options_helps_callback))					
		
		item_options = IupSubmenu(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"submenuoptions"), _
			IupMenu(item_options_item_edit ,item_options_item_build ,item_options_item_tools,item_options_item_help, NULL))	
			
				   
			
			   
	   '--------------------------------------------------
	   
		'help FB
		TGlobalVariables->hItemFB = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuhelpFB"), NULL)	   
	   
   	IupSetCallback(TGlobalVariables->hItemFB, "ACTION", cast(any ptr , @item_helps_custom_callback))
	   
		'help about
		TGlobalVariables->hItemAbout = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuabout"), NULL)
	
		IupSetCallback(TGlobalVariables->hItemAbout, "ACTION", cast(any ptr , @item_help_about_callback))		
		
		item_help = IupSubmenu(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"submenuhelp"), _
			IupMenu(TGlobalVariables->hItemFB ,_
			TGlobalVariables->hItemAbout,_
			NULL))			
		
		' Added help custom menu
		
		For i As Long = 1 To 100
			
			If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"HELPF",  "n" & i) <> "" Then
				
				Dim As Ihandle Ptr hTempMenu = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfig,"HELPF", "n" & i), NULL)
				
				IupInsert(IupGetParent(TGlobalVariables->hItemAbout), TGlobalVariables->hItemAbout , hTempMenu)
				
				IupSetCallback(hTempMenu, "ACTION", cast(any ptr , @item_helps_custom_callback))
				
			Else
				
				Exit For
				
			EndIf
		
		Next			
			
		'---------------------------------------------------	 	
	 	
		' main menu
	main_menu = IupMenu(item_file,item_edit,item_view,item_build,item_tools,item_options ,item_help,  NULL)
	
	IupSetHandle("MainMenu", main_menu)	
	
End Sub

Function encoding_menu_popup_proc (ih As Ihandle Ptr) As Integer

	Dim As Ihandle Ptr hDimMenuDoc(122), hDimMenuFile(122), hDimMenuFileSave(122)
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))

	Dim As Long j , k

	For i As Long = 0 To 121

		If bEncodingBool(i) Then

			Select Case szEncodingString(i)
				
				' UNICODE we cut off for this point
				Case "UTF-32LE" , "UTF-32BE" , "UTF-32" , "UCS-4LE" , "UCS-4BE", "UCS-4","UCS-4-INTERNAL","UCS-4-INTERNALEUC-CN",_
					"UTF-16LE" , "UTF-16BE" , "UTF-16" , "UCS-2LE" , "UCS-2BE", "UCS-2" , "UCS-2-INTERNAL"
				
				Case Else

				hDimMenuDoc(k) = IupItem(szEncodingString(i), NULL)
	
				IupSetCallback(hDimMenuDoc(k), "ACTION", cast(any ptr,@convert_document_as_encoding_callback))
	
				IupSetStrAttribute(hDimMenuDoc(k), "IDMENUENC", szEncodingString(i))
				
				If *IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "CURRENTENCODING") = szEncodingString(i) Then
				
					IupSetAttribute(hDimMenuDoc(k),"ACTIVE","NO")
				
				EndIf	
				
				k+=1
			
			End Select

			hDimMenuFile(j) = IupItem(szEncodingString(i), NULL)

			IupSetCallback(hDimMenuFile(j), "ACTION", cast(any ptr,@re_open_file_as_encoding_callback))

			IupSetStrAttribute(hDimMenuFile(j), "IDMENUENC", szEncodingString(i))

			hDimMenuFileSave(j) = IupItem(szEncodingString(i), NULL)

			IupSetCallback(hDimMenuFileSave(j), "ACTION", cast(any ptr,@set_encoding_file_for_save_callback))

			IupSetStrAttribute(hDimMenuFileSave(j), "IDMENUENC", szEncodingString(i))
			
			If *IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "CURRENTENCODING") = szEncodingString(i) Then
				
				IupSetAttribute(hDimMenuFileSave(j),"VALUE","ON")
				
			EndIf	

			j+=1

		EndIf

	Next

	Dim As Ihandle Ptr menu = IupMenu(IupSubmenu(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"setencforsave"),IupMenuv(@hDimMenuFileSave(0))),_
	IupSubmenu(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"convertdocenconfly"), IupMenuv(@hDimMenuDoc(0))),_
	IupSubmenu(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"reopenfileenc"), IupMenuv(@hDimMenuFile(0))),_
	IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"numberencinmenu"), "numbers"),_
	IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"setdefaultenc"), "sysdef"),_
	NULL)

	IupSetFunction("numbers", cast(any ptr , @numbers_encoding_in_the_menu_callback))

	IupSetFunction("sysdef", cast(any ptr , @select_default_system_menu_callback))

	IupPopup(menu, IUP_MOUSEPOS, IUP_MOUSEPOS)

	IupDestroy(menu)

	Return IUP_DEFAULT

End Function

Sub menu_popup_buildbox_proc()
   
   Dim As Ihandle Ptr i1,i2 ,i3,i4,i5,i6
   
   i1 = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menupopupbbcopysel") , 0)
   
   IupSetCallback(i1, "ACTION", cast(any ptr,@item_popup_buildbox_copy_sel_callback))
   
   i2 = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menupopupbbcopyall") , 0)
   
   IupSetCallback(i2, "ACTION", cast(any ptr,@item_popup_buildbox_copy_all_callback))  
   
   i3 = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menupopupbbonlyerr") , 0)
   
   IupSetCallback(i3, "ACTION", cast(any ptr,@item_popup_buildbox_only_errors_callback))
   
   i4 = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menupopupbbonlywar") , 0)
   
   IupSetCallback(i4, "ACTION", cast(any ptr,@item_popup_buildbox_only_warnings_callback))
   
   i5 = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menupopupbberrwar") , 0)
   
   IupSetCallback(i5, "ACTION", cast(any ptr,@item_popup_buildbox_errors_and_warnings_callback))
   
   i6 = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menupopupbbclear") , 0)
   
   IupSetCallback(i6, "ACTION", cast(any ptr,@item_popup_buildbox_clear_callback))      
   
   Dim As Ihandle Ptr menu = IupMenu(i1,i2,i3,i4,i5,i6, 0)
   
	IupPopup(menu, IUP_MOUSEPOS, IUP_MOUSEPOS)

	IupDestroy(menu)   
   
End Sub

' Editor popup menu
Sub menu_popup_editor_proc()
   
   Dim As Ihandle Ptr i1,i2 ,i3,i4,i5,i6,i7
   
   i1 = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menucopy") , 0)
   
	IupSetAttribute(i1, "IMAGE", "img_copy")

	IupSetCallback(i1, "ACTION", cast(any ptr , @item_copy_callback))
   
   i2 = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menupaste") , 0)
   
	IupSetAttribute(i2, "IMAGE", "img_paste")

	IupSetCallback(i2, "ACTION", cast(any ptr , @item_paste_callback))
    
   i3 = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuselectall") , 0)
   
   IupSetCallback(i3, "ACTION", cast(any ptr,@item_select_all_callback))
   
   i4 = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"toolcomment") , 0)
   
   IupSetAttribute(i4, "IMAGE", "img_comment")
   
   IupSetCallback(i4, "ACTION", cast(any ptr,@item_comment_callback()))
   
   i5 = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"tooluncomment") , 0)
   
   IupSetAttribute(i5, "IMAGE", "img_un_comment")
   
   IupSetCallback(i5, "ACTION", cast(any ptr,@item_uncomment_callback()))
   
   i6 = IupItem("WIN (CRLF)" , 0)
   
   IupSetCallback(i6, "ACTION", cast(any ptr,@convert_crlf_multitext_callback))  
   
   i7 = IupItem("UNIX (LF)" , 0)
   
   IupSetCallback(i7, "ACTION", cast(any ptr,@convert_lf_multitext_callback))        
   
   Dim As Ihandle Ptr menu = IupMenu(i1,i2,i3,IupSeparator(),i4,i5,IupSeparator(), _
   IupSubmenu(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionlineend"),_
   IupMenu(i6,i7,0)),_
    0)
   
	IupPopup(menu, IUP_MOUSEPOS, IUP_MOUSEPOS)

	IupDestroy(menu)   
   
End Sub

