Sub load_keywords_proc()
	
	Dim As Long iReturn
	
	TGlobalVariables->pszKeywords0 = Cast(ZString Ptr , read_file_proc(ExePath & "/keywords/keywords0",iReturn))
	
	TGlobalVariables->pszKeywords1 = Cast(ZString Ptr , read_file_proc(ExePath & "/keywords/keywords1",iReturn))
	
	TGlobalVariables->pszKeywords2 = Cast(ZString Ptr , read_file_proc(ExePath & "/keywords/keywords2",iReturn))
	
	TGlobalVariables->pszKeywords3 = Cast(ZString Ptr , read_file_proc(ExePath & "/keywords/keywords3",iReturn))
	
End Sub

Sub set_attribute_multitext_proc(multitext As Ihandle Ptr , iTempFlag As Byte = 0) 
	
	Dim As Integer iCodeCase
	
	Dim As Byte bFlagBold, bFlagItalic, bFlagUnderline
	
	Dim As ZString*10 szFontStyleGroupBold , szFontStyleGroupItalic
	
	get_theme_color(iTempFlag)
	
	Dim As ZString*100 szFont
	
	If iTempFlag = 0 Then
		
		szFont = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Fonts","editor")
		
	Else
		
		szFont = *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions,"ftxtedit"),"VALUE")
		
	EndIf
	
	If InStr(szFont, " Bold ") Then 
	   
	   bFlagBold = 1
	   
	   szFont = replace_string_proc(szFont , " Bold " , " " )	   
	   
	EndIf
	
	If InStr(szFont, " Italic ") Then 
	   
	   bFlagItalic = 1
	   
	   szFont = replace_string_proc(szFont , " Italic " , " " )	   
	   
	EndIf
	
	If InStr(szFont, " Underline ") Then 
	   
	   bFlagUnderline = 1
	   
	   szFont = replace_string_proc(szFont , " Underline " , " " )	   
	   
	EndIf
	
	If InStr(szFont, " Strikeout ") Then 
	   
	   szFont = replace_string_proc(szFont , " Strikeout " , " " )	   
	   
	EndIf	

	Dim As Integer iPosSpace = InStrRev(szFont , " ")
	
	TGlobalVariables->szFontEditorSize = Mid(szFont , iPosSpace , (Len(szFont) - iPosSpace)+1)
	
	TGlobalVariables->szFontEditor = RTrim(Mid(szFont , 1 , iPosSpace) , Any " ,")
	
	IupSetAttribute(multitext, "STYLEFONT32", TGlobalVariables->szFontEditor)
	
	IupSetAttribute(multitext, "STYLEFONTSIZE32", TGlobalVariables->szFontEditorSize)
	
	If bFlagBold Then
	   
	   IupSetAttribute(multitext, "STYLEBOLD32", "YES")
	   
	Else
	   
	   IupSetAttribute(multitext, "STYLEBOLD32", "NO")
	   
	EndIf
	
	If bFlagItalic Then
	   
	   IupSetAttribute(multitext, "STYLEITALIC32", "YES")
	   
	Else
	   
	   IupSetAttribute(multitext, "STYLEITALIC32", "NO")	   
	   
	EndIf	
   
	If bFlagUnderline Then
	   
	   IupSetAttribute(multitext, "STYLEUNDERLINE32", "YES")
	   
	Else
	   
	   IupSetAttribute(multitext, "STYLEUNDERLINE32", "NO")	   
	   
	EndIf		
	
	IupSetAttribute( multitext, "STYLEBGCOLOR32", TGlobalVariables->szColorbtn(1) )
	
	IupSetAttribute( multitext, "STYLEFGCOLOR32", TGlobalVariables->szColorbtn(9) )

	IupSetAttribute(multitext, "STYLECLEARALL", "Yes")
	
   
	IupSetAttribute(multitext, "STYLEBGCOLOR33", TGlobalVariables->szColorbtn(3))
	
	IupSetAttribute(multitext, "STYLEFGCOLOR33", TGlobalVariables->szColorbtn(11))		
	
	IupSetAttribute(multitext, "LEXERLANGUAGE", *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Lexer","lex"))
	
	IupSetAttribute(multitext, "USEPOPUP" , "NO")
	
	If iTempFlag = 0 Then
	
		IupSetAttribute(multitext, "TABSIZE", *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","indentsize"))
		
		If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","indent") = "TAB" Then
			
			IupSetAttribute(multitext, "USETABS", "YES")
			
		Else
			
			IupSetAttribute(multitext, "USETABS", "NO")
			
		EndIf
		
		IupSetAttribute(multitext, "INDENTATIONGUIDES", *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","indentationguides"))
		
		IupSetAttribute(multitext, "WORDWRAP", *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","wrap"))
		
		If *IupGetAttribute(multitext, "WORDWRAP") =  "NONE" Then
			
			IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "menuwordwrap"), "VALUE", "OFF")
			
		Else
			
			IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "menuwordwrap"), "VALUE", "ON")
			
		EndIf	
		
		IupSetAttribute(multitext, "WHITESPACEVIEW", *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","whitespace"))
		
		If *IupGetAttribute(multitext, "WHITESPACEVIEW") =  "INVISIBLE" Then
			
			IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "menuwhitespaces"), "VALUE", "OFF")
			
		Else
			
			IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "menuwhitespaces"), "VALUE", "ON")
			
		EndIf	
		
		If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","folding") = "YES" Then
			
         TGlobalVariables->bFlagFolding = 1
         
		Else
		   
		   TGlobalVariables->bFlagFolding = 0
			
		EndIf	
		
		If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","autocomplect") = "YES" Then
			
         TGlobalVariables->bFlagAutoComplect = 1
         
		Else
		   
		   TGlobalVariables->bFlagAutoComplect = 0
			
		EndIf	
		
   	Select Case *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Editor" , "case")
   	   
   	   Case "up"
   	      
   	      iCodeCase = 1
   	      
   	   Case "down"
   	      
   	      iCodeCase = 2
   	      
   	   Case "camel"   
   	      
   	      iCodeCase = 3
   	      
   	   Case Else   
   	      
   	      iCodeCase = 0
   	   
   	End Select	
   	
   	Dim As String sTheme = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme","0")
   	
   	szFontStyleGroupBold = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme", sTheme & "bold")
   	
   	If Len(szFontStyleGroupBold) < 9 Then
   	   
   	   szFontStyleGroupBold = "000000000"
   	   
   	   IupConfigSetVariableStr(TGlobalVariables->hConfig,"Theme", sTheme & "bold" , szFontStyleGroupBold)
   	   
   	EndIf
   	
   	szFontStyleGroupItalic = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme", sTheme & "italic")
   	
   	If Len(szFontStyleGroupItalic) < 9 Then
   	   
   	   szFontStyleGroupItalic = "000000000"
   	   
   	   IupConfigSetVariableStr(TGlobalVariables->hConfig,"Theme", sTheme & "bold" , szFontStyleGroupItalic)
   	   
   	EndIf   	
   		
	Else
		
		IupSetAttribute(multitext, "TABSIZE", *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions,"updownindent"),"VALUE"))
		
		If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions,"radiotab"),"VALUE") = "ON" Then
			
			IupSetAttribute(multitext, "USETABS", "YES")
			
		Else
			
			IupSetAttribute(multitext, "USETABS", "NO")
			
		EndIf	
		
		If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions,"checkspacesimv"),"VALUE") = "ON" Then

			IupSetAttribute(multitext, "INDENTATIONGUIDES", "REAL")
			
		Else

			IupSetAttribute(multitext, "INDENTATIONGUIDES", "NONE")
			
		EndIf	
		
		If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions,"checkwrap"),"VALUE") = "ON" Then

			IupSetAttribute(multitext, "WORDWRAP", "WORD")
			
			IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "menuwordwrap"), "VALUE", "ON")
			
		Else

			IupSetAttribute(multitext, "WORDWRAP", "NONE")
			
			IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "menuwordwrap"), "VALUE", "OFF")
			
		EndIf			
		
		If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions,"checkwhitespace"),"VALUE") = "ON" Then

			IupSetAttribute(multitext, "WHITESPACEVIEW", "VISIBLEALWAYS")
			
			IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "menuwhitespaces"), "VALUE", "ON")
			
		Else

			IupSetAttribute(multitext, "WHITESPACEVIEW", "INVISIBLE")
			
			IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "menuwhitespaces"), "VALUE", "OFF")
			
		EndIf	
		
		
   	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checkfolding") , "VALUE") = "ON" Then
   		
         TGlobalVariables->bFlagFolding = 1
         
   	Else
   	   
   	   TGlobalVariables->bFlagFolding = 0
   		
   	EndIf	
   	
   	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checkautocomplect") , "VALUE") = "ON" Then
   		
         TGlobalVariables->bFlagAutoComplect = 1
         
   	Else
   	   
   	   TGlobalVariables->bFlagAutoComplect = 0
   		
   	EndIf	
   	
   	Select Case "ON"
   	   
   	   Case *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "radioupcase") , "VALUE")
   	      
   	      iCodeCase = 1
   	      
   	   Case *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "radiodowncase") , "VALUE")
   	      
   	      iCodeCase = 2
   	      
   	   Case *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "radiocamelcase") , "VALUE")
   	      
   	      iCodeCase = 3
   	      
   	   Case Else   
   	      
   	      iCodeCase = 0
   	   
   	End Select   	
   	
      Dim As String szTheme
      
      szTheme = *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , "VALUE")
      
   	szFontStyleGroupBold = *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme"),"bold" & szTheme)
   	
   	If Len(szFontStyleGroupBold) < 9 Then szFontStyleGroupBold = "000000000"
   	
   	szFontStyleGroupItalic = *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme"),"italic" & szTheme)	   
      
      If Len(szFontStyleGroupItalic) < 9 Then szFontStyleGroupItalic = "000000000"   	
	
	EndIf

	IupSetAttribute(multitext, "EXPAND", "YES")

	IupSetCallback(multitext, "CARET_CB", Cast(Any Ptr, @multitext_caret_callback()))

	IupSetCallback(multitext, "VALUECHANGED_CB", cast(any ptr , @multitext_valuechanged_callback()))

	IupSetCallback(multitext, "MARGINCLICK_CB", Cast(Any Ptr, @marginclick_callback()))
	
	IupSetCallback(multitext, "K_ANY", Cast(Any Ptr, @k_any_multitext_callback()))
	
	IupSetCallback(multitext, "ACTION", Cast(Any Ptr, @action_multitext_callback()))
	
	IupSetCallback(multitext, "BUTTON_CB", Cast(Any Ptr, @button_cb_multitext_callback()))
   
	IupSetInt(multitext, "MARGINWIDTH0", Val(TGlobalVariables->szFontEditorSize)*3)
	
	IupSetInt(multitext, "MARGINWIDTH1", 15)

	IupSetAttribute(multitext, "MARGINTYPE1", "SYMBOL")
	
	IupSetAttribute(multitext, "MARKERDEFINE", "0=CIRCLE")

	IupSetAttribute(multitext, "MARGINSENSITIVE1", "YES")
		
	IupSetAttribute(multitext, "MARKERBGCOLOR0", TGlobalVariables->szColorbtn(12))
	
	IupSetAttribute(multitext, "MARKERFGCOLOR0", TGlobalVariables->szColorbtn(4))
	
	If TGlobalVariables->bFlagFolding = 1 Then
	
   	IupSetInt(multitext, "MARGINWIDTH2", 15)	 	
   	
   	IupSetAttribute(multitext, "PROPERTY", "fold=1")
   	
   	IupSetAttribute(multitext, "PROPERTY", "fold.compact=0")
   	
   	IupSetAttribute(multitext, "PROPERTY", "fold.comment=1")
   	
   	IupSetAttribute(multitext, "PROPERTY", "fold.preprocessor=1")
   	
   	IupSetAttribute(multitext, "MARGINTYPE2",  "SYMBOL")
   	
   	IupSetAttribute(multitext, "MARGINMASKFOLDERS2",  "Yes")
   	
   	IupSetAttribute(multitext, "MARGINSENSITIVE2", "YES")
   	
   	IupSetAttribute(multitext, "MARKERDEFINE", "FOLDER=ARROW")
   	
   	IupSetAttribute(multitext, "MARKERDEFINE", "FOLDEROPEN=ARROWDOWN")
   	
   	IupSetAttribute(multitext, "MARKERDEFINE", "FOLDEREND=EMPTY")
   	
   	IupSetAttribute(multitext, "MARKERDEFINE", "FOLDERMIDTAIL=EMPTY")
   	
   	IupSetAttribute(multitext, "MARKERDEFINE", "FOLDEROPENMID=EMPTY")
   	
   	IupSetAttribute(multitext, "MARKERDEFINE", "FOLDERSUB=EMPTY")
   	
   	IupSetAttribute(multitext, "MARKERDEFINE", "FOLDERTAIL=EMPTY")
   	
   	IupSetAttribute(multitext, "FOLDFLAGS", "LINEAFTER_CONTRACTED")
	
	endif
	
	IupSetAttribute(multitext, "MARKERBGCOLOR30",TGlobalVariables->szColorbtn(11))
	
	IupSetAttribute(multitext, "MARKERBGCOLOR29",TGlobalVariables->szColorbtn(11))
	
	IupSetAttribute(multitext, "MARKERBGCOLOR28",TGlobalVariables->szColorbtn(11))
	
	If TGlobalVariables->bFlagFolding = 1 Then
	
   	IupSetAttribute(multitext, "FOLDMARGINCOLOR", TGlobalVariables->szColorbtn(5))
   	
   	IupSetAttribute(multitext, "FOLDMARGINHICOLOR", TGlobalVariables->szColorbtn(13))
	
	EndIf
	
	Dim As integer iCol = Val("&h"& Mid(TGlobalVariables->szColorbtn(6),6,2) & Mid(TGlobalVariables->szColorbtn(6),4,2) & Mid(TGlobalVariables->szColorbtn(6),2,2))
	
	IupScintillaSendMessage( multitext, SCI_SETSELBACK, true,  cast(Any Ptr,iCol) )
	
	iCol = Val("&h"& Mid(TGlobalVariables->szColorbtn(14),6,2) & Mid(TGlobalVariables->szColorbtn(14),4,2) & Mid(TGlobalVariables->szColorbtn(14),2,2))
	
	IupScintillaSendMessage( multitext, SCI_SETSELFORE, true, cast(Any Ptr,iCol) )
			
	IupSetAttribute(multitext, "CARETLINEBACKCOLOR", TGlobalVariables->szColorbtn(7))	
	
	IupSetAttribute(multitext, "CARETLINEBACKALPHA", TGlobalVariables->szAlphaCaret)
	
	IupScintillaSendMessage( multitext, SCI_SETCARETLINEVISIBLE, true, 0 )
	
	IupSetAttribute(multitext, "CARETCOLOR", TGlobalVariables->szColorbtn(15))		
	
	IupSetAttribute(multitext, "STYLEBGCOLOR1", TGlobalVariables->szColorbtn(17))		'comment 
	
	IupSetAttribute(multitext, "STYLEFGCOLOR1", TGlobalVariables->szColorbtn(25))		'comment 
	
	IupSetAttribute(multitext, "STYLEBGCOLOR19", TGlobalVariables->szColorbtn(17))	'block comment 
	
	IupSetAttribute(multitext, "STYLEFGCOLOR19", TGlobalVariables->szColorbtn(25))	'block comment 	
	
	IupSetAttribute(multitext, "STYLEBGCOLOR2", TGlobalVariables->szColorbtn(18))		'number 
	
	IupSetAttribute(multitext, "STYLEFGCOLOR2", TGlobalVariables->szColorbtn(26))		'number
	
	IupSetAttribute(multitext, "STYLEBGCOLOR4", TGlobalVariables->szColorbtn(8))		'string
	
	IupSetAttribute(multitext, "STYLEFGCOLOR4", TGlobalVariables->szColorbtn(16))		'string 
	
	IupSetAttribute(multitext, "STYLEBGCOLOR6", TGlobalVariables->szColorbtn(19))		'operator 
	
	IupSetAttribute(multitext, "STYLEFGCOLOR6", TGlobalVariables->szColorbtn(27))		'operator	
	
	IupSetAttribute(multitext, "STYLEBGCOLOR7", TGlobalVariables->szColorbtn(20))		'identifier 
	
	IupSetAttribute(multitext, "STYLEFGCOLOR7", TGlobalVariables->szColorbtn(28))		'identifier	
	
	IupSetAttribute(multitext, "STYLEBGCOLOR3", TGlobalVariables->szColorbtn(21))		'keywords0
	
	IupSetAttribute(multitext, "STYLEFGCOLOR3", TGlobalVariables->szColorbtn(29))		'keywords0 	
	
	IupSetAttribute(multitext, "STYLEBGCOLOR10", TGlobalVariables->szColorbtn(22))		'Keywords1
	
	IupSetAttribute(multitext, "STYLEFGCOLOR10", TGlobalVariables->szColorbtn(30))		'Keywords1	
	
	IupSetAttribute(multitext, "STYLEBGCOLOR11", TGlobalVariables->szColorbtn(23))		'Keywords2
	
	IupSetAttribute(multitext, "STYLEFGCOLOR11", TGlobalVariables->szColorbtn(31))		'Keywords2	
	
	IupSetAttribute(multitext, "STYLEBGCOLOR12", TGlobalVariables->szColorbtn(24))		'Keywords3
	
	IupSetAttribute(multitext, "STYLEFGCOLOR12", TGlobalVariables->szColorbtn(32))		'Keywords3	
	
	If Mid(szFontStyleGroupBold,1,1) = "1" Then
	   
	   IupSetAttribute(multitext, "STYLEBOLD4", "YES")
	   
	Else
	   
	   IupSetAttribute(multitext, "STYLEBOLD4", "NO")
	   
	EndIf
	
	If Mid(szFontStyleGroupItalic,1,1) = "1" Then
	   
	   IupSetAttribute(multitext, "STYLEITALIC4", "YES")
	   
	Else
	   
	   IupSetAttribute(multitext, "STYLEITALIC4", "NO")
	   
	EndIf	
	
	If Mid(szFontStyleGroupBold,2,1) = "1" Then
	   
	   IupSetAttribute(multitext, "STYLEBOLD1", "YES")
	   
	   IupSetAttribute(multitext, "STYLEBOLD19", "YES")
	   
	Else
	   
	   IupSetAttribute(multitext, "STYLEBOLD1", "NO")
	   
	   IupSetAttribute(multitext, "STYLEBOLD19", "NO")
	   
	EndIf
	
	If Mid(szFontStyleGroupItalic,2,1) = "1" Then
	   
	   IupSetAttribute(multitext, "STYLEITALIC1", "YES")
	   
	   IupSetAttribute(multitext, "STYLEITALIC19", "YES")
	   
	Else
	   
	   IupSetAttribute(multitext, "STYLEITALIC1", "NO")
	   
	   IupSetAttribute(multitext, "STYLEITALIC19", "NO")
	   
	EndIf		
	
	If Mid(szFontStyleGroupBold,3,1) = "1" Then
	   
	   IupSetAttribute(multitext, "STYLEBOLD2", "YES")
	   
	Else
	   
	   IupSetAttribute(multitext, "STYLEBOLD2", "NO")
	   
	EndIf
	
	If Mid(szFontStyleGroupItalic,3,1) = "1" Then
	   
	   IupSetAttribute(multitext, "STYLEITALIC2", "YES")
	   
	Else
	   
	   IupSetAttribute(multitext, "STYLEITALIC2", "NO")
	   
	EndIf	
	
	If Mid(szFontStyleGroupBold,4,1) = "1" Then
	   
	   IupSetAttribute(multitext, "STYLEBOLD6", "YES")
	   
	Else
	   
	   IupSetAttribute(multitext, "STYLEBOLD6", "NO")
	   
	EndIf
	
	If Mid(szFontStyleGroupItalic,4,1) = "1" Then
	   
	   IupSetAttribute(multitext, "STYLEITALIC6", "YES")
	   
	Else
	   
	   IupSetAttribute(multitext, "STYLEITALIC6", "NO")
	   
	EndIf		
	
	If Mid(szFontStyleGroupBold,5,1) = "1" Then
	   
	   IupSetAttribute(multitext, "STYLEBOLD7", "YES")
	   
	Else
	   
	   IupSetAttribute(multitext, "STYLEBOLD7", "NO")
	   
	EndIf
	
	If Mid(szFontStyleGroupItalic,5,1) = "1" Then
	   
	   IupSetAttribute(multitext, "STYLEITALIC7", "YES")
	   
	Else
	   
	   IupSetAttribute(multitext, "STYLEITALIC7", "NO")
	   
	EndIf		
	
	If Mid(szFontStyleGroupBold,6,1) = "1" Then
	   
	   IupSetAttribute(multitext, "STYLEBOLD3", "YES")
	   
	Else
	   
	   IupSetAttribute(multitext, "STYLEBOLD3", "NO")
	   
	EndIf
	
	If Mid(szFontStyleGroupItalic,6,1) = "1" Then
	   
	   IupSetAttribute(multitext, "STYLEITALIC3", "YES")
	   
	Else
	   
	   IupSetAttribute(multitext, "STYLEITALIC3", "NO")
	   
	EndIf		
	
	If Mid(szFontStyleGroupBold,7,1) = "1" Then
	   
	   IupSetAttribute(multitext, "STYLEBOLD10", "YES")
	   
	Else
	   
	   IupSetAttribute(multitext, "STYLEBOLD10", "NO")
	   
	EndIf
	
	If Mid(szFontStyleGroupItalic,7,1) = "1" Then
	   
	   IupSetAttribute(multitext, "STYLEITALIC10", "YES")
	   
	Else
	   
	   IupSetAttribute(multitext, "STYLEITALIC10", "NO")
	   
	EndIf	
	
	If Mid(szFontStyleGroupBold,8,1) = "1" Then
	   
	   IupSetAttribute(multitext, "STYLEBOLD11", "YES")
	   
	Else
	   
	   IupSetAttribute(multitext, "STYLEBOLD11", "NO")
	   
	EndIf
	
	If Mid(szFontStyleGroupItalic,8,1) = "1" Then
	   
	   IupSetAttribute(multitext, "STYLEITALIC11", "YES")
	   
	Else
	   
	   IupSetAttribute(multitext, "STYLEITALIC11", "NO")
	   
	EndIf		

	If Mid(szFontStyleGroupBold,9,1) = "1" Then
	   
	   IupSetAttribute(multitext, "STYLEBOLD12", "YES")
	   
	Else
	   
	   IupSetAttribute(multitext, "STYLEBOLD12", "NO")
	   
	EndIf
	
	If Mid(szFontStyleGroupItalic,9,1) = "1" Then
	   
	   IupSetAttribute(multitext, "STYLEITALIC12", "YES")
	   
	Else
	   
	   IupSetAttribute(multitext, "STYLEITALIC12", "NO")
	   
	EndIf	
	
	IupScintillaSendMessage(multitext, 2060,  3 ,  Cast(Any Ptr ,iCodeCase) ) 
	
	IupScintillaSendMessage(multitext, 2060,  10 ,  Cast(Any Ptr ,iCodeCase) ) 
	
	IupScintillaSendMessage(multitext, 2060,  11 ,  Cast(Any Ptr ,iCodeCase) ) 
	
	IupScintillaSendMessage(multitext, 2060,  12 ,  Cast(Any Ptr ,iCodeCase) ) 	
	
	IupScintillaSendMessage(multitext, SCI_SETWORDCHARS,  0 , "_#$abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789" ) 
	
	IupSetAttribute(multitext, "KEYWORDS0" , TGlobalVariables->pszKeywords0)
	
	IupSetAttribute(multitext, "KEYWORDS1" , TGlobalVariables->pszKeywords1)
	
	IupSetAttribute(multitext, "KEYWORDS2" , TGlobalVariables->pszKeywords2)
	
	IupSetAttribute(multitext, "KEYWORDS3" , TGlobalVariables->pszKeywords3)	

		
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","viewnumbers")  = "YES"  OrElse _
		*IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions,"checknumbers"),"VALUE") = "ON" Then

		IupSetInt(multitext, "MARGINWIDTH0", Val(TGlobalVariables->szFontEditorSize)*3)
		
		IupSetInt(multitext, "MARGINWIDTH1", 15)
		
		If TGlobalVariables->bFlagFolding = 1 Then
		
		   IupSetInt(multitext, "MARGINWIDTH2", 15)
		   
		Else
		   
		   IupSetInt(multitext, "MARGINWIDTH2", 0)
		
		EndIf
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "menuviewnumbers"), "VALUE", "ON")
		
	Else

		IupSetInt(multitext, "MARGINWIDTH0", 0)
		
		IupSetInt(multitext, "MARGINWIDTH1", 0)
		
		If TGlobalVariables->bFlagFolding = 1 Then
		
		   IupSetInt(multitext, "MARGINWIDTH2", 0)
		   
		EndIf   
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "menuviewnumbers"), "VALUE", "OFF")
		
	EndIf	
	
		'IupSetAttribute(multitext, "STYLEFGCOLOR34", "255 0 0")
		
		'IupSetAttribute(multitext, "STYLEBGCOLOR34", "0 0 255")
		
		IupSetAttribute(multitext, "STYLEFGCOLOR35", "255 255 0")
		
		IupSetAttribute(multitext, "STYLEBGCOLOR35", "255 0 255")
		
		'IupScintillaSendMessage(multitext , 2351, -1, cast(any ptr,-1 ))
	
		
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Editor" , "lineends") = "WIN" Then
				
		IupScintillaSendMessage(multitext, SCI_SETEOLMODE,  SC_EOL_CRLF ,  0 )
		
		IupScintillaSendMessage(multitext, SCI_CONVERTEOLS,  SC_EOL_CRLF ,  0 )
				
	Else
				
		IupScintillaSendMessage(multitext, SCI_SETEOLMODE,  SC_EOL_LF ,  0 )
		
		IupScintillaSendMessage(multitext, SCI_CONVERTEOLS,  SC_EOL_LF ,  0 )
				
	EndIf	
	
End Sub
